<?php
require_once("auth.php3");
require_once("lib/category.php");

$PAGE_TITLE = "DKF: Kategorie";

$cat_obj = null;
$collections = null;

/*
 * Spracovani pozadavku
 */
$page = "";
switch($action) {
case 'edit':
    if (category_rights($EDIT_RIGHT))
        $page = category_edit_form($category);
    break;
case 'save':
    if (category_rights($EDIT_RIGHT))
        if (category_save($category, $_POST["title"], $_POST["description"], $_POST["colls"]))
            header("Location: category.php?category=$category");
    break;
case 'new':
    if (category_rights($ADD_RIGHT))
        $page = category_new_form();
    break;
case 'add':
    if (category_rights($ADD_RIGHT)) {
        $category = category_add_new($_POST["title"], $_POST["description"], $_POST["colls"]);
        if ($category)
            header("Location: category.php?category=$category");
    }
    break;
case 'delete':
    if (category_rights($DEL_RIGHT)) {
        $page = category_delete_form($category);
    }
    break;
case 'rm':
    if (category_rights($DEL_RIGHT)) {
        $res = true;
        if ($_POST["rm"])
            $res = category_delete($category);
        if ($res)
            header("Location: category.php");
    }
    break;
default:
    if ($category) {
        $page = category_list_collections($category);
    } else {
        $page = category_list_categories();
    }
}


/*
 * Zobrazeni stranky
 */
include("start_html.php3");

if ($error) display_error($GLOBALS["error"]);

echo $page;

include("end_html.php3");
?>
