<?php
/* $Id: change_folder.php3,v 1.17.2.9 2007/04/05 14:40:06 petr Exp $ */

/*
 * slouzi ke zmene udaju ve slozce
 */

/*
 * nastavime spravny odkaz pro vlastnosti
 */
$prop_ref = "?typ=$typ&coll=$coll";
if (isset($folder)) {
	$prop_ref .= "&folder=$folder";
	if (isset($photo))
		$prop_ref .= "&photo=$photo";
}
/*
 * tato cast je pro pripad, kdy se pridava prazdny radek
 * u nektereho pole
 */
if (isset($add_author)) {
	header("Location: insert_author.php3$prop_ref");
	return;
}
if (isset($add_subj)) {
	header("Location: insert_subject.php3$prop_ref");
	return;
}
if (isset($add_note)) {
	header("Location: insert_note.php3$prop_ref");
	return;
}
if (isset($add_cover)) {
	header("Location: insert_cover.php3$prop_ref");
	return;
}
if (isset($add_src)) {
	header("Location: insert_src.php3$prop_ref");
	return;
}
if (isset($add_med)) {
	header("Location: insert_medailonek.php$prop_ref");
	return;
}




require_once("auth.php3"); /* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("locks.php"); /* funkce pro praci se zamky */
require_once("dkf_index.php"); /* nastroje pro praci s indexovou databazi */
require_once("functions.php");
require_once("properties.php");
require_once("lib/schema.php");


/*
 * kdo nema prava musi ven
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT))
	die($NO_AUTHOR);

if ($lock = get_lock($coll, $folder, $photo)) {
	if ($lock[2] != $log_user)
		die ("objekt je zamcen nekym jinym");
} else {
	die ("objekt neni uzamcen");
}

/*
 * nastaveni promennych, nazvu stranky atd.
 */
include ("get_ed_names.php3");
if ($photo) {
	require("photo_names.php3");
	$redir = "coll=$coll&folder=$folder&photo=$photo";
	$ID=$photo;
} else if ($folder) {
	require("fold_names.php3");
	$redir = "coll=$coll&folder=$folder";
	$ID=$folder;
} else {
	require("coll_names.php3");
	$redir = "coll=$coll";
	$ID=$coll;
}
/*
 * kompilace prikazu k updatovani databaze
 */
$update_query = "update $TABLE_NAME set
	title='$title', access_category='$access', typ='$typ',
	publisher='$publisher', description='$description',
	identifier='$identifier', user_identifier='$user_identifier',
	modified=NOW(), modifier='$log_user' where id='$ID'";


/*
 * jestli doslo nekde u zakladnich veci ke zmene tak je proved
 */
if (isset($title)  || isset($publisher) || isset($typ) ||
	isset($access) || isset($description)) {
	/*
	 * je treba preindexovat databazi
	 */
	 $db_id = dkf_index_open("wd");
	 $odind_res = mysql_query("select * from $TABLE_NAME where id=$ID");
	 $odind_lin = mysql_fetch_row($odind_res);
	 /*
	  * protoze mohlo dojit ke kompletni zmene, musime prvne vse odindexovat
	  */
	 odindexuj($odind_lin[4], $TABLE_NAME, 'title', $db_custom, $ID, $db_id);
	 odindexuj($odind_lin[9], $TABLE_NAME, 'description', $db_custom, $ID, $db_id);
	 odindexuj($odind_lin[10], $TABLE_NAME, 'identifier', $db_custom, $ID, $db_id);
	 odindexuj($odind_lin[12], $TABLE_NAME, 'user_identifier', $db_custom, $ID, $db_id);

	$result = mysql_query($update_query) ||
		die("nepodailo se zmnit daje");
	 /*
	  nyni znovu naindexujeme
	 */
	 $db_custom = create_custom($TABLE_NAME, $ID);
	 naindexuj($title, $TABLE_NAME, 'title', $db_custom, $ID, $db_id);
	 naindexuj($description, $TABLE_NAME, 'description', $db_custom, $ID, $db_id);
	 naindexuj($identifier, $TABLE_NAME, 'identifier', $db_custom, $ID, $db_id);
	 naindexuj($user_identifier, $TABLE_NAME, 'user_identifier', $db_custom, $ID, $db_id);
	 dkf_index_close($db_id);
}

/*
 * pokud je nastaven medailonek, tak ho uloz
 */
if (isset($medailonek) && count($medailonek)>0 && isset($folder) && ! isset($photo)) {



	$db_id = dkf_index_open("wd");

	$db_custom = create_custom("medailonek", $folder);
    $ls_med = "select * from medailonek where id_folder='$folder'";
    $ls_res = mysql_query($ls_med);
    while ($ls_res && mysql_num_rows($ls_res)>0 && ($line = mysql_fetch_row($ls_res))) {
	    odindexuj($line[1], "medailonek", 'description', $db_custom, $folder, $db_id);
    }
    $del_med = "delete from medailonek where id_folder='$folder'";
    $result = mysql_query($del_med);
    if (!$result)
        die("nepodarilo se smazat stare medailonky");
		
		for ($i=0; $i<count($medailonek); $i++) {
		if (strlen($medailonek[$i]) > 0) {
			$ins = "insert into medailonek values($folder, '".$medailonek[$i]."')";
			$result = mysql_query($ins);
			if (!$result)
				die("nepodarilo se pridat medailonek");

            // naindexujeme medailonek
	 		$db_custom = create_custom("medailonek", $folder);
			naindexuj($medailonek[$i], "medailonek", 'description', $db_custom, $folder, $db_id);
		}
	}
	dkf_index_close($db_id);
}

/*
 * pokud je nastaven autor, tak ho uloz
 */
if (isset($author) && count($author)>0 && (isset($photo) || isset($folder))) {
		

    $author_table = "folder_author";
    $obj_id = $folder;
    if (isset($photo)) {
        $author_table = "photo_author";
        $obj_id = $photo;
    }
	/*
	 * prvne tabulku procistime
	 */
	$del_author = "delete from $author_table where id=$obj_id";
	$result = mysql_query($del_author);
	if (! $result)
		die($BAD_DEL_AUTHOR);
	/*
	 * ulozime vsechny autory
	 */
	for ($i=0; $i<count($author); $i++) {
		if (strlen($author[$i])) {
			$ins = "insert $author_table values($obj_id,
							'".$author[$i]."')";
			$result = mysql_query($ins);
			if (!$result)
				die($BAD_ADD_AUTHOR);
		}
	}
}


/*
 * pokud je nastaveno zarizeni, tak ho uloz
 */
if (isset($machine) && count($machine)>0 && isset($photo) || (isset($resolution) && count($resolution))) {
	/*
	 * prvne tabulku procistime
	 */
	$del_machine = "delete from photo_machine where id=$photo";
	$result = mysql_query($del_machine);
	if (!$result)
		die("nejde smazat machine");
	/*
	 * ulozime vsechny autory
	 */
	$i = 0;
	if ($machine[$i] !== "" || $resolution[$i] !== "") {
		$ins = "insert into photo_machine values($photo,
						'".$machine[$i]."', '".$resolution[$i]."')";
		$result = mysql_query($ins);
		if (!$result)
			die("nejde pridat machine");
	}
	if ($resolution[0] !== "") {
		$inst_query = "select * from photo_instance where id_photo='$photo'";
		$result = mysql_query($inst_query);
		while ($result && ($line = mysql_fetch_row($result))) {
			$result2 = mysql_query("select * from instance_image where id_instance='$line[1]'");
			if (! $result2)
				continue;
      $line2 = mysql_fetch_row($result2);
			$result3 = mysql_query("update image set resolution='$resolution[0]' where id='$line2[1]'");
			if (! $result3)
				die("nepodarilo se zmenit rozliseni u instanci");
		}
	}
}

/*
 * pokud je je nastavena velikost vetsi strany nahledovyho obrazku,
 * tak je potreba pregenerovat
 */
if (isset($longer_side) && isset($photo) && !is_uploaded_file($_FILES['userfile']['tmp_name'])) {
	/*
	 * kdyz uzivatel vsechno vymaze
	 */
	if ("$longer_side" == "") {
		$longer_side = 1024;
	}
	/*
	 * zjistime jak je to ted a jestli ma cenu vubec neco menit
	 */
	$inst_query = "select instance.* from photo_instance, instance where photo_instance.id_photo='$photo' and photo_instance.id_instance=instance.id and instance.num=1";
	$inst_result = mysql_query($inst_query);
	$inst_line = mysql_fetch_row($inst_result);
	$inst_result2 = mysql_query("select image.* from instance_image,image where id_instance='$inst_line[0]' and image.id=id_image");
	$inst_line2 = mysql_fetch_row($inst_result2);
	/*
	 * pokud se zmenila delsi strana
	 */
	if ((($inst_line2[3] >= $inst_line2[4]) && ($longer_side != $inst_line2[3])) || (($inst_line2[4] >= $inst_line2[3]) && ($longer_side != $inst_line2[4]))) {
		/*
		 * prvne tabulku procistime
		 */
		$del_longer_side = "delete from photo_size where id=$photo";
		$result = mysql_query($del_longer_side);
		if (!$result)
			die("nejde smazat size");
		/*
		 * ulozime novy rozmer
		 */
		$i = 0;
		if ("$longer_side" != "") {
			require_once("str_quote.php3");
			$ins = "insert into photo_size values($photo, '$longer_side')";
			$result = mysql_query($ins);
			if (!$result)
				die("nejde pridat size");
		}
		/*
		 * nastaveni predavanych promennych
		 */
		if (isset($coll))
			$c = $coll;
		else
			$c = 0;
		if (isset($folder))
			$f = $folder;
		else
			$f = 0;
		if (isset($photo))
			$p = $photo;
		else
			$p = 0;
		if (("$inst_line[4]" != "") and file_exists("img/$inst_line[4]"))
			unlink("img/$inst_line[4]");
		mysql_query("delete from instance where id=$inst_line[0]");
		mysql_query("delete from image where id=$inst_line2[0]");
		mysql_query("delete from instance_image where id_instance=$inst_line[0] and id_image=$inst_line2[0]");
		/*
		 * zjisteni jmena archivniho souboru
		 */
		$inst2_query = "select instance.* from photo_instance, instance where photo_instance.id_photo='$photo' and photo_instance.id_instance=instance.id and instance.num=0";
		$inst2_result = mysql_query($inst2_query);
		$inst2_line = mysql_fetch_row($inst2_result);
		$file = str_quote($inst2_line[4]);
		/*
		 * pregenerujeme prislusnou fotku
		 */
		exec(escapeshellcmd("$NICE_PATH -n 10 /usr/bin/nohup $PHP_PATH ext_ins_photo.php3 $file 'image/jpeg' '0' $photo '$identifier' '$c' '$f' '$p' '$longer_side' 'regenerate' '$res' > log_ins_photo.log 2>&1 &"));
	}
}



/*
 * pokud jsou nastaveny subjekty, bude lepsi je updatovat
 */
if (isset($subject) && count($subject)>0) {
	/*
	 * prvne zjistime co je vsechno treba smazat z propojovacich tabulek
	 */
	$sel = "select * from $SUBJECT_NAME where $ID_NAME=$ID";
	$result = mysql_query($sel);
	/*
	 * je treba preindexovat databazi, proto ji otevreme
	 */
	 $db_id = dkf_index_open("wd");
	 if (! $db_id)
	 	die("nelze otevrit dkf_index.db pro zapis<br>\n");
	/*
	 * a odindexujeme
	 */
	while ($result && mysql_num_rows($result) &&
			($line=mysql_fetch_row($result))) {
	    $db_custom = create_custom($SUBJECT_NAME, $line[0]);
		odindexuj($line[1], $SUBJECT_NAME, 'subject', $db_custom, $line[0], $db_id);
	}

	/*
	 * pak smazem stary
	 */
	$del_subj = "delete from $SUBJECT_NAME where $ID_NAME=$ID";
	$result = mysql_query($del_subj);
	if (!$result)
		die($BAD_DEL_SUBJ);
	/*
	 * a ulozime novy
	 */
	for ($i=0; $i<count($subject); $i++) {
		if ($subject[$i] !== "") {
			$ins = "insert into $SUBJECT_NAME values($ID,
							'".$subject[$i]."')";
			 /*
			  nyni znovu naindexujeme
			 */
	 		$db_custom = create_custom($SUBJECT_NAME, $ID);
			 naindexuj($subject[$i], $SUBJECT_NAME, 'subject', $db_custom, $ID, $db_id);

			$result = mysql_query($ins);
			if (!$result)
				die($BAD_ADD_SUBJ);
		}
	}
	dkf_index_close($db_id);
}

/*
 * pokud byla nastavena poznamka
 */
if (isset($note) && count($note)>0) {
	/*
	 * promazem
	 */
	$del = "delete from $NOTE_NAME where $ID_NAME=$ID";
	$result = mysql_query($del);
	if (!$result)
		die($BAD_DEL_NOTE);
	/* 
	 * a ulozime novy
	 */
	for ($i=0; $i<count($note); $i++) {
		if ($note[$i] !== "") {
			$ins = "insert into $NOTE_NAME values($ID,
							'".$note[$i]."')";
			$result = mysql_query($ins);
			if (!$result)
				die($BAD_ADD_NOTE);
		}
	}
}

/*
 * pokud je nastaveno neco pro coverage
 */
if ((isset($covpl) || isset($covdat)) && (count($covpl)>0) || count($covdata)>0) {
	/*
	 * prvne zjistime co mame vsechno smazat
	 */
	$sel = "select $COV_TABLE.* from
				$COV_TABLE where
				$COV_TABLE.$ID_NAME=$ID";
	$result = mysql_query($sel);
	/*
	 * je treba preindexovat databazi, proto ji otevreme
	 */
	 $db_id = dkf_index_open("wd");
	 if (! $db_id)
	 	die("nelze otevrit dkf_index.db pro zapis<br>\n");
	/*
	 * a pak to smazem
	 */
	while ($result && mysql_num_rows($result) &&
			($line=mysql_fetch_row($result))) {
		/*
		* protoze mohlo dojit ke kompletni zmene, musime prvne vse odindexovat
		*/
		$odind_res = mysql_query("select * from $COV_NAME where id=$line[1]");
		$odind_lin = mysql_fetch_row($odind_res);
	 	$db_custom = create_custom("coverage", $odind_lin[0]);
		odindexuj($odind_lin[2], "coverage", 'place', $db_custom, $odind_lin[0], $db_id);
		odindexuj($odind_lin[3], "coverage", 'date', $db_custom, $odind_lin[0], $db_id);

		$del = "delete from $COV_NAME where id=$line[1]";
		$res = mysql_query($del);
		if (!$res)
			die($BAD_DEL_NOTE);
	}
	$result = mysql_query("delete from $COV_TABLE 
					where $COV_TABLE.$ID_NAME=$ID");
	/*
	 * a pridame novy
	 */
	for ($i=0; $i<count($covpl); $i++) {
		if ($covpl[$i] !== "" || $covdat[$i] !== "") {
			$ins = "insert into $COV_NAME values(0,
							'',
							'".$covpl[$i]."',
							'".$covdat[$i]."')";
			$result = mysql_query($ins);
			if (!$result)
				die($BAD_ADD_COV);
			$result = mysql_query("select max(id) from $COV_NAME");
			$line = mysql_fetch_row($result);
			$result = mysql_query("insert into $COV_TABLE values($ID, $line[0])");
			if (! $result)
				die($BAD_ADD_COV);
			 /*
			  nyni znovu naindexujeme
			 */
	 		$db_custom = create_custom("coverage", $line[0]);
			 naindexuj($covpl[$i], "coverage", 'place', $db_custom, $line[0], $db_id);
			 naindexuj($covdat[$i], "coverage", 'date', $db_custom, $line[0], $db_id);
		}
	}
	dkf_index_close($db_id);
}
/*
 * pokud je nasteveno neco ze zdroje
 */
if ((isset($srctyp) || isset($srcdat) || isset($srccoll) || isset($srcshellf))&&
	(count($srctyp)>0)) {
	/*
	 * prvne zjistime co je vsechno treba smazat z propojovacich tabulek
	 */
	$sel = "select $SRC_TABLE.* from
				$SRC_TABLE where
				$SRC_TABLE.$ID_NAME=$ID";
	$result = mysql_query($sel);
	/*
	 * je treba preindexovat databazi, proto ji otevreme
	 */
	 $db_id = dkf_index_open("wd");
	 if (! $db_id)
	 	die("nelze otevrit dkf_index.db pro zapis<br>\n");
	/*
	 * a pak to smazem
	 */
	while ($result && mysql_num_rows($result) &&
			($line=mysql_fetch_row($result))) {
		/*
		* protoze mohlo dojit ke kompletni zmene, musime prvne vse odindexovat
		*/
		$odind_res = mysql_query("select * from $SRC_NAME where id=$line[1]");
		$odind_lin = mysql_fetch_row($odind_res);
	 	$db_custom = create_custom("source", $odind_lin[0]);
		odindexuj($odind_lin[4], "source", 'shellfref', $db_custom, $odind_lin[0], $db_id);

		$del = "delete from $SRC_NAME where id=$line[1]";
		$res = mysql_query($del);
		if (!$res)
			die($BAD_DEL_SRC);
	}
	$result = mysql_query("delete from $SRC_TABLE 
					where $SRC_TABLE.$ID_NAME=$ID");
	/*
	 * a naplnime cerstvymi udaji
	 */
	for ($i=0; $i<count($srctyp); $i++) {
		if ($srctyp[$i] !== "" || $srcdat[$i] !== "" ||
			$srccoll[$i] !== "" || $srcshellf[$i] !== "") {
			$ins = "insert into $SRC_NAME values(0,
							'".$srctyp[$i]."',
							'".$srcdat[$i]."',
							'".$srccoll[$i]."',
							'".$srcshellf[$i]."')";
			$result = mysql_query($ins);
			if (!$result) die($BAD_ADD_SRC);
			$result = mysql_query("select max(id) from $SRC_NAME");
			$line = mysql_fetch_row($result);
			$result = mysql_query("insert into $SRC_TABLE values($ID, $line[0])");
			if (! $result)
				die($BAD_ADD_SRC);
			 /*
			  nyni znovu naindexujeme
			 */
	 		$db_custom = create_custom("source", $line[0]);
			 naindexuj($srcshellf[$i], "source", 'shellfref', $db_custom, $line[0], $db_id);
		}
	}
	dkf_index_close($db_id);
}

// nacteme vlastnosti kolekce
$coll_prop = get_properties($coll);
$schema = NULL;
if ($coll_prop->id_schema)
    $schema = new Schema($coll_prop->id_schema);

if (isset($meta)) {

    $table_name = table_name($coll, $folder, $photo);
    $table_id = table_id($coll, $folder, $photo);
    $query = "DELETE FROM metadata WHERE table_name='$table_name' AND table_id='$table_id'";
    mysql_query($query);
    foreach($_POST['meta'] as $name => $meta) {
        foreach($meta as $lang => $values) {
            $prefix = $schema->getMeta($name, $lang, 'prefix');
            foreach($values as $value) {
                if ($value == '') continue;
                $query = "INSERT INTO metadata (name, lang, table_name, table_id, value, prefix) VALUES ('$name', '$lang', '$table_name', '$table_id', '$value', '$prefix')";
                $result = mysql_query($query);
            }
        }
    }
}

/*
 * v pripade, ze se jedna o fotku a je posilan novy obrazek
 * tak nastavime hezci promenne
 */
$userfile = $_FILES['userfile']['tmp_name'];
$userfile_name = $_FILES['userfile']['name'];
$userfile_size = $_FILES['userfile']['size'];
$userfile_type = $_FILES['userfile']['type'];

$ufile = $userfile;

/*
 * pokud byl poslan soubor
 */
if (is_uploaded_file($userfile) && $photo) {
	/*
	 * zjistime si informace o existujicich instancich k objektu
	 */
	//echo "--$alternativni--<br />";
	$sel = "select $INST_TABLE.* from
				$INST_TABLE where
				$INST_TABLE.$ID_NAME=$ID";
	//echo "$sel<br />";
	$result = mysql_query($sel);
  $arch_id = 0;
	while ($result && mysql_num_rows($result) &&
			($line=mysql_fetch_row($result))) {
        /* zjistime info o instanci a archivni preskocime */
		$inst_res = mysql_query("select * from instance where
					id='$line[1]'");
		//echo "select * from instance where id='$line[1]'<br />";
		$inst_line = mysql_fetch_row($inst_res);
    if (($inst_line[1] == '0' && "$alternativni" == "true") ||
    	($inst_line[1] == '4' && "$alternativni" == "false")) {
      	$arch_id = $inst_line[0];
        continue;
    }

		/*
		 * zjistime si jake obrazky k te instanci patri
		 */
		$sel2 = "select * from instance_image where
				id_instance=$line[1]";
		//echo "$sel2<br />";
		$res2 = mysql_query($sel2);
		/*
		 * smaznem obrazky
		 */
		while ($res2 && mysql_num_rows($res2) &&
				($line2=mysql_fetch_row($res2))) {
			$del2 = "delete from image where id=$line2[1]";
			//echo "$del2<br />";
			$res3 = mysql_query($del2);
			if (!$res3)
				die("nejde smazat image");
		}
		/*
		 * smaznem propojeni
		 */
		$res2 = mysql_query("delete from instance_image where
					id_instance=$line[1]");
		//echo "delete from instance_image where id_instance=$line[1]<br />";
		/*
		 * zjistime si jmeno souboru a smazem ho
		 */
		$res = mysql_query("select file_name from $INST_NAME where
					id='$line[1]'");
		//echo "select file_name from $INST_NAME where id='$line[1]'<br />";
		$line2 = mysql_fetch_row($res);
		if (("$line2[0]" != "") && file_exists("img/$line2[0]"))
			unlink("img/$line2[0]");
		/*
		 * konecne smazem i instanci
		 */
		$del = "delete from $INST_NAME where id=$line[1]";
		//echo "$del<br />";
		$res = mysql_query($del);
		if (!$res)
			die($BAD_DEL_NOTE);
	}
	/*
	 * odvazem z propj tabulek
	 */

   $query = "delete from $INST_TABLE where $INST_TABLE.$ID_NAME=$ID and $INST_TABLE.id_instance!='$arch_id'";
	//echo "$query<br />";
	$result = mysql_query($query);
	    				
	$folder_line[0] = $photo;

	/*
	 * vygenerujem nahledy
	 */
	$res = $resolution[0];

	/*
	 * upgradujeme delsi stranu nahl fotografie
	 */
	$result = mysql_query("delete from photo_size where id=$photo");
	$ins = "insert into photo_size values($photo, '$longer_side')";
	//echo "$ins<br />";
	$result = mysql_query($ins);
	if (!$result)
		die("nejde pridat size");

	/*
	 * pokud neni nastavena delsi strana delsi nahledove kopie, tak ji
	 * nastavime na default
	 */
	if (! isset($longer_side) || ("$longer_side" == ""))
		$longer_side = 1024;



	include("insert_photo2.php3");
}

/*
 * preposleme na editaci
 */
if ("$save_and_unlock" != "") {
    header("Location: list_folders.php3?$redir&lock=0");
} else {
    header("Location: edit_folder.php3?$redir");
}
?>
