<?php
/* $Id: del_folder.php3,v 1.12.2.1 2006/04/06 16:39:08 petr Exp $ */

/*
 * soubor zajistuje smazani slozky a vsech veci, co k tomu nalezi
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("dkf_index.php");

/*
 * overime jestli muze uzivatel skutecne mazat
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $DEL_RIGHT))
	die($NO_AUTHOR);

/*
 * funkce maze obecny objekt
 * id -- id objektu
 * table -- nazev tabulky z ktere mazat
 * up_table -- nzev nadrazene tabulky
 * up_id -- id v nadrazene tabulce
 * id_name -- jmeno sloupce s id v prop. tab.
 * subject_name -- nazev tabulky se sujektem
 * note_name -- nazev tabulky s poznamkou
 * cov_table -- analogicky
 * src_table -- analogicky
 *   ...
 * grp_rights_name -- analogicky
 */
function drop_folder($id, $table, $up_table, $up_id, $id_name, $subject_name, $note_name, $cov_table, $src_table, $usr_rights_name, $grp_rights_name) 
{
	global $BAD_DEL_SUBJ, $BAD_DEL_NOTE, $BAD_DEL_SRC;

	/*
	 * odindexovani
	 */
	 $result = mysql_query("select * from $table where id=$id");
	 $odindex_line = mysql_fetch_row($result);
	 $db_id = dkf_index_open("wd");
	 if (! $db_id)
	 	die ("nedari se navazat spojeni s indexovou databazi");
	 $db_custom = create_custom($table, $id);

	 odindexuj($odindex_line[4], $table, 'title', $db_custom, $id, $db_id);
	 odindexuj($odindex_line[9], $table, 'description', $db_custom, $id, $db_id);
	 odindexuj($odindex_line[10], $table, 'identifier', $db_custom, $id, $db_id);
	 odindexuj($odindex_line[12], $table, 'user_identifier', $db_custom, $id, $db_id);



	/*
	 * smazani nastaveni kolekce
	 */
	if ("$table" == "collections") {
		$result = mysql_query("delete from collection_properties where id_collection='$id'");
		if (!$result)
			die("Nepodarilo se smazat vlastnosti kolekce");
	}
	
    /*
     * odindexovani vsech subjektu
     */
    $query = "select * from $subject_name where $id_name=$id";
	$result = mysql_query($query);
	if (! $result)
		die("del_folder: nepodarilo se ziskat info o subjektech pro $id");
	if ($db_id == FALSE)
		die("del_folder: nelze odindexovat subjekty");
	$custom = create_custom($subject_name, $id);
	while ($line = mysql_fetch_row($result)){
	    odindexuj($line[1], $subject_name, 'subject', $custom, $id, $db_id);
	}
    /* smazani vsech subjektu */
	$del_subj = "delete from $subject_name where $id_name=$id";
	$result = mysql_query($del_subj);
	if (!$result)
		die($BAD_DEL_SUBJ);

	/*
	 * smazani vsech poznamek
	 */
	$del = "delete from $note_name where $id_name=$id";
	$result = mysql_query($del);
	if (!$result)
		die($BAD_DEL_NOTE);

	/*
	 * smazani vsech ,,coverage``
	 */
	$sel = "select * from $cov_table where $id_name=$id";
	$result = mysql_query($sel);
	while ($result && mysql_num_rows($result) &&
			($line=mysql_fetch_row($result))) {
		$res = mysql_query("select * from coverage where id=$line[1]");
		$odind_lin = mysql_fetch_row($res);
	 	$db_custom = create_custom('coverage', $line[1]);
	 	odindexuj($odind_lin[2], 'coverage', 'place', $db_custom, $line[1], $db_id);
	 	odindexuj($odind_lin[3], 'coverage', 'date', $db_custom, $line[1], $db_id);
		$del = "delete from coverage where id=$line[1]";
		$res = mysql_query($del);
		if (!$res)
			die($BAD_DEL_NOTE);
	}
	/*
	 * smazani z propojovaci tabulky
	 */
	$result = mysql_query("delete from $cov_table where $id_name=$id");

	/*
	 * smazani zdroju
	 */
	$sel = "select * from $src_table where $id_name=$id";
	$result = mysql_query($sel);
	while ($result && mysql_num_rows($result) &&
			($line=mysql_fetch_row($result))) {
		$res = mysql_query("select * from source where id=$line[1]");
		$odind_lin = mysql_fetch_row($res);
	 	$db_custom = create_custom('source', $line[1]);
	 	odindexuj($odind_lin[4], 'source', 'shellfref', $db_custom, $line[1], $db_id);
		$del = "delete from source where id=$line[1]";
		$res = mysql_query($del);
		if (!$res)
			die($BAD_DEL_SRC);
	}
	/*
	 * vyjmuti z propojovaci tabulky
	 */
	$result = mysql_query("delete from $src_table where $id_name=$id");

	/*
	 * odstraneni samotneho objektu
	 */
	$result = mysql_query("delete from $table where id=$id");
	if ("$up_table" != "" && "$up_id" != "")
		$result = mysql_query("delete from $up_table where $up_id=$id");

	/*
	 * odstraneni zaznamu z tabulky prav
	 */
	$result = mysql_query("delete from $usr_rights_name where $id_name=$id");
	$result = mysql_query("delete from $grp_rights_name where $id_name=$id");

	/*
	 * nastavime typ tabulky jehoz zamky chceme smazat a smazem
	 */
	$typ = ($table == "photos") ? 3 : (($table == "folders") ? 2 : 1);
	$result = mysql_query("delete from zamky where id_object=$id and typ=$typ");
    /* jeste pouzijeme typ pro znacky */
    $result = mysql_query("delete from marks where id_object=$id and typ=$typ");

	 dkf_index_close($db_id);
}

/*
 * zajistuje korektni smazani fotky s vyuzitim drop_folder()
 */
function del_photo($id) {
	/*
	 * vytvori seznam vsech instanci
	 */
	$sel = "select photo_instance.* from
				photo_instance where
				photo_instance.id_photo=$id";
	$result = mysql_query($sel);
	/*
	 * a vsechny je smaze
	 */
	while ($result && mysql_num_rows($result)>0 &&
			($line=mysql_fetch_row($result))) {
		/*
		 * ziskani obrazku k instanci
		 */
		$sel2 = "select * from instance_image where
				id_instance=$line[1]";
		$res2 = mysql_query($sel2);
		/*
		 * smazani obrazku z instance
		 */
		while ($res2 && mysql_num_rows($res2)>0 &&
				($line2=mysql_fetch_row($res2))) {
			$del2 = "delete from image where id=$line2[1]";
			#echo "$del2\n";
			$res3 = mysql_query($del2);
			if (!$res3)
				die("nejde smazat image");
		}
		$res2 = mysql_query("delete from instance_image where
					id_instance=$line[1]");
		/*
		 * zjistime si jmeno souboru, kde je obrazek ulozeny
		 */
		$res = mysql_query("select file_name from instance where
					id='$line[1]'");
		$line2 = mysql_fetch_row($res);
		/*
		 * pokud tam ten soubor byl poslan tak ho smaz
		 */
		if (("$line2[0]" != "") && file_exists("img/$line2[0]"))
			unlink("img/$line2[0]");
		/*
		 * smazani prav k instanci
		 */
		$del = "delete from user_instance_rights where id_instance=$line[1]";
		$res = mysql_query($del);
		if (! $res)
			die("nelze odstranit prava uzivatelu na instanci $line[1]");
		$del = "delete from group_instance_rights where id_instance=$line[1]";
		$res = mysql_query($del);
		if (! $res)
			die("nelze odstrantit prava skupin na instanci $line[1]");
		$del = "delete from instance where id=$line[1]";
		$res = mysql_query($del);
		if (!$res)
			die("nelze odstranit instanci");
	}
	/*
	 * vyjmuti z propojovaci tabulky
	 */
	$result = mysql_query("delete from photo_instance
					where photo_instance.id_photo=$id");
	/*
	 * smazani specialitky autor fotografie
	 */
	$result = mysql_query("delete from photo_author where id=$id");

    /*
     * smazani specialitky photo_size
     */
    $result = mysql_query("delete from photo_size where id=$id");
    
    /*
     * smazani specialitky photo_machine
     */
    $result = mysql_query("delete from photo_machine where id=$id");

	/*
	 * odstraneni slozky
	 */
	drop_folder($id, "photos", "folder_photo", "id_photo", "id_photo", "photo_subject",
		    "photo_note", "coverage_photo", "photo_source", "user_photo_rights", "group_photo_rights");
}

/*
 * korektni smazani slozky s vyuzitim drop_folder()
 */
function del_folder($id)
{
	/*
	 * seznam fotek ve slozce
	 */
	$sel = "select * from folder_photo where id_folder=$id";
	$result = mysql_query($sel);
	/*
	 * vsechny je smaz
	 */
	while ($result && mysql_num_rows($result)>0 &&
			($line=mysql_fetch_row($result))) {
		del_photo($line[1]);
	}
	/*
	 * odstraneni z propojovaci tabulky
	 */
	$result = mysql_query("delete from folder_photo where id_folder=$id");
	/*
	 * odstraneny slozky
	 */

    /* odindexovani vsech medailonku */
	$db_id = dkf_index_open("wd");
	if (! $db_id)
		die ("nedari se navazat spojeni s indexovou databazi");
   	$sel = "select * from medailonek where id_folder=$id";
    $result = mysql_query($sel);
   	while ($result && mysql_num_rows($result) &&
    		($line=mysql_fetch_row($result))) {
     	$db_custom = create_custom('medailonek', $id);
 	    odindexuj($line[1], 'medailonek', 'description', $db_custom, $id, $db_id);
   	}
	dkf_index_close($db_id);

	/* smazani vsech medailonku */
   	$del = "delete from medailonek where id_folder=$id";
    $res = mysql_query($del);
 	if (!$res)
    	die('nepodarilo se smazat medailonky');

    /* smazani autoru */
	$result = mysql_query("delete from folder_author where id=$id");

    /* a smazem samotnou slozku */
	drop_folder($id, "folders", "collection_folder", "id_folder", "id_folder", "folder_subject",
		    "folder_note", "coverage_folder", "folder_source", "user_folder_rights", "group_folder_rights");
}


/*
 * korektni odstraneni kolekce
 */
function del_coll($id)
{
	/*
	 * vytvorime seznam slozek
	 */
	$sel = "select * from collection_folder where id_collection=$id";
	$result = mysql_query($sel);

	/*
	 * a smazem je
	 */
	while ($result && mysql_num_rows($result)>0 &&
			($line=mysql_fetch_row($result))) {
		del_folder($line[1]);
	}
	/*
	 * odstreneni z propoj. tab.
	 */
	$result = mysql_query("delete from collection_folder where id_collection=$id");
	/*
	 * odstraneni kolekce
	 */
	drop_folder($id, "collections", "", "", "id_collection", "collection_subject",
		    "collection_note", "coverage_collection", "collection_source", "user_collection_rights", "group_collection_rights");
}

/*
 * zeptame se uzivatele jestli si je opravdu jist smazanim objektu
 */
if ("$force" != "1") {
	require_once("start_html.php3");
	echo "Opravdu si pejete objekt smazat?<br>\n";
	echo "(Pokud bude objekt obsahovat njak vnoen objekty, tak budou tyto objekty smazny tak.)<br><br>\n";

	/* ano, chce smazat */
	echo "<form action=\"edit_folder.php3\" method=\"get\">\n";
	echo "\t\t<input type=\"hidden\" name=\"coll\" value=$coll>\n";
	if ($folder)
		echo "\t<input type=\"hidden\" name=\"folder\" value=$folder>";
	if ($photo)
		echo "\t<input type=\"hidden\" name=\"photo\" value=$photo>";
	echo "\t\t<input type=\"submit\" value=\"Ne, nechci nic mazat\">";
	echo "</form>\n";

	/* ne, nechce */
	echo "<form action=\"del_folder.php3\" method=\"get\">\n";
	echo "\t\t<input type=\"hidden\" name=\"force\" value=\"1\">\n";
	echo "\t\t<input type=\"hidden\" name=\"coll\" value=$coll>\n";
	if ($folder)
		echo "\t<input type=\"hidden\" name=\"folder\" value=$folder>";
	if ($photo)
		echo "\t<input type=\"hidden\" name=\"photo\" value=$photo>";
	echo "\t\t<input type=\"submit\" value=\"Ano, opravdu chci objekt smazat\">";
	echo "</form>\n";

	require_once("end_html.php3");

	return;
}


/*
 * mazem na zaklade toho, kde se nachazime
 */
if (isset($photo)) {
	$del_res = del_photo($photo);
	$redir = "?coll=$coll&folder=$folder";
} else if (isset($folder)) {
	$del_res = del_folder($folder);
	$redir = "?coll=$coll";
} else if (isset($coll)) {
	$del_res = del_coll($coll);
	$redir = "";
} else {
	die("Nevim co mazat");
}
/*
 * presmerujeme o uroven vys
 */
header("Location: list_folders.php3$redir");
?>
