<?php
/* $Id: edit_group.php,v 1.9.2.1 2007/02/20 10:20:11 petr Exp $ */

/*
 * edituje zakladi udaje o skupine, tak prislusnost uzivatelu ke skupine
 * a prava uzivatelu v ramci skupiny
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */

/*
 * pokud nemam jasno v tom, kterou skupinu chceme editovat
 */
if (!isset($group) || "$group" == "")
	die("neznm skupina");

/*
 * editovat skupinu muze bud admin nebo nekdo jiny, kdo na to ma prava
 */
if (! check_grp_rights($group,	$ADD_USR_GRP_RIGHT |
				$EDIT_USR_GRP_RIGHT |
				$DEL_USR_GRP_RIGHT |
				$EDIT_GRP_RIGHT |
				$DEL_GRP_RIGHT))
	die($NO_AUTHOR);

/*
 * zacatek html stranky
 */
require("start_html.php3");

/*
 * pouziva se do html tagu checkbox
 */
function is_checked($rights, $mask) {
	return ($rights & $mask) ? "checked" : "";
}

/*
 * editace informaci o skupine (nazev, popis)
 */
if (check_grp_rights($group, $EDIT_GRP_RIGHT | $DEL_GRP_RIGHT)) {
	/*
	 * ziskani informaci o skupine z databaze
	 */
	$group_query = "select * from groups where id='$group'";
	$group_result = mysql_query("$group_query");
	if (! $group_result)
		die("chyba pi natn informac o skupin");
	$group_line = mysql_fetch_row($group_result);
	/* formular pro zmenu udaju */
	/* udaje o uzivateli */
	echo "<form action=\"change_group.php\" method=\"get\">\n";
	echo "<table width=\"100%\">\n";
	echo "\t<input type=\"hidden\" name=\"group\" value=$group>";
	echo "\t<tr><td>id:</td><td>$group_line[0]</td></tr>\n";
	echo "\t<tr><td>Nzev skupiny</td><td>";
	echo "<input type=\"text\" name=\"grp_name\" value=\"" . htmlspecialchars($group_line[1], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\">";
	echo "</td></tr>\n";
	echo "\t<tr><td>Popis</td><td>";
	echo "<input type=\"text\" name=\"grp_descr\" value=\"" . htmlspecialchars($group_line[2], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\" size=50>";
	echo "</td></tr>\n";

	echo "</table>\n";

	/*
	 * radek s ovladacimi tlacitky
	 */
	echo "<table>\n";
	echo "\t<tr align=left valign=top>\n";
	if (check_grp_rights($group, $EDIT_GRP_RIGHT)) {
		echo "\t\t<td><input type=\"submit\" value=\"Uloit zmny\"></td>";
	}
	echo "</form>";
	if (check_grp_rights($group, $DEL_GRP_RIGHT)) {
		echo "<td><form action=\"del_group.php\" method=\"get\">\n";
		echo "\t\t<input type=\"hidden\" name=\"group\" value=$group>";
		echo "\t\t<input type=\"submit\" value=\"Smazat skupinu\"></td>\n";
		echo "</form>\n";
	}
	echo "\t</tr>\n";
	echo "</table>\n";
}

/*
 * sprava uzivatelu dane skupiny
 */
if (check_grp_rights($group, $EDIT_USR_GRP_RIGHT | $DEL_USR_GRP_RIGHT)) {
	 $user_list_query = "select user_group_rights.*, users.nickname from user_group_rights left join users on user_group_rights.id_user=users.id where id_group='$group' order by users.nickname";
	 $user_list_result = mysql_query($user_list_query);
	 if ($user_list_result) {
	 	/*
		 * formular pro editaci prav uzivatele v ramci skupiny
		 */
		echo "<form action=\"change_usr_grp.php\" method=\"get\">";
		echo "<table border=1 cellpadding=11>";
		echo "<b><tr><td colspan=2 rowspan=3>Uivatel</td>\n";
		echo "<td colspan=9 align=\"center\">Prva pro</td></tr>\n";
		echo "<tr><td colspan=4 align=\"center\">prci s objekty</td>";
		echo "<td colspan=5 align=\"center\">administraci skupiny</td>";
		echo "<tr><td>ten</td><td>editace</td><td>pidn</td><td>mazn</td>";
		echo "<td>pidn uivatel</td><td>editace prv</td>";
		echo "<td>mazn uivatel</td><td>editace skupiny</td><td>zruen skupiny</td></b></tr>\n";
		$i = 0;
		/*
		 * pro vsechny uzivatele ve skupine
		 */
	 	while ($user_line = mysql_fetch_row($user_list_result)) {
			echo "<input type=\"hidden\" name=\"usr_grp[$i][0]\" value=$user_line[0]>\n";
			echo "<tr><td><input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][1]\" value=$user_line[0]></td>\n";
			echo "<td>$user_line[3]</td>";
			echo "<td>";
			$checked = is_checked($user_line[2], $READ_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][2]\" value=$READ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $EDIT_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][3]\" value=$EDIT_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $ADD_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][4]\" value=$ADD_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $DEL_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][5]\" value=$DEL_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $ADD_USR_GRP_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][6]\" value=$ADD_USR_GRP_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $EDIT_USR_GRP_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][7]\" value=$EDIT_USR_GRP_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $DEL_USR_GRP_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][8]\" value=$DEL_USR_GRP_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $EDIT_GRP_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][9]\" value=$EDIT_GRP_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $DEL_GRP_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_grp[$i][10]\" value=$DEL_GRP_RIGHT $checked>\n";
			echo "</td></tr>\n";
			$i++;
		}
		echo "</table>";
		echo "<input type=\"hidden\" name=\"group\" value=\"$group\" />";
		echo "<input type=\"submit\" name=\"save\" value=\"Uloit zmny\" />";
		echo "<input type=\"submit\" name=\"savemark\" value=\"Uloit zmny pouze u oznaench uivatel\" />";
		if (check_grp_rights($group, $DEL_USR_GRP_RIGHT)) {
			echo "<br><input type=\"submit\" name=\"delete\" value=\"Vyjmout oznaen uivatele ze skupiny\" />";
		}
		echo "</form>";
	} 
}

/*
 * seznam uzivatelu k pridani
 * -- takovi uzivatele, kteri jeste nejsou ve skupine
 */
if (check_grp_rights($group, $ADD_USR_GRP_RIGHT)) {
	$user_list_query = "select users.id, users.nickname from users left join user_group_rights on user_group_rights.id_user=users.id and user_group_rights.id_group='$group' where user_group_rights.id_group is null order by users.nickname";
	$user_list_result = mysql_query($user_list_query);
	if (! $user_list_result)
		die("nelze vytvorit seznam uzivatelu, kteri nejsou ve skupine $group");
	echo "<form action=\"insert_usr_grp.php\" method=\"get\">";
	echo "Pidat uivatele ";
	echo "<select name=\"new_usr_grp\" size=1>\n";
	while ($user_line = mysql_fetch_row($user_list_result)) {
		echo "<option value=$user_line[0]>" . htmlspecialchars($user_line[1], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "</option>\n";
	}
	echo "</select>";
	echo " <input type=\"hidden\" name=\"group\" value=\"$group\" />";
	echo " <input type=\"submit\" name=\"add\" value=\"Pidat uivatele do skupiny\" />";
	echo "</form>";
}

/*
 * konec html stranky
 */
require("end_html.php3");
?>
