<?php
/* $Id: edit_user.php3,v 1.8.2.2 2007/03/15 15:57:56 petr Exp $ */

/* 
 * editace informaci a nastaveni uzivatele
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("lib/user.php");

/*
 * editovat informace o uzivateli muze jen administrator
 */
if (! author(4))
	die($NO_AUTHOR);
/*
 * pokud nevime jakeho uzivatele chceme edotovat
 * nema smysl se tady poflakovat
 */
if (!isset($user) && "$user" != "")
	die($UNKNOWN_USER);

/*
 * zacatek html stranky
 */
require("start_html.php3");

/*
 * nacteni informaci o uzivateli
 */
$user_obj = new User($_GET["user"]);
$user_photos = $user_obj->count_photos();

/* formular pro zmenu udaju */
/* udaje o uzivateli */
echo "<table>\n";
echo "<form action=\"change_user.php3\" method=\"POST\">\n";
echo "\t<tr><td>id:</td><td>$user_obj->id</td></tr>\n";
echo "\t<tr><td>Fotek</td><td>$user_photos</td></tr>\n";
echo "\t<tr><td>Uivatelsk jmno</td><td>";
echo "<input type=\"text\" name=\"nickname\" value=\"". htmlspecialchars($user_obj->nickname, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\" />";
echo "</td></tr>\n";
echo "\t<tr><td>e-mail</td><td>";
echo "<input type=\"text\" name=\"email\" value=\"". htmlspecialchars($user_obj->email, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\" />";
echo "</td></tr>\n";
echo "\t<tr><td>rove pstupu</td>";
$form_access = $user_obj->access_category;
/*
 * zobrazi polozku formulare uroven pristupu
 */
include("form_access.php3");
echo "</tr>\n";

/*
 * formular pro nastaveni osobnich informaci nejake osoby
 */
echo "\t<tr><td>Titul ped jmnem</td><td>";
echo "<input type=\"text\" name=\"tit1\"";
echo "value=\"" . htmlspecialchars($user_obj->pre_titul, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\" /></td></tr>\n";
echo "\t<tr><td>Jmno</td><td>";
echo "<input type=\"text\" name=\"name\"";
echo "value=\"" . htmlspecialchars($user_obj->name, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\" /></td></tr>\n";
echo "\t<tr><td>Pjmen</td><td>";
echo "<input type=\"text\" name=\"surname\"";
echo "value=\"" . htmlspecialchars($user_obj->surname, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) ."\" /></td></tr>\n";
echo "\t<tr><td>Titul za jmnem</td><td>";
echo "<input type=\"text\" name=\"tit2\"";
echo "value=\"" . htmlspecialchars($user_obj->post_titul, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) ."\" /></td></tr>\n";

echo "\t<tr>\n";
echo "\t\t<td>Poznmka</td>\n";
echo "\t\t<td><textarea name=\"note\" cols=\"35\" rows=\"5\">" . htmlspecialchars($user_obj->note, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "</textarea>\n";
echo "\t</tr>\n";

echo "<tr><td><br /></td><td></td></tr>\n";
echo "<tr><td><br /></td><td></td></tr>\n";

echo "\t<input type=\"hidden\" name=\"user\" value=\"$user_obj->id\">";
echo "</table>\n";

echo "<table>\n";
echo "\t<tr align=left valign=top><td>\n";
echo "\t\t<input type=\"submit\" value=\"Uloit zmny\"></form>";
echo "</td><td>";

/*
 * tlacitko pro zmenu hesla
 */
echo "<form action=\"new_passwd.php3\" method=\"get\">\n";
echo "\t\t<input type=\"hidden\" name=\"user\" value=$user>\n";
echo "\t\t<input type=\"submit\" value=\"Zmnit heslo\">";
echo "</form></td><td>";

/*
 * formular pro smazani uzivatele
 */
echo "<form action=\"del_user.php3\" method=\"get\">\n";
echo "\t\t<input type=\"hidden\" name=\"user\" value=$user />\n";
if ($user_obj->active == 1) {
    echo "\t\t<input type=\"submit\" name=\"deactivate\" value=\"Deaktivovat et\" />";
} else {
    echo "\t\t<input type=\"submit\" name=\"activate\" value=\"Aktivovat et\" />";
}
if ($user_obj->count_photos() <= 0) {
    echo "\t\t<input type=\"submit\" name=\"delete\" value=\"Smazat uivatele\" />";
}
echo "</form>\n";
echo "\t</td></tr>\n";
echo "</table>\n";

/*
 * konec html stranky
 */
include("end_html.php3");
?>
