<?php
/* $Id: editor_page_ref.php3,v 1.10.2.8 2007/04/06 12:44:06 petr Exp $ */

/*
 * editorske nastroje
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("locks.php");	/* nacte funkce pro praci se zamkama */

/*
 * zobrazi se jenom pokud mame nejake admin. pravo nebo nektere k editaci
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $ALL_ADMIN_RIGHT | $EDIT_RIGHT | $ADD_RIGHT | $DEL_RIGHT)) {
	/*
	 * pokud jsme v kolekci, tak zobrazime nastroje pro editaci kolekce
	 */
	if ((! isset($folder)) && (! isset($photo))) {
        echo "\t<ul>\n";
		if (check_obj_rights($log_user, 0, 0, 0, $ADD_RIGHT | $EDIT_RIGHT | $DEL_RIGHT)) {
            echo "\t\t<lh>Kategorie</lh>\n";
        }
		if (check_obj_rights($log_user, 0, 0, 0, $ADD_RIGHT)) {
            echo "\t\t<li><a href=\"category.php?action=new\">Pidat kategorii</a></li>\n";
        }
		if (isset($category) && check_obj_rights($log_user, 0, 0, 0, $EDIT_RIGHT)) {
            echo "\t\t<li><a href=\"category.php?action=edit&category=$category\">Editovat kategorii</a></li>\n";
        }
		if (isset($category) && check_obj_rights($log_user, 0, 0, 0, $DEL_RIGHT)) {
            echo "\t\t<li><a href=\"category.php?action=delete&category=$category\">Smazat kategorii</a></li>\n";
        }
        echo "\t</ul>\n";
        echo "\t<ul>\n";
		if (check_obj_rights($log_user, 0, 0, 0, $ADD_RIGHT | $EDIT_RIGHT | $DEL_RIGHT)) {
		    echo "\t\t<lh>Kolekce</lh>\n";
        }
		/*
		 * pokud mame pravo pridavat, tak zaobrazitme prikaz k pridani kolekce
		 */
		if (check_obj_rights($log_user, 0, 0, 0, $ADD_RIGHT)) {
			echo "\t<li><a href=\"add_folder.php3?typ=4\">Pidat kolekci</a></li>";
		}
		/*
		 * pokud se nachazime v kolekci
		 */
		if (isset($coll)) {
			/*
			 * a muzeme tuto kolekci editovat
			 */
			if (check_obj_rights($log_user, $coll, 0, 0, $EDIT_RIGHT)) {
				/*
				 * a pokud zrovna tuto kolekci needitujeme,
				 * tak zobrazime moznost editace
				 */
				if (! isset($PAGE_ID) || "$PAGE_ID" != "edit" ||
			    	      isset($folder) || isset($photo)) {
					echo "<li><a href=\"edit_folder.php3?coll=$coll\">";
					echo "Editovat kolekci</a></li>\n";
				}
                if ($PAGE_ID == "edit" || $PAGE_ID == "rights") {
					/*
					 * pokud ji editujeme tak zobrazime skratku
					 * pro prepnuti z editace do nahledu na kolekci
					 */
					echo "<li><a href=\"list_folders.php3?coll=$coll\">";
					echo "Zobrazit kolekci</a></li>\n";
				}
				$lock = get_lock($coll, $folder, $photo);
                echo "<li>";
				if (! $lock) {
					if ("$PAGE_ID" == "edit")
						echo "<a href=\"edit_folder.php3?coll=$coll&lock=1\">";
					else
						echo "<a href=\"list_folders.php3?coll=$coll&lock=1\">";
					echo "Zamknout objekt</a>\n";
				} else if ($lock[2] == $log_user) {
					echo "<a href=\"list_folders.php3?coll=$coll&lock=0\">";
					echo "Odemknout objekt</a>\n";
				} else {
				}
                echo "</li>";
			}
			/*
			 * pokud mame nektere z administratorskych prav, tak
			 * muzeme zobrazit odkaz na zmenu prav
			 */
			if (check_obj_rights($log_user, $coll, 0, 0, $ALL_ADMIN_OBJ)) {
				echo "\t<li><a href=\"edit_obj_rights.php?coll=$coll\">Zmna prv</a></li>";
			}
			/*
			 * do kolekci se daji davat slozky, samozrejme pokud k tomu mame prava
			 */
            echo "</ul>\n<ul>\n";
			echo "\t<lh>Sloka</lh>\n";
			if (check_obj_rights($log_user, $coll, 0, 0, $ADD_RIGHT)) {
				echo "<li><a href=\"add_folder.php3?typ=8&coll=$coll\">";
				echo "Pidat sloku</a></li>\n";
			}
            echo "</ul>\n";
		}
        echo "</ul>\n";
	} 
	/*
	 * jinak muzeme byt ve slozce
	 */
	else if (! isset($photo)) {
        echo "\t<ul>\n\t\t";
        echo "<lh>Sloka</lh>\n";
		/*
		 * pokud mame pravo pridavat, tak zaobrazime prikaz k pridani slozky
		 */
		if (check_obj_rights($log_user, $coll, 0, 0, $ADD_RIGHT)) {
			echo "<li><a href=\"add_folder.php3?typ=8&coll=$coll\">";
			echo "Pidat sloku</a></li>\n";
		}
		/*
		 * pokud se nachazime v ve slozce
		 */
		if (isset($folder)) {
			/*
			 * a muzeme tuto slozku editovat
			 */
			if (check_obj_rights($log_user, $coll, $folder, 0, $EDIT_RIGHT)) {
				/*
				 * a pokud zrovna tuto slozku needitujeme,
				 * tak zobrazime moznost editace
				 */
				if (! isset($PAGE_ID) || "$PAGE_ID" != "edit" ||
				    isset($photo)) {
					echo "<li><a href=\"edit_folder.php3?coll=$coll&";
						echo "folder=$folder\">";
					echo "Editovat sloku</a></li>\n";
				}
                if ($PAGE_ID == "edit" || $PAGE_ID == "rights") {
					/*
					 * pokud ji editujeme tak zobrazime skratku
					 * pro prepnuti z editace do nahledu na slozku
					 */
					echo "<li><a href=\"list_folders.php3?";
						echo "coll=$coll&folder=$folder\">";
					echo "Zobrazit sloku</a></li>\n";
				}
				$lock = get_lock($coll, $folder, $photo);
                echo "<li>";
				if (! $lock) {
					if ("$PAGE_ID" == "edit")
						echo "<a href=\"edit_folder.php3?coll=$coll&folder=$folder&lock=1\">";
					else
						echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&lock=1\">";
					echo "Zamknout objekt</a><br />\n";
				} else if ($lock[2] == $log_user) {
					echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&lock=0\">";
					echo "Odemknout objekt</a><br />\n";
				} else {
				}
                echo "</li>";
			}
			/*
			 * pokud mame nektere z administratorskych prav, tak
			 * muzeme zobrazit odkaz na zmenu prav
			 */
			if (check_obj_rights($log_user, $coll, $folder, 0, $ALL_ADMIN_OBJ)) {
				echo "\t<li><a href=\"edit_obj_rights.php?coll=$coll&folder=$folder\">Zmna prv</a></li>";
			}
			/*
			 * do slozek se daji davat fotky, samozrejme pokud k tomu mame prava
			 */
            echo "\t</ul>\n\t<ul>\n";
            echo "\t\t<lh>Fotka</lh>\n";
			if (check_obj_rights($log_user, $coll, $folder, 0, $ADD_RIGHT)) {
				echo "<li><a href=\"add_folder.php3?typ=16&coll=$coll&";
				echo "folder=$folder\">";
				echo "Pidat fotku</a></li>\n";
				echo "<li><a href=\"upload.php?typ=16&coll=$coll&";
				echo "folder=$folder\">";
				echo "Nahrt fotky</a></li>\n";
			}
            echo "\t</ul>\n";
		}
	}
	/*
	 * jinak musime byt ve fotce
	 */
	else {
		if (check_obj_rights($log_user, $coll, NULL, NULL, $EDIT_RIGHT)) {
            echo "\t<ul>\n";
            echo "\t\t<lh>Kolekce</lh>\n";
            echo "\t\t<li><a href=\"set_photo.php?set=coll&coll=$coll&folder=$folder&photo=$photo&action=$PAGE_ID\" onClick=\"return confirm('Nastavit tuto fotografii jako reprezentativni obrazek kolekce?')\">Nastavit fotku</a></li>\n";
            echo "\t</ul>\n";
        }
		if (check_obj_rights($log_user, $coll, $folder, NULL, $EDIT_RIGHT)) {
            echo "\t<ul>\n";
            echo "\t\t<lh>Sloka</lh>\n";
            echo "\t\t<li><a href=\"set_photo.php?set=folder&coll=$coll&folder=$folder&photo=$photo&action=$PAGE_ID\" onClick=\"return confirm('Nastavit tuto fotografii jako reprezentativni obrazek sloky?')\">Nastavit fotku</a></li>\n";
            echo "\t</ul>\n";
        }
		if (check_obj_rights($log_user, $coll, $folder, $photo, $ADD_RIGHT | $EDIT_RIGHT | $DEL_RIGHT)) {
            echo "\t<ul>\n";
		    echo "\t\t<lh>Fotka</lh>\n";
        }

		/*
		 * pokud mame pravo pridavat, tak zaobrazime prikaz k pridani fotky
		 */
		if (check_obj_rights($log_user, $coll, $folder, 0, $ADD_RIGHT)) {
			echo "<li><a href=\"add_folder.php3?typ=16&coll=$coll&";
			echo "folder=$folder\">";
			echo "Pidat fotku</a></li>\n";
		}
		/*
		 * pokud se nachazime v te fotce
		 */
		if (isset($photo)) {
			/*
			 * a muzeme tuto fotku editovat
			 */
			if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT)) {
				/*
				 * a pokud zrovna tuto fotku needitujeme,
				 * tak zobrazime moznost editace
				 */
				if (! isset($PAGE_ID) || "$PAGE_ID" != "edit") {
					echo "<li><a href=\"edit_folder.php3?coll=$coll&";
					echo "folder=$folder&photo=$photo\">";
					echo "Editovat fotku</a>&nbsp</li>\n";
                }
                if ($PAGE_ID == "edit" || $PAGE_ID == "rights") {
					/*
					 * pokud ji editujeme tak zobrazime skratku
					 * pro prepnuti z editace do nahledu na fotku
					 */
					echo "<li><a href=\"show_photo.php3?";
					echo "coll=$coll&folder=$folder&photo=$photo&num=3\">";
					echo "Zobrazit fotku</a>&nbsp</li>\n";
				}
				$lock = get_lock($coll, $folder, $photo);
                echo "<li>\n";
				if (! $lock) {
					if ("$PAGE_ID" == "edit")
						echo "<a href=\"edit_folder.php3?coll=$coll&folder=$folder&photo=$photo&lock=1\">";
					else
						echo "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$photo&num=2&lock=1\">";
					echo "Zamknout objekt</a><br />\n";
				} else if ($lock[2] == $log_user) {
					echo "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$photo&num=2&lock=0\">";
					echo "Odemknout objekt</a><br />\n";
				} else {
				}
                echo "</li>\n";
			}
			/*
			 * pokud mame nektere z administratorskych prav, tak
			 * muzeme zobrazit odkaz na zmenu prav
			 */
			if (check_obj_rights($sess[1], $coll, $folder, $photo, $ALL_ADMIN_OBJ)) {
				echo "\t<li><a href=\"edit_obj_rights.php?coll=$coll&folder=$folder&photo=$photo\">Zmna prv</a></li>";
			}
		}
		/*
		 * posilat fotku e-mailem smeji jen prihlaseni uzivatele
		 */
		if ($anonym != $log_user) {
			echo "<li><a href=\"email.php?typ=16&coll=$coll&folder=$folder&photo=$photo\">";
			echo "Poslat e-mailem</a></li>\n";
		}
        echo "\t</ul>\n";
	}
}
?>
