<?php
/* $Id: ext_ins_photo.php3,v 1.15.2.5 2007/04/11 09:05:20 petr Exp $ */

/*
 * generovani nahledu na pozadi
 */
require("pconnect_db.php3");
require("str_quote.php3");
require("cfg.php");
require("Log.php");

#$log = fopen('ins_photo.log', 'a');
$log = &Log::singleton('file', 'dkf.log', 'Insert');


function gen_prev($num, $scale, $identifier, $file, $res)
{
	global $CONVERT_PATH, $QUALITY, $folder_line, $log;

	/*
	 * ziskani zakladnich info o obrazku
	 */ 
	$size = getimagesize($file);
	if (! $size)
		return 0;
	/*
	 * nastaveni barevnosti obrazku
	 * (vsecny nahledy jsou v jpegu, takze RGB)
	 */
	 $bits=24;
	 $color_space="RGB";

	/*
	 * uprava identifikatoru
	 */
	$qfile = escapeshellarg($file);
	$ofile = "$identifier.$num.jpg";
	$qofile = escapeshellarg($ofile);
	/*
	 * pokud je obrazek sirsi nez delsi, tak muzes pouzit
	 * neupravenou hodnotu, jinak ji uprav o pomer stran
	 */
	$ratio = (double)$size[0]/(double)$size[1];
	if ($ratio > 1.0) {
		$x = $scale;
	} else {
		$x = (int)($scale*$ratio);
	}
//	$ex_cmd = "$CONVERT_PATH $qfile -geometry $x -colorspace RGB -quality $QUALITY -unsharp 1x1.5+0.5 img/$qofile";
	$ex_cmd = "$CONVERT_PATH $qfile -geometry $x -quality $QUALITY -unsharp 1x1.5+0.5 img/$qofile";
	/*
	 * za$log->logeme prikaz, ktery spoustime
	 */
#  fwrite($log, "$ex_cmd\n");
	/*
	 * spustime prikaz ke konvertovani
	 */
	$ex=exec(escapeshellcmd($ex_cmd));

   $log->log($ex_cmd . " ret " . $ex);
	/*
	 * ziskani infa o vygenerovanym obr a zaroven test ze se to povedlo
	 */
	$size = getimagesize("img/$ofile");
	if (!$size)
		die("neni soubor");
	/*
	 * nastaveni velikosti souboru, md5sum a pridani do databaze
	 */
	$fsize = filesize("img/$ofile");
	$msum = substr(`/usr/bin/md5sum img/$qofile`, 0, 32);
	$insert_instance = "insert into instance values(
		0, $num, 'image/jpeg', '$fsize',
		'$ofile', '$msum')";
	$result = mysql_query($insert_instance);
	if (! $result)
		die("error: $file -> $ofile");
	/*
	 * zjisteni id naposled vlozenyho
	 */
	$result = mysql_query("select max(id) from instance where check_sum='$msum'");
	$instance_line = mysql_fetch_row($result);

	$file = $ofile;
	$qfile = $qofile;
	/*
	 * propojeni fotky s instanci
	 */
	$result = mysql_query("insert into photo_instance values(
			$folder_line[0], $instance_line[0])");
	$ratio = (double)$size[0]/(double)$size[1];
	if ($size[0] > $size[1])
		$orient = 0;
	else
		$orient = 1;
	if (!isset($res))
		$res=600;
	/*
	 * pridani infa o obrazku
	 */
	$result = mysql_query("insert into image values(
				0, $orient, $res, $size[0], $size[1],
				'JPEG:$QUALITY', '$bits', '$color_space')");
	if (!$result)
		die("nejde pridat image");
	/*
	 * propojeni instance s obrazkem
	 */
	$result = mysql_query("select max(id) from image where dim_horizontal='$size[0]' and dim_vertical='$size[1]' and bit_depth='$bits'");
	$img_line = mysql_fetch_row($result);
	$result = mysql_query("insert into instance_image values(
		$instance_line[0], $img_line[0])");
}

/*
 * nacteni argumentu predanych pri spusteni
 */
if ($argc < 11)
	die("spatny pocet argumentu");

$file = str_quote($argv[1]);
$qfile = $file;
$userfile_type = $argv[2];
$userfile_size = $argv[3];
$folder_line[0] = $argv[4];
$identifier = $argv[5];
$coll = ($argv[6] > 0) ? $argv[6] : NULL;
$folder = ($argv[7] > 0) ? $argv[7] : NULL;
$photo = ($argv[8] > 0) ? $argv[8] : NULL;
$long_side = $argv[9];
$action = $argv[10];
if (isset($argv[11]) || "$argv[11]" == "")
	$res =$argv[11];
else
	$res =NULL;


/*
 * nastavime scanovane rozliseni obrazku
 */
if (!isset($res) || "$res" == "")
	$res=600;

/*
 * zapis do logu
 */
#fwrite($log, "$file $userfile_type $userfile_size $identifier\n");
$log->log("DEBUGvl: $file $userfile_type $userfile_size $identifier");

if ($action == "insert_new") {
	/*
	 * ziskani zakladnich info o obrazku
	 */ 
	$size = getimagesize("img/tmp.$file");
	/*
	 * pokud se jedna o png soubor tak prekonvertuj do spravne komprese
	 * jinak se to muze rovnou zkopirovat
	 */
	if ($size[2] == 3) {
		$ex_cmd = "$CONVERT_PATH img/tmp.$file -quality 4 img/$file";
#		fwrite($log, "$ex_cmd\n");
    $log->log($log, $ex_cmd);
		$retval = exec(escapeshellcmd($ex_cmd));
		if (! is_file("img/$file"))
			die("nejde zkonvertovat tmp.$file");
		$compression = "PNG:6";
	} else {
		copy("img/tmp.$file", "img/$file");
        if ($size[2] == 7 || $size[2] == 8) { // pokude se jedna o tif
    		$compression = `$IDENTIFY_PATH -verbose img/$file | /bin/grep Compression`;
            $compression = trim(preg_replace('/\s*Compression: (.*)/', '$1', $compression));
        } else { // jinak
    		$compression = trim(`$IDENTIFY_PATH -format "%m" img/$file`);
        }
	}
	/*
	 * odmazani docasnehou souboru
	 */
	if (file_exists("img/tmp.$file"))
		unlink("img/tmp.$file");
	/*
	 * zjisteni barevnosti obrazku
	 */
	$file_result = `file img/$file`;
#	fwrite($log, "\nfile_result=$file_result\n");
	$log->log("file_result=$file_result");
	if (strstr($file_result, "RGB")) {
		$color_space='RGB';
		$bits=24;
	} else if (strstr($file_result, "8-bit grayscale")) {
		$color_space='grayscale';
		$bits=8;
	} else if (strstr($file_result, "1-bit grayscale")) {
		$color_space='bitonal';
		$bits=1;
	} else if (strstr($file_result, "JPEG")) {
    	$color_space= `$IDENTIFY_PATH -verbose img/$file | /bin/grep Colorspace`;
        $color_space= trim(preg_replace('/\s*Colorspace: (.*)/', '$1', $color_space));
		$bits=24;
        if ($color_space == "CMYK")
            $bits=32;
	} else if (strstr($file_result, "GIF")) {
		$color_space='PaletteMatte';
		$bits=8;
	}

	/*
	 * vytvorime pro obrazek md5sum
	 */
	$msum = substr(`/usr/bin/md5sum img/$qfile`, 0, 32);
	/*
	 * zjistime presnou velikost po pripadne konverzi
	 */
	$fsize = filesize("img/$file");
	/*
	 * vlozime do databaze info o nove instanci
	 */
    $num = preg_replace('/.*\.(\d)\.[^\.]*$/', '$1', $file);
    #fwrite($log, "$file => $num\n");
    $log->log("$file => $num");
	$insert_instance = "insert into instance values(
		0, '$num', '$userfile_type', '$fsize',
		'$file', '$msum')";
	$result = mysql_query($insert_instance);
	if (! $result)
		die("nelze pridat instanci");
	/*
	 * zjistime id pridane instance
	 */
	$result = mysql_query("select max(id) from instance where check_sum='$msum'");
	$instance_line = mysql_fetch_row($result);
	/*
	 * propojime instanci s fotkou
	 */
	$pi_query = "insert into photo_instance values($folder_line[0], $instance_line[0])";
	$result = mysql_query("$pi_query");
	if (!$result)
		die("nejde pridat photo_instance\n$pi_query\n");
	/*
	 * spoctem orientaci obrazku
	 */
	if ($size[0] > $size[1])
		$orient = 0;
	else
		$orient = 1;
	
	/*
	 * pridani informaci o obrazku
	 */
	$query = "insert into image values(0, $orient, $res, $size[0], $size[1], '$compression', '$bits', '$color_space')";
	$result = mysql_query($query);
	if (!$result)
		die("nejde pridat image");
	/*
	 * zjisteni id pridaneho obrazku
	 */
	$result = mysql_query("select max(id) from image where dim_horizontal='$size[0]' and dim_vertical='$size[1]' and bit_depth='$bits'");
	$img_line = mysql_fetch_row($result);
	/*
	 * propojeni instance s obrazkem
	 */
	$result = mysql_query("insert into instance_image values(
			$instance_line[0], $img_line[0])");
	/*
	 * pom. prom. pro $ratio -- pomer stran; $scale -- velikosti delsich stran
	 */
	$ratio = (double)$size[0]/(double)$size[1];
	$scale = Array(1024, 640, 160);
	$scale[0] = $long_side;

	/*
	 * vygenerujeme 3 nahledy
	 */
	for ($i=1; $i<4; $i++) {
		gen_prev($i, $scale[$i-1], $identifier, "img/$file", $res);
		$file = "$identifier." . $i . ".jpg";
	}
} else if ($action == "regenerate") {
	gen_prev(1, $long_side, $identifier, "img/$file", $res);
}
#fclose($log);
?>
