<?php

function table_name($coll, $folder, $photo)
{
    if ($photo) return 'photos';
    if ($folder) return 'folders';
    if ($coll) return 'collections';

    return false; 
}

function table_id($coll, $folder, $photo)
{
    if ($photo) return $photo;
    if ($folder) return $folder;
    if ($coll) return $coll;
    return 0;
}

function get_element($coll, $folder, $photo)
{
    $table = table_name($coll, $folder, $photo);
    $id = table_id($coll, $folder, $photo);
    $query = "SELECT * FROM $table WHERE id='$id'";
    $result = mysql_query($query);
    if ($result and mysql_num_rows($result) > 0)
        $element = mysql_fetch_object($result);
    else
        return NULL;

    return $element;
}

function build_href($base, $ref_pref="")
{
    global $category, $coll, $folder, $photo, $url_prefs, $log_user, $anonym;

    $path_prefs = array(
        "category" => $category,
        "coll" => $coll,
        "folder" => $folder,
        "photo" => $photo
    );

    $path_query = http_build_query($path_prefs);
    $pref_query = http_build_query($url_prefs);
    $href = $base;

    if ($path_query != "" || $pref_query != "") {
        $href .= "?" . $path_query;
        if ($path_query != "") $href .= "&";
        $href .= $pref_query;
    }

    return $href . $ref_pref;
}

function str_format( $str )
{
  // odstranim html entity
  $trans = get_html_translation_table (HTML_ENTITIES);
  $trans = array_flip ($trans);
	$str = str_replace('&oslash;', '&#248;', $str);
  $pom = strtr ($str, $trans);
  
  $pom = str_replace('<br>', '<br/>', $pom); 
  $pom = str_replace('<p>', '<br/>', $pom);
  $pom = str_replace('</p>', '', $pom);
  //$pom = str_replace('&oslash;', '&#248;', $pom);

  // nahrad samostatne &
  $pom = preg_replace('/\&(?!(?=\#\d+;))/x', '&amp;', $pom);

  return $pom;
}

function drobecek($title, $url, $description=NULL, $cara='>')
{
    global $url_prefs, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC;

    $desc = $description;
    if (! $desc) $desc = $title;

    $s = "";
    if ($cara) $s .= "\t<b>$cara</b>&nbsp;";

    $s .= "\t<a href=\"" . htmlspecialchars($url, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC)
       . "\" title=\"" . htmlspecialchars($desc, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC)
       . "\">" . orez($title, 30)
       . "</a>&nbsp;\n";

    return $s;
}

function display_error($error)
{
    echo "<div id=\"error\" name=\"error\">";
    echo $error;
    echo "</div>\n";
}

function getInstanceDim( $pid, $num )
{
  $info_query = "select image.dim_horizontal, image.dim_vertical
                        from photo_instance, instance, instance_image, image
                       where photo_instance.id_photo='$pid' and 
                             photo_instance.id_instance=instance.id and
                             instance.num='$num' and 
                             instance_image.id_instance=instance.id and
                             instance_image.id_image=image.id";
  $info_result = mysql_query($info_query);
  if (! $info_result) die("nelze ziskat info o obrazku");
  $info_line = mysql_fetch_row($info_result);

  return $info_line;
}

/*
 * orez poznamky na zadany pocet znaku. za konec slova se da trojtafka
 */
function orez ($str, $znaku) {
	$pozn = preg_replace('/<[^>]+>/', '', $str);
    $orig_len = strlen($pozn);

	if ($orig_len > $znaku) {
		for ($i=($znaku-1); $i<$orig_len && $pozn[$i] != " "; $i++)
			;
		$pozn = substr($pozn, 0, $i);
		if (strlen($pozn) < $orig_len)
			$pozn .= "...";
	} 

	return $pozn;
}


function count_folders( $id, $name='collection_folder', $id_name='id_collection' )
{
	$fr = mysql_query( "select count(*) from $name where $id_name='$id'" );
	$fl = mysql_fetch_row($fr);
    return $fl[0];
}

function count_col_photos( $id )
{
	$pr = mysql_query("select count(*) from collection_folder left join folder_photo on collection_folder.id_folder=folder_photo.id_folder where id_photo is not null and collection_folder.id_collection='$id'");
	$pl = mysql_fetch_row($pr);
    return $pl[0];
}

function count_user_photos( $user_id )
{
    $q = "select count(*) from photos where owner='$user_id'";
	$pr = mysql_query($q);
	$pl = mysql_fetch_row($pr);
    return $pl[0];
}

function move_files ($id, $new_ident)
{
	$ins_query = "select instance.id, instance.num, instance.file_name from instance, photo_instance where photo_instance.id_photo=$id and photo_instance.id_instance=instance.id";
	$ins_result = mysql_query($ins_query);
	if (! $ins_result)
		die("nepodarilo se ziskat info o instancich pro photo.id=$id\n");
	while ($ins_line = mysql_fetch_row($ins_result)) {
		$suffix = preg_replace('/.*\.(.*)$/', '$1', $ins_line[2]);
		$file = "$new_ident.$ins_line[1].$suffix";
		if ("$file" != "$ins_line[2]") {
			/*
			 * ikdyz jeste neni jasne, jestli soubor existuje, tak
			 * presto upravime zaznam v databazi, aby nedochazelo
			 * v budoucnu ke krizeni;
			 */
			$up_q = "update instance set file_name='$file' where id=$ins_line[0]";
			$up_r = mysql_query($up_q);
			if (! $up_r)
				die("nepodarilo se updatovat jmeno souboru\n");

			/*
			 * presun souboru
			 */
			if (file_exists("img/$ins_line[2]")) {
/*				echo "img/$ins_line[2] => ../img/$file\n";*/
				rename("img/$ins_line[2]", "img/$file");
			} else {
/*				echo "neexistuje soubor ../img/$ins_line[2]\n";*/
			}
		}
	}

}

function odindexuj_objekt($id, $TABLE_NAME)
{
	$base = preg_replace('/(.*)s$/', '$1', $TABLE_NAME);

	$db_id = dkf_index_open("wd");
	if (! $db_id)
		die("odindexuj_objekt: nepodarilo se odindexovat $TABLE_NAME $id\n");
	/*
	 * odindexujeme zakladni tabulku
	 */
	$db_custom = create_custom($TABLE_NAME, $id);
	$query = "select * from $TABLE_NAME where id=$id";
	$result = mysql_query($query);
	if (! $result)
		die("odindexuj_objekt: nepodarilo se ziskat info o $TABLE_NAME $id\n");
	$line = mysql_fetch_row($result);
	odindexuj($line[4], $TABLE_NAME, 'title', $db_custom, $id, $db_id);
	odindexuj($line[9], $TABLE_NAME, 'description', $db_custom, $id, $db_id);
	odindexuj($line[10], $TABLE_NAME, 'identifier', $db_custom, $id, $db_id);
	odindexuj($line[12], $TABLE_NAME, 'user_identifier', $db_custom, $id, $db_id);

    /*
     * odindexujeme subjekty
     */
    $query = "select * from ${base}_subject where id_${base}=$id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o subjektech pro $id");

	if ($db_id == FALSE)
		die("odindexovat: nelze odindexovat");
	$custom = create_custom("${base}_subject", $id);
	while ($line = mysql_fetch_row($result)){
	    odindexuj($line[1], "${base}_subject", 'subject', $custom, $id, $db_id);
	}

	/*
	 * odindexujeme medailonky
	 */
    if ($base == 'folder') {
	    if ($db_id == FALSE)
		    die("nelze odindexovat, protoze nejde otevrit index");
    	$custom = create_custom("medailonek", $id);
    	$query = "select * from medailonek where id_folder=$id";
	    $result = mysql_query($query);
    	if (! $result)
	    	die("move_object: nepodarilo se ziskat ifnfo o medailonkach pro $id");
    	while ($line = mysql_fetch_row($result)){
	        odindexuj($line[1], "medailonek", 'description', $custom, $id, $db_id);
    	}
    }

	/*
	 * odindexujeme coverage
	 */
	$cov_query = "select coverage.* from coverage, coverage_$base where coverage_$base.id_$base=$id and coverage_$base.id_coverage=coverage.id";
	$cov_result = mysql_query($cov_query);
	if (! $cov_result)
		die("odindexuj_objekt: nepodarilo se ziskat info o coverate k $TABLE_NAME $id:$line[0]:$cov_query\n");
	$cov_line = mysql_fetch_row($cov_result);
	if ($cov_line) {
		$db_custom = create_custom("coverage", $cov_line[0]);
 		odindexuj($cov_line[2], 'coverage', 'place', $db_custom, $cov_line[0], $db_id);
	 	odindexuj($cov_line[3], 'coverage', 'date', $db_custom, $cov_line[0], $db_id);
	}

	 /*
	  * odindexujeme source
	  */
	 $src_query = "select source.* from source, ${base}_source where ${base}_source.id_$base=$id and ${base}_source.id_source=source.id";
	 $src_result = mysql_query($src_query);
	 if (! $src_result)
	 	die("odindexuj_objekt: nepodarilo se ziskat info o source k $TABLE_NAME $id:$line[0]:$src_query\n");
	$src_line = mysql_fetch_row($src_result);
	if ($src_line) {
		$db_custom = create_custom("source", $src_line[0]);
		odindexuj($src_line[4], 'source', 'shellfref', $db_custom, $src_line[0], $db_id);
	}

	dkf_index_close($db_id);
}

function naindexuj_objekt($id, $TABLE_NAME)
{
	$base = preg_replace('/(.*)s$/', '$1', $TABLE_NAME);

	$db_id = dkf_index_open("wd");
	if (! $db_id)
		die("naindexuj_objekt: nepodarilo se naindexovat $TABLE_NAME $id\n");
	/*
	 * naindexujeme zakladni tabulku
	 */
	$db_custom = create_custom($TABLE_NAME, $id);
	$query = "select * from $TABLE_NAME where id=$id";
	$result = mysql_query($query);
	if (! $result)
		die("naindexuj_objekt: nepodarilo se ziskat info o $TABLE_NAME $id\n");
	$line = mysql_fetch_row($result);
	naindexuj($line[4], $TABLE_NAME, 'title', $db_custom, $id, $db_id);
	naindexuj($line[9], $TABLE_NAME, 'description', $db_custom, $id, $db_id);
	naindexuj($line[10], $TABLE_NAME, 'identifier', $db_custom, $id, $db_id);
	naindexuj($line[12], $TABLE_NAME, 'user_identifier', $db_custom, $id, $db_id);

    /*
     * naindexuj subjekty
     */
    $query = "select * from ${base}_subject where id_${base}=$id";
	$result = mysql_query($query);
	if (! $result)
		die("naindexuj: nepodarilo se ziskat info o subjektech pro $id");
	if ($db_id == FALSE)
		die("naindexuj: nelze naindexovat");
	$custom = create_custom("${base}_subject", $id);
	while ($line = mysql_fetch_row($result)){
	    naindexuj($line[1], "${base}_subject", 'subject', $custom, $id, $db_id);
	}

	/*
	 * naindexuj medailonky
	 */
    if ($base == 'folder') {
	    if ($db_id == FALSE)
		    die("nelze naindexovat, protoze nejde otevrit index");
    	$custom = create_custom("medailonek", $id);
    	$query = "select * from medailonek where id_folder=$id";
	    $result = mysql_query($query);
    	if (! $result)
	    	die("naindexuj: nepodarilo se ziskat ifnfo o medailonkach pro $id");
    	while ($line = mysql_fetch_row($result)){
	        naindexuj($line[1], "medailonek", 'description', $custom, $id, $db_id);
    	}
    }

	/*
	 * naindexujeme coverage
	 */
	$cov_query = "select coverage.* from coverage, coverage_$base where coverage_$base.id_$base=$id and coverage_$base.id_coverage=coverage.id";
	$cov_result = mysql_query($cov_query);
	if (! $cov_result)
		die("naindexuj_objekt: nepodarilo se ziskat info o coverate k $TABLE_NAME $id:$line[0]\n");
	$cov_line = mysql_fetch_row($cov_result);
	if ($cov_line) {
		$db_custom = create_custom("coverage", $cov_line[0]);
 		naindexuj($cov_line[2], 'coverage', 'place', $db_custom, $cov_line[0], $db_id);
	 	naindexuj($cov_line[3], 'coverage', 'date', $db_custom, $cov_line[0], $db_id);
	}

	 /*
	  * naindexujeme source
	  */
	 $src_query = "select source.* from source, ${base}_source where ${base}_source.id_$base=$id and ${base}_source.id_source=source.id";
	 $src_result = mysql_query($src_query);
	 if (! $src_result)
	 	die("naindexuj_objekt: nepodarilo se ziskat info o source k $TABLE_NAME $id:$line[0]\n");
	$src_line = mysql_fetch_row($src_result);
	if ($src_line) {
		$db_custom = create_custom("source", $src_line[0]);
		 naindexuj($src_line[4], 'source', 'shellfref', $db_custom, $src_line[0], $db_id);
	}
	dkf_index_close($db_id);
}

function is_log_user()
{
    return $GLOBALS["log_user"] != $GLOBALS["anonym"];
}

function ac_to_s($access_category)
{
	$value = "";
    switch ($access_category) {
        case 0:
            $value = "anonymn";
            break;
        case 1:
            $value = "uivatelsk";
                break;
        case 2:
            $value = "editorsk";
            break;
        case 4:
            $value = "administrtorsk";
            break;
    }
    return $value;
}

function js_escape($str)
{
    $srch = array('\\', "\n", "\r", '"');
    $repl = array('\\\\', " ", " ", '\\"');

    return str_replace($srch, $repl, $str);
}

?>
