<?php
/* $Id: get_slide.php,v 1.12 2003/08/14 05:34:50 petr Exp $ */

/*
 * definuje funkce pro ziskani informace o prvnim, predchozim, nasledujicim a poslednim objektu
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */

/*
 * overi pravio pro cteni v zavislosti na pozici
 */
function prubni($id)
{
	global $anonym, $log_user, $coll, $folder, $photo, $READ_RIGHT;

	/*
	 * pravo pro cteni muze mit bud anonym, nebo uzivatel
	 */
	if ("$photo" != "") {
		if (! (check_obj_rights($anonym, $coll, $folder, $id, $READ_RIGHT) || check_obj_rights($log_user, $coll, $folder, $id, $READ_RIGHT)))
			return 0;
	} else if ("$folder" != "") {
		if (! (check_obj_rights($anonym, $coll, $id, 0, $READ_RIGHT) || check_obj_rights($log_user, $coll, $id, 0, $READ_RIGHT)))
			return 0;
	} else if ("$coll" != "") {
		if (! (check_obj_rights($anonym, $id, 0, 0, $READ_RIGHT) || check_obj_rights($log_user, $id, 0, 0, $READ_RIGHT)))
			return 0;
	} else {
		return 0;
	}


	return 1;
}

/*
 * hlavni funkce, ktera ziska prv, pred, nasl, posl
 */
function slide(&$descript, $srt) { // srt urcuje podle ceho se tridi 0 -- podle abecedy, 1 -- podle data modifikace 
	global $photo, $folder, $user_line, $coll, $anonym, $log_user;

	/*
	 * priprava dotazu pro ziskani seznamu
	 *
	 * je treba uvest alternativni pole pro trideni, protoze pokud
	 * bude title u vice stejny tak to setridi podle toho jak
	 * to bude vyhovovat optimalizacni funkci databaze!!!
	 */

	if ($srt == 0) $str_srt="title";
	else $str_srt="created DESC";

	if ($photo) { 
		$slide_query="select photos.id, photos.title from folder_photo, photos
			where folder_photo.id_folder=$folder
			and folder_photo.id_photo=photos.id
			order by photos.$str_srt, photos.identifier, photos.id";
		$actual=$photo;
	} elseif ($folder) {
			$slide_query = "select folders.id, folders.title
				from collection_folder, folders
				where collection_folder.id_collection=$coll
				and collection_folder.id_folder=folders.id
				order by folders.$str_srt, folders.identifier, folders.id";
			$actual=$folder;
	} elseif ($coll) {
		$slide_query = "select id, title from collections order by $str_srt, identifier, id";
		$actual=$coll;
	}
	/*
	 * nacteni slozek
	 */
	$slide_result=mysql_query($slide_query);
	if (! $slide_result) die("Nelze provest dotaz na slide show.");

	/*
	 * 0 -- prvni
	 * 1 -- predchozi
	 * 2 -- nasledujici
	 * 3 -- posledni
	 */
	$slide[0]=-1; $slide[1]=-1; $slide[2]=-1; $slide[3]=-1;
	$slide_line = mysql_fetch_row($slide_result);
	$prub = 0;
	/*
	 * vyhledavam prvni, na kterou mam pravo
	 */
	if (mysql_num_rows($slide_result) > 0)
		while ($slide_line && ! ($prub=prubni($slide_line[0])))
			$slide_line = mysql_fetch_row($slide_result);
	if ($slide_line) {
		$slide[0] = $slide_line[0];
		$descript[0] = $slide_line[1];
        	if ($actual == $slide_line[0])
			$slide[1] = $slide[0];
	}

	$slide_pre=$slide[0];
	$descript_pre=$descript[0];
	/*
	 * vyhledani predchoziho a nasledujiciho
	 */
	while ($slide_line=mysql_fetch_row($slide_result)) {
		/*
		 * preskakuji ty, na ktery nemam prava
		 */
		if (! prubni($slide_line[0]))
			continue;
		/*
		 * kdyz narazim na aktualni slozku, pak jsem nasel predchozi
		 */
		if ($actual == $slide_line[0]) { 
			$slide[1]=$slide_pre;
			$descript[1]=$descript_pre;
		} else
		/*
		 * kdyz uz jsem se dobelha za aktualni, tak tam bude nejspis nasledujici
		 */
		if ($actual == $slide_pre) { 
			$slide[2]=$slide_line[0];
			$descript[2]=$slide_line[1];
		}
		$slide_pre=$slide_line[0];
		$descript_pre=$slide_line[1];
		//echo "$descript_pre<BR>";
	}
	
	/*
	 * pokud soucasna polozka neni posledni pak nastavime posledni
	 * -- promenna $slide_pre je pomocna, ktera by po skonceni cyklu
	 *    mela ukazovat na posledni slozku
	 */
	if ($actual != $slide_pre) {
		$slide[3] = $slide_pre;
		$descript[3]=$descript_pre;
	}
	/*
	 * pokud je aktualni slozak prvni, tak nema predchozi
	 */
	if ($actual == $slide[0]) {
		$slide[0] = $slide[1] = -1;
	}

/*
 * vrat zjistene informace
 */
return $slide;
}
?>
