<?php
require_once("auth.php3");
require_once("cfg.php");
require_once("functions.php");

require_once("lib/collection.php");



function category_get($category)
{
    $q = "SELECT * FROM categories WHERE id='$category'";
    $r = mysql_query($q);
    if (!r) {
        $GLOBALS["error"] = "Categorie $category neexistuje";
        return NULL;
    }
    return mysql_fetch_object($r);
}


function category_get_collections($category)
{
    if (!$category) return Array();
    $qc = "SELECT collections.id as id, title, description FROM collection_category, collections WHERE id_category='$category' AND id_collection=collections.id ORDER BY title";
    $rc = mysql_query($qc);
    if (!$rc) {
        $GLOBALS["error"] = "Nepodarilo se ziskat seznam kolekci pro kategorii $category";
        return NULL;
    }

    $colls = Array();
    while ($collection = mysql_fetch_object($rc)) {
		if (check_obj_rights($GLOBALS["log_user"], $collection->id, 0, 0, $GLOBALS["READ_RIGHT"]))
            $colls[] = $collection;
    }

    return $colls;
}

function collection_is_in($collection, $cols)
{
    foreach($cols as $c) {
        if ($c->id == $collection->id) return true;
    }

    return false;
}


function category_delete_form($category_id)
{
    $category = category_get($category_id);

    $s = "";
    $s .= "<h1>$category->title</h1>";
    $s .= "<p>$category->description</p>";
    $s .= "<form action=\"category.php?action=rm&category=$category->id\" method=\"POST\">";
    $s .= "<input type=\"submit\" name=\"rm\" value=\"Smazat\" />&nbsp;";
    $s .= "<input type=\"submit\" name=\"leave\" value=\"Nechat\" />";
    $s .= "</form>";

    return $s;
}


function category_form($action='add', $submit='Vytvoit', $cat_obj=NULL)
{
    $s = "";
    $s .= "<form action=\"category.php?action=$action&category=$cat_obj->id\" method=\"POST\">";
    $s .= "<b>Nzev</b><br /><input type=\"text\" name=\"title\" value=\"$cat_obj->title\"/><br /><br />";
    $s .= "<b>Popis</b><br /><textarea name=\"description\" rows=\"10\" cols=\"60\">$cat_obj->description</textarea><br /><br />";

    $s .= "<b>Kolekce</b><br/>";
    $colls = category_get_collections($cat_obj->id);
    $q = "SELECT id, title, description FROM collections ORDER BY title";
    $r = mysql_query($q);
    while ($collection = mysql_fetch_object($r)) {
#        $s .= "<option value=\"$collection->id\"";
        $s .= "<input type=\"checkbox\" name=\"colls[]\" value=\"$collection->id\"";
        if (collection_is_in($collection, $colls))
            $s .= " checked=\"true\"";
        $s .= ">";
        $s .= $collection->title;
        $s .= "<br />";
    }
    $s .= "<br />";

    $s .= "<input type=\"submit\" name=\"new\" value=\"$submit\" />";
    $s .= "</form>";

    return $s;
}


function category_new_form()
{
    return category_form();
}


function category_edit_form( $category )
{
    $cat_obj = category_get($category);
    return category_form('save', 'Uloit', $cat_obj);
}

function category_params( $title, $description )
{
    $p['title'] = mysql_escape_string($title);
    $p['description'] = mysql_escape_string($description);
    $p['log_user'] = $GLOBALS["log_user"];

    return $p;
}


function category_connect_colls($category, $colls)
{
    if (!$colls) return false;

    foreach($colls as $c) {
        $qc = "INSERT INTO collection_category VALUES('$category', '$c')";
        mysql_query($qc);
    }
}


function category_save( $category, $title, $description, $colls=NULL )
{
    $p = category_params($title, $description);
    $q = "UPDATE categories SET title='" . $p['title'] .
                      "', description='" . $p['description'] .
                         "', modifier='" . $p['log_user'] .
                         "', modified=NOW() WHERE id='$category'";
    $r = mysql_query($q);
    if (!$r) {
        $GLOBALS["error"] = "Nepodarilo se aktualizovat databazi";
        return false;
    }

    if (! $colls) return true;

    $qd = "DELETE FROM collection_category WHERE id_category='$category'";
    mysql_query($qd);

    category_connect_colls($category, $colls);

    return true;
}


function category_delete( $category_id )
{
    $q = "DELETE FROM categories WHERE id='$category_id'";
    $r = mysql_query($q);
    $r = mysql_query($q);
    if (!$r) {
        $GLOBALS["error"] = "Nepodarilo se smazat kategorii $category_id";
        return false;
    }

    $q = "DELETE FROM collection_category WHERE id_category='$category_id'";
    $r = mysql_query($q);
    if (!$r) {
        $GLOBALS["error"] = "Nepodarilo se uvolnit kolekce kategorie $category_id";
        return false;
    }

    return true;
}


function category_add_new( $title, $description, $colls )
{
    $p = category_params($title, $description);

    $q = "INSERT INTO categories VALUES(0, '" . $p['title'] . "', '"
                                              . $p['description'] . "', '"
                                              . $p['log_user'] . "', NOW(), NOW(), '"
                                              . $log_user . "')";
    $r = mysql_query($q);
    if (!$r) {
        $GLOBALS["error"] = "Nepodarilo se vytvorit novou kategorii.";
        return NULL;
    }

    $r = mysql_query("SELECT id FROM categories WHERE title='" . $p['title'] ."'");
    if (!$r) {
        $GLOBALS["error"] = "Nepodarilo se zjistit id nove vlozene kategorie.";
        return NULL;
    }
    $cat = mysql_fetch_object($r);

    category_connect_colls($cat->id, $colls);

    return $cat->id;
}


function category_render_collection($category, $collection, $margin="50px")
{
    $s = "";
    $p  = obj_render_photo( $collection->id, NULL, NULL, "list_folders.php3?category=$category&coll=$collection->id", 50, 5 );
    $padding = 0;

    $s .= "<div class=\"entry\" style=\"padding-left: $margin;\">";
    if ($p != "") {
        $s .= "<table>";
        $s .= "<tr><td>";
        $s .= $p;
        $s .= "</td><td>";
    }
    $s .= "<div class=\"title\">";
    $s .= "<a href=\"list_folders.php3?category=$category&coll=$collection->id\">$collection->title</a>";
    $s .= " <span class=\"cnt\">[ Sloek: " . count_folders($collection->id) .
                              " | Fotografi: " . count_col_photos($collection->id);
    if (is_log_user())
        $s .= " | Pstup: " . accessibility($collection->id, NULL, NULL);
    $s .= " ]</span>";
    $s .= "</div>";
    $s .= "<br />";
    $s .= "<div class=\"note\" style=\"padding-left: ${padding}px;\">";
    $s .= $collection->description;
    $s .= "</div>";
    if ($p != "") {
        $s .= "</td></tr>";
        $s .= "</table>";
    }
    $s .= "</div>";

    return $s;
}


function category_list_collections($category)
{
    $category = category_get($category);
    $s  = "<h1>$category->title</h1>";
    $s .= "<p><i>$category->description</i></p>";
    
    $colls = category_get_collections($category->id);
    if (! $colls) return $s;

    foreach($colls as $collection) {
        $s .= category_render_collection($category->id, $collection, "0px");
    }

    return $s;
}


function category_count_folders($category_id)
{
    $colls = category_get_collections($category_id);
    $folders = 0;
    foreach($colls as $c) {
        $folders += count_folders($c->id);
    }

    return $folders;
}

function category_count_photos($category_id)
{
    $colls = category_get_collections($category_id);
    $photos = 0;
    foreach($colls as $c) {
        $photos += count_col_photos($c->id);
    }

    return $photos;
}


function category_list_categories()
{

    $s = "";

    $q = "SELECT * FROM categories ORDER BY title";
    $r = mysql_query($q);
    while ($category = mysql_fetch_object($r)) {
        $colls = category_get_collections($category->id);
        if (count($colls) == 0 && !check_obj_rights($GLOBALS["log_user"], 0, 0, 0, $EDIT_RIGHT))
            continue;
#        if (count($colls) == 0) continue;
        $s .= "<div class=\"entry\">";
        $s .= "<div class=\"title\">";
        $s .= "<a href=\"category.php?category=$category->id\">$category->title</a>";
        $s .= " <span class=\"cnt\">[ Kolekc: " . count($colls)
            . " | Sloek: " . category_count_folders($category->id)
            . " | Fotografi: " . category_count_photos($category->id) . " ]";
        $s .= "</span>";
        $s .= "</div>";
        $s .= "<div class=\"note\">";
        $s .= $category->description;
        $s .= "</div>";
#        if ($colls) {
#            foreach($colls as $collection) {
#                $s .= category_render_collection($category->id, $collection);
#            }
#        }
        $s .= "</div>";
    }

    return $s;
}


function category_rights($right, $coll=0)
{
    if (check_obj_rights($GLOBALS["log_user"], $coll, 0, 0, $right))
        return true;

    $GLOBALS["error"] = "Nedostatecna opravneni";
    return false;
}

?>
