<?php
require_once("log.php");

class MySQLObject 
{
    protected $_table;
    protected $_id_name;
    
    protected $_id;
    protected $_vars;

    function __construct($id=NULL) {
    	if (is_array($id)) {
            $this->_vars = $id;
            if (isset($id['id']))
                $this->_id = $id['id'];   		
    	} else {
            $this->_vars = array();
            $this->_id = $id;
            if ($id) {
                $this->load($id);
            }
    	}
    }
    
    public static function ls($table, $klas=NULL, $opt=array()) {
        $query = "SELECT * FROM " . $table;
        if ($opt['cond']) {
        	$query .= " WHERE " . $opt['cond'];
        }
        if ($opt['order']) {
        	$query .= " ORDER BY " . $opt['order'];
        }
        $result = mysql_query($query);
        $pom = array();
        
        if (! $result) {
        	$msg = mysql_error() . $query;
        	loguj($msg);
            $GLOBALS["error"] = $msg; 
            return $pom;
        }
       
        while ($obj = mysql_fetch_assoc($result)) {
        	if ($klas) {
        	   $new_obj = new $klas();
        	   foreach($obj as $key => $value)
        	       $new_obj->$key = $value;
                $pom[] = $new_obj;
        	} else {
        		$pom[] = $obj;
        	}
        }

        return $pom;
    }

    function load($id) {
        $query = "SELECT * FROM $this->_table WHERE $this->_id_name='$id'";
        $result = mysql_query($query);
        if (! $result || mysql_num_rows($result) == 0) {
        	$msg = "Unable to reload $this->_table with id: $id" . $query;
        	loguj($msg);
            $GLOBALS["error"] = $msg; 
            return false;
        }
        $this->_vars= mysql_fetch_assoc($result);
        $this->_id = $id;

        return true;
    }

    private function prepare_props($delimiter = ",") {
        $pom = array();
        foreach($this->_vars as $key => $value) {
            $pom[] = $key . "='" . $value . "'";
        }

        return implode($delimiter, $pom);
    }

    function save() {
        if ($this->_id) {
            $query = "UPDATE $this->_table SET ";
            $query .= $this->prepare_props();
            $query .= " WHERE $this->_id_name='$this->_id'";
        } else {
            $query = "INSERT INTO $this->_table (";
            $query .= implode(',', array_keys($this->_vars));
            $query .= ") VALUES(";
            $pom = array();
            foreach(array_values($this->_vars) as $value) {
                $pom[] = "'$value'";
            }
            $query .= implode(',', $pom);
            $query .= ")";
        }
        #echo $query . "<br />\n";
        $result = mysql_query($query);
        if (! $result) {
        	$msg = "Nepodarilo se ulozit $this->_table. $query: " . mysql_error();
        	loguj($msg);
            $GLOBALS["error"] = $msg;
            return false;
        }
        
        # zjisteni id nove vytvoreneho objektu
        if (! $this->_id) {
            $query = "SELECT $this->_id_name FROM $this->_table WHERE ";
            $query .= $this->prepare_props(' AND ');
            $result = mysql_query($query);
            $obj = mysql_fetch_assoc($result);
            $this->_id = $obj[$this->_id_name];
            $this->_vars[$this->_id_name] = $this->_id;
        }

        return true;
    }
    
    function delete() {
        if (! $this->_id) return;
        
        $query = "DELETE FROM $this->_table WHERE $this->_id_name='$this->_id'";
        $result = mysql_query($query);
        if ($result) return true;

        $msg = "Nepodarilo se smazat $this->_table. $query: " . mysql_error();
        loguj($msg);
        $GLOBALS["error"] = $msg;
        
        return false;
    }

    function render() {
        $s  = "<div>";
        foreach($this->_vars as $key => $value) {
            $s .= "<b>$key:</b> $value<br />";
        }
        $s .= "</div>";

        return $s;
    }

    function __get($name) {
        return $this->_vars[$name];
    }

    function __set($name, $value) {
        $this->_vars[$name] = $value;
    }
}
?>