<?php
require_once('get_parent.php');
require_once("functions.php");

function photo_render( $photo, $instance, $href=NULL, $height='auto', $margin=10 )
{
    $f = get_photo_folder($photo);
    $c = get_folder_coll($f);

    $img_dim = getInstanceDim( $photo, $instance );
    $wi = $img_dim[0];
    $hi = $img_dim[1];
    if ($height != 'auto') {
#        $coef = $height / $hi;
#        $hi = $height;
#        $wi = $wi * $coef;
        $hi = $height;
        $wi = $height;
    }
    $w = $wi + $margin;
    $h = $hi + $margin;

    $s = "";
    $s .= "<div class=\"photo_thumb\" style=\"width:${w}px;height:${h};padding:${margin}px;margin-right:10px;\">";
    if ($href) $s .= "<a href=\"$href\">";
    $s .= "<img src=\"get_img.php3?coll=$c&folder=$f&photo=$photo&num=$instance\" width=\"$wi\" height=\"$hi\" />\n";
    if ($href) $s .= "</a>";
    $s .= "</div>";

    return $s;
}

?>
