<?php

require_once("auth.php3");
require_once("locks.php");
require_once("dkf_index.php");
require_once("functions.php");

/*
 * pokud nema uzivatel pravo k editaci a zaroven k smazani objektu, pak tady nema co delat
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT) || ! check_obj_rights($log_user, $coll, $folder, $photo, $DEL_RIGHT))
	die($NO_AUTHOR);

/*
 * pro pripad, ze by se snazil editovat nekdo neco, co neni
 */
if (!isset($coll) || "$coll" == "")
	die($UNKNOWN_COLL);

if (! isset($mv_to))
	die("nebylo zadano kam se ma objekt presunout");

if (strlen($mv_to) != 12)
	die("spatny identifikator");

/*
 * zkontrolujeme jestli je nastaven zamek. pokud neni, pak tato funkce byla
 * volana na nezamceny objekt a proto konec
 */
if (! get_lock($coll, $folder, $photo))
	die("objekt nen zamen");


if (isset($photo)) {
	$TABLE_NAME = "photos";
	$PARENT_TABLE = "folders";
	$ID_NAME = "id_photo";
	$ID_PARENT = "id_folder";
	$PAR_CUR = "folder_photo";
	$id = $photo;
} elseif (isset($folder)) {
	$TABLE_NAME = "folders";
	$PARENT_TABLE = "collections";
	$ID_NAME = "id_folder";
	$PAR_CUR = "collection_folder";
	$ID_PARENT = "id_collection";
	$id = $folder;
} else {
	die("spatne zadane parametry");
}


/*
 * rozparsovani noveho identifikatoru
 *
$coll_ident = substr($mv_to, 0, 3);
$fold_ident = substr($mv_to, 3, 5);
$photo_ident = substr($mv_to, 9, 3);

echo "$coll_ident, $fold_ident, $photo_ident";
*/

$query = "select id from $PARENT_TABLE where identifier='" . mysql_escape_string($mv_to) . "'";
$result = mysql_query($query);
if (! $result || mysql_num_rows($result) <=0)
	die("Nelze nalezt cilov objetk s identifiktorem $mv_to. Zkontrolujte jestli pesouvte fotku do sloky nebo sloku do kolekce, vechny ostatn monosti nejsou sprvn.");
$line = mysql_fetch_row($result);
$new_par = $line[0];


$old_coll = $coll;
$old_folder = $folder;
$old_photo = $photo;

if ("$TABLE_NAME" == "photos") {
	require_once("get_parent.php");
	$photo=NULL;
	$folder=$new_par;
	$coll=get_folder_coll($folder);
	if ($coll == -1)
		die("nepodarilo se zjistit nadrazenou kolekci ke slozce $new_par");
	$redir = "coll=$coll&folder=$folder&photo=$old_photo";
} elseif ("$TABLE_NAME" == "folders") {
	$photo=NULL;
	$folder=NULL;
	$coll = $new_par;
	$redir = "coll=$coll&folder=$old_folder";
} else {
	die ("tento objekt nelze presunout: $TABLE_NAME");
}

require_once("gen_ident.php3");
$new_ident = gen_ident($coll, $folder, $photo);

/*
 * uzivatel musi mit pravo zapisovat do ciloveho objektu
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT))
	die($NO_AUTHOR);


/*
 * pred presunem objekt odindexujeme, aby nam indexy neukazovaly do prazdna
 */
if ("$TABLE_NAME" == "folders") {
	$folder = $old_folder;
	$query = "select * from folder_photo where id_folder=$folder";
	$result = mysql_query($query);
	if (! $result)
		die("chyba pri zjistovani potomku slozky $folder");
	while ($line = mysql_fetch_row($result)) {
		odindexuj_objekt($line[1], "photos");
	}
}
odindexuj_objekt($id, $TABLE_NAME);


/*
 * presun objektu
 */
$query = "update $PAR_CUR set $ID_PARENT=$new_par where $ID_NAME=$id";
$result = mysql_query($query);
if (! $result)
	die("nepodarilo se presunout objekt z puvodni slozky: $query");

/*
 * update identifier, modifier, modified
 */
$query = "update $TABLE_NAME set identifier='$new_ident', modifier='$log_user', modified=NOW() where id=$id";
$result = mysql_query($query);
if (! $result)
	die("nepodarilo se zmenit identifikator presunuteho objektu na $new_ident");

/*
 * naindexujem presunutej objekt
 */
naindexuj_objekt($id, $TABLE_NAME);

if ("$TABLE_NAME" == "photos") {
	move_files($id, $new_ident);
} else
/*
 * jestlize presouvame slozku, tak musime taky zmenit id fotek
 */
if ("$TABLE_NAME" == "folders") {
	$folder = $old_folder;
	$query = "select * from folder_photo where id_folder=$folder";
	$result = mysql_query($query);
	if (! $result)
		die("chyba pri zjistovani potomku slozky $folder");
	while ($line = mysql_fetch_row($result)) {
		$new_ident = gen_ident($coll, $folder, $photo);
		$q = "update photos set identifier='$new_ident', modifier='$log_user', modified=NOW() where id=$line[1]";
		$r = mysql_query($q);
		if (! $r)
			die ("nejde updatovat fotku $line[1]:$q\n");
		move_files($line[1], $new_ident);
		naindexuj_objekt($line[1], "photos");
	}
}


$coll = $old_coll;
$folder = $old_folder;
$photo = $old_photo;


header("Location: edit_folder.php3?$redir");

?>
