<?php
require_once("auth.php3");
require_once("pconnect_db.php3");
require_once("lib/schema.php");
require_once("lib/metadata.php");

if (! auth(4)) {
    $GLOBALS["error"] = "Nedostaten oprvnn!";
} else {
    if ($_POST["save"]) {
        $schema = new Schema();
        $schema->name = $_POST["name"];
        $schema->description = $_POST["description"];
        $schema->save();
    }
    
    
    if (! $_GET["id"]) {
        $page = "";
        $ls = Schema::ls();
        foreach ($ls as $schema) {
            $page .= $schema->render();
        }
        $page .= '
    <br />
    <h3>Pidat schema</h3>
    <form action="schema.php" method="post">
        <b>Name</b><br />
        <input type="text" name="name" /><br />
        <br />
        <b>Description</b><br />
        <textarea name="description"></textarea><br />
        <br />
        <input type="submit" name="save" value="Pridat" />
    </form>
    ';
    
    } else {
        $schema = new Schema($_GET["id"]);
        if ($_POST["add"] and $_POST["meta"]) {
            $schema->add_property($_POST["meta"]);
        }
    
        $page .= $schema->render();
        $register = meta_get_register();
    
        if (count($register) > 0) {
            $page .= "<h3>Pidat atribut</h3>";
            $page .= "<form method=\"post\">";
            $page .= "<b>Prefix</b";
            $page .= "<br /><input type=\"text\" name=\"meta[prefix]\" />";
            $page .= "<br /><b>Nzev</b>";
            $page .= "<br /><select name=\"meta[name]\">";
            $page .= "<option value=\"\"></option>";
            foreach($register as $meta) {
                $page .= "<option value=\"$meta->name\">$meta->name</option>";
            }
            $page .= "</select>";
            $page .= "<br /><b>Typ</b>";
            $page .= "<br /><select name=\"meta[typ]\">";
            $page .= "<option value=\"text\">text</option>";
            $page .= "<option value=\"textarea\">textarea</option>";
            $page .= "<option value=\"article\">article</option>";
            $page .= "</select>";
            $page .= "<br /><input type=\"checkbox\" name=\"meta[repeatable]\" value=\"1\" />";
            $page .= " <b>Repeatable?</b>";
            $page .= "<br /><input type=\"checkbox\" name=\"meta[mandatory]\" value=\"1\" />";
            $page .= " <b>Mandatory?</b>";
            $page .= "<br /><b>Popis</b>";
            $page .= "<br /><textarea name=\"meta[description]\"></textarea>";
            $page .= "<br /><input type=\"submit\" name=\"add\" value=\"Pidat atribut\" />";
            $page .= "</form>";
        }
    }
}


require_once("start_html.php3");

if ($GLOBALS["error"]) display_error($GLOBALS["error"]);

echo $page;

?>


<?php
require_once("end_html.php3");
?>
