<?php
require_once("auth.php3"); /* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("dkf_index.php");
require_once("functions.php");
require_once("lib/photo.php");
require_once("colors.php3");

$dkf_all = NULL;
$dkf_all_counter = 0;

class srchFolder {
	var $_table;
	var $_score;

	var $parent;
	var $childern;
	var $sorted;

	var $id;
	var $title;
	var $description;
	var $identifier;
	var $user_identifier;

	function srchFolder ($t, $i)
	{
		global $dkf_all, $dkf_all_counter;
		
		$this->_table = $t;
		$this->_score = 0;

		$this->parent = NULL;
		$this->childern = NULL;
		$this->sorted = NULL;

		$this->id = $i;
		$this->title = "";
		$this->description = "";
		$this->identifier = "";
		$this->user_identifier = "";

		$dkf_all[] =& $this;
		$dkf_all_counter++;
	}

	function add (&$child, $indexes, $bonus)
	{
		global $log_user, $READ_RIGHT;
		if (! $child)
			return 0;
			
		$size = sizeof($indexes);
        if ($child->_table == "medailonek")
            $child->_table = "folders";
		if (($size <= 0) || (! $indexes)) {
            if ($child->_table == 'collection_subject') {
                $child->_table = 'collections';
            }
			if ($this->childern["$child->id"]) {
				$this->childern["$child->id"]->_table =
					$child->_table;
				$this->childern["$child->id"]->_score += 10 + $bonus;
			} else {
				$this->childern["$child->id"] = &$child;
				$this->childern["$child->id"]->parent = &$this;
				$this->childern["$child->id"]->_score += 10 + $bonus;
			}
			return 1;
		}
        if (($child->_table == "coverage") || ($child->_table == "source") ||
            ($child->_table == "collection_subject") || ($child->_table == "folder_subject") || ($child->_table == "photo_subject")) {
			$pom =& $this;
			$i=0;
			$added = 0;
			while ($i < $size) {
				$key = $indexes[$i];
				if (! isset($pom->childern["$key"])) {
					switch($i) {
						case 0:
							$t = "collections";
							break;
						case 1:
							$t = "folders";
							break;
						case 2:
							$t = "photos";
							break;
						default:
							break;
					}
					$pom->childern["$key"] = & new srchFolder($t, $key);
					$pom->childern["$key"]->parent = &$pom;
					$added = 1;
				} else if (($i+1) == $size) {
					$added = 1;
				}
				$pom =& $pom->childern["$key"];
				$i++;
			}
			if ($added)
				$pom->_score += 10 + $bonus;
			return $added;
		}

		$key = array_shift($indexes);
		if (! $this->childern["$key"]) {
			switch($this->_table) {
				case "folders":
					$t = "photos";
					break;
				case "collections":
					$t = "folders";
					break;
				default:
					$t = "collections";
					break;
			}
			$this->childern["$key"] = & new srchFolder($t, $key);
			$this->childern["$key"]->parent = &$this;
		}
		return $this->childern["$key"]->add($child, $indexes, $bonus);
	}

	function update ()
	{
		if ($this->_table) {
			$query = "select title, description, identifier, user_identifier from $this->_table where id=$this->id";
			$result = mysql_query($query);
			if (! $result)
				die("nezdaril se dotaz do databaze: $this->_table:$this->id");
			$line = mysql_fetch_row($result);
			$this->title = $line[0];
			$this->description = orez($line[1], 200);
			$this->identifier = $line[2];
			$this->user_identifier = $line[3];
		}
		if (! $this->childern)
			return;
		foreach ($this->childern as $key => $child) {
			$this->childern[$key]->update();
		}
	}

	function sort()
	{
		if (! $this->childern)
			return 0;
		$this->sorted = $this->childern;
		foreach ($this->sorted as $key => $child) {
			$this->sorted[$key]->sort();
		}
	}

	function render($level=0)
	{
        global $COLOR_LIGHT;
		if ($level == 0)
			echo "<ul>\n";
		$odkaz = NULL;
		$img_src = "";
		$img_width = 0;
		$img_height = 0;
		if ($this->parent) {
			$pom =& $this;
			$par = NULL;
			while ($pom->parent) {
				$par[] = $pom->id;
				$pom =& $pom->parent;
			}
			switch ($this->_table) {
				case "photos" :
					$info_query = "select image.dim_horizontal, image.dim_vertical from photo_instance, instance, instance_image, image where photo_instance.id_photo=$par[0] and photo_instance.id_instance=instance.id and instance.num=3 and instance_image.id_instance=instance.id and instance_image.id_image=image.id";
					$info_result = mysql_query($info_query);
					if (! $info_result)
						die("nelze ziskat info o obrazku");
					$info_line = mysql_fetch_row($info_result);
					$img_src = "get_img.php3?coll=$par[2]&folder=$par[1]&photo=$par[0]&num=3";
					$img_width = $info_line[0];
					$img_height = $info_line[1];
					$odkaz = "show_photo.php3?coll=$par[2]&folder=$par[1]&photo=$par[0]&num=2&$ref_pref";
					break;
				case "folders" :
					$odkaz = "list_folders.php3?coll=$par[1]&folder=$par[0]&$ref_pref";
					break;
				case "collections" :
					$odkaz = "list_folders.php3?coll=$par[0]&$ref_pref";
					break;
			}
		}
		if ($img_src) {
			echo "<table><tr valign=\"top\"><td>";
            echo photo_render($par[0], 3, $odkaz);
			echo "</td>";
		}
		if ($this->title != "") {
			if ($img_src)
				echo "\t<td>";
			else
				echo "\t<li>";
			if ($odkaz)
				echo "<a href=\"$odkaz\">";
			echo "$this->title";
			if ($odkaz)
				echo "</a><br><font size=\"-3\" color=\"$COLOR_LIGHT\"><i>score: $this->_score</i></font>";
			if (! $img_src)
				echo "\t</li>";
			else
				echo "<br>\n";
		}
		if ($this->description != "") {
			echo "\t$this->description";
		}
		if ($img_src) {
			echo "</td></tr></table>";
		}

		if ($this->sorted) {
			echo "\t<ul>\n";
			foreach ($this->sorted as $key => $child) {
				$this->sorted["$key"]->render($level+1);
			}
		}
		if ($this->sorted)
			echo "\t</ul>\n";
		if ($level == 0)
			echo "</ul>\n";
	}

	function _show_tree()
	{
		echo "<ul>\n";
        echo "<li>$this->_table:$this->title:$this->description:$this->identifier:$this->user_identifier";
		if ($this->childern) {
			foreach($this->childern as $key => $child) {
				$child->_show_tree();
			}
		}
		echo "</ul>\n";
	}
}

$dkf = new srchFolder("", 0);
$glob_found = NULL;

/*
 * vrati 1 kdyz obj < $obj2 a -1 obracene
 */
function dkf_compare(&$obj, &$obj2)
{
	if ((! $obj) && (! $obj2))
		return 0;
	if (! $obj)
		return 1;
	if (! $obj2)
		return -1;
	
	if ($obj->_score < $obj2->_score)
		return 1;
	elseif ($obj->_score > $obj2->_score)
		return -1;

	return 0;
}

/*
/*
 * verze pro dkf_sort (normalni)
 * vrati -1 kdyz obj < obj2 a 1 obracene
 *
function dkf_compare(&$obj, &$obj2)
{
	if ((! $obj) && (! $obj2))
		return 0;
	if (! $obj)
		return -1;
	if (! $obj2)
		return 1;
	
	if ($obj->_score < $obj2->_score)
		return -1;
	elseif ($obj->_score > $obj2->_score)
		return 1;

	return 0;
}
*/
/*
 * tridi algoritmem insert sort (lepsi (a mnohem rychlejsi) je pouzit usort)
 */
/*function dkf_sort($pole)
{
	$len = sizeof($pole);

	if (! $pole)
		return 1;
	$i=1;
	while ($i < $len) {
		$j=$i-1;
		$x =& $pole[$i];
		while (($j >= 0) && (dkf_compare($pole[$j], $x) < 0)) {
			$pole[$j+1] =& $pole[$j];
			$j--;
		}
		$pole[$j+1] =& $x;
		$i++;
	}

}
*/
function dkf_render_one(&$value)
{
	global $log_user, $anonym, $show_type, $cols_no, $sort_by, $view_type_local, $COLOR_LIGHT,
		$show_thumbs_local;
	$odkaz = NULL;
	$img_src = "";
	$img_width = 0;
	$img_height = 0;

	if ($value->parent) {
		$pom =& $value;
		$par = NULL;
		$par_desc = NULL;
		$par_title = NULL;
		$par_odkaz = NULL;
		while ($pom->parent) {
			$par[] = $pom->id;
			$par_desc[] = $pom->description;
			$par_title[] = $pom->title;
			$pom =& $pom->parent;
		}
		switch ($value->_table) {
			case "photos" :
				$info_query = "select image.dim_horizontal, image.dim_vertical from photo_instance, instance, instance_image, image where photo_instance.id_photo=$par[0] and photo_instance.id_instance=instance.id and instance.num=3 and instance_image.id_instance=instance.id and instance_image.id_image=image.id";
				$info_result = mysql_query($info_query);
				if (! $info_result)
					die("nelze ziskat info o obrazku");
				$info_line = mysql_fetch_row($info_result);
				$img_src = "get_img.php3?coll=$par[2]&folder=$par[1]&photo=$par[0]&num=3";
				$img_width = $info_line[0];
				$img_height = $info_line[1];
				$odkaz = "show_photo.php3?coll=$par[2]&folder=$par[1]&photo=$par[0]&num=2";
				$par_odkaz[] = "list_folders.php3?coll=$par[2]&folder=$par[1]";
				$par_odkaz[] = "list_folders.php3?coll=$par[2]";
				break;
			case "folders" :
				$odkaz = "list_folders.php3?coll=$par[1]&folder=$par[0]";
				$par_odkaz[] = "list_folders.php3?coll=$par[1]";
				break;
			case "collections" :
				$odkaz = "list_folders.php3?coll=$par[0]";
				break;
		}
	}
	$retez="";
	if ($log_user == $anonym)
		$retez .= "&" . set_params($show_type, $cols_no, $sort_by, $view_type_local, $show_thumbs_local);

	$len_par = sizeof($par);
	if ($len_par > 0) {
		$i = $len_par - 1;
		while ($i >= 1) {
			echo "<ul><li>";
			if ($par_odkaz)
				echo "<a href=\"" . $par_odkaz[$i-1] . "$retez\">";
			echo $par_title[$i];
			if ($par_odkaz)
				echo "</a>";
			echo "<br>";
			$i--;
		}
	}
	echo "<ul>\n";
	if ($img_src) {
		echo "<table><tr valign=\"top\"><td>";
        echo photo_render($par[0], 3, "$odkaz$retez");
		echo "</td>";
	}
	if ($value->title != "") {
		if ($img_src)
			echo "\t<td>";
		else
			echo "\t<li>";
		if ($odkaz)
			echo "<a href=\"$odkaz$retez\">";
		echo "$value->title";
		if ($odkaz)
			echo "</a><br><font size=\"-3\" color=\"$COLOR_LIGHT\"><i>score: $value->_score</i></font>";
		if (! $img_src)
			echo "\t</li>";
		else
			echo "<br>\n";
	}
	if ($value->description != "") {
		echo "\t$value->description";
	}
	if ($img_src) {
		echo "</td></tr></table>";
	}
	echo "</ul>\n";
	if ($len_par > 0) {
		$i = $len_par - 1;
		while ($i >= 1) {
			echo "</li></ul>";
			$i--;
		}
	}
}

function dkf_render($srch_coll, &$pole, $nejmin)
{
	global $dkf_all_counter, $search_page, $search_per_page, $squery,
		$srch_vse, $srch_tit, $srch_descr, $srch_ident, $srch_cov_place,
		$srch_cov_date, $srch_join, $srch_zp, $advanced_search,
		$show_type, $cols_no, $sort_by, $view_type_local, $show_thumbs_local,
		$log_user, $anonym, $COLOR_LIGHT;

	if (! $pole)
		return 1;
	$len = sizeof($pole);
	$nalezeno=0;
	// spocitame pocet nalezenych objektu
	foreach ($pole as $value) {
		// protoze je to setrizeno sestupne, tak konec kdyz narazima
		// na prvni prvek, kde nic nebylo nalezeno
		if ($value->_score < $nejmin)
			break;
		$nalezeno++;
	}
	$pages = (int)ceil($nalezeno/$search_per_page);
	// vypiseme pocet objektu
	echo "<font color=\"$COLOR_LIGHT\">Poet nalezench objekt je <b>$nalezeno</b><br>\n";

	// navigace po vyhledanych objektech
	echo "Strnka: $search_page/$pages<br>\n";
	echo "Seznam strnek: </font>";
	if (isset($squery))
		$retez = "squery=". rawurlencode($squery) . "&search=Hledej";
	elseif (isset($advanced_search))
		$retez = "srch_vse=" . rawurlencode($srch_vse) . 
			 "&srch_tit=" . rawurlencode($srch_tit) .
			 "&srch_descr=" . rawurlencode($srch_descr) .
			 "&srch_ident=" . rawurlencode($srch_ident) .
			 "&srch_cov_place=" . rawurlencode($srch_cov_place) .
			 "&srch_cov_date=" . rawurlencode($srch_cov_date) .
			 "&srch_join=" . rawurlencode($srch_join) .
			 "&srch_zp=" . rawurlencode($srch_zp) .
			 "&advanced_search=Vyhledat";
	foreach ($srch_coll as $sc) {
		$retez .= "&srch_coll[]=" . rawurlencode($sc);
	}
	$istart = $search_page - 5;
	if ($istart < 1)
		$istart = 1;
	$iend = $istart + 10;
	if ($iend > ($pages+1))
		$iend = $pages+1;
	if ($istart > 1)
		echo "... ";

	if ($log_user == $anonym)
		$retez .= "&" . set_params($show_type, $cols_no, $sort_by, $view_type_local, $show_thumbs_local);

	for ($i=$istart; $i<$iend && $i<=$pages; $i++) {
		if ($i != $search_page)
			echo "<a href=\"search.php?$retez&search_page=$i\">$i</a> ";
		else
			echo "$i ";
	}
	if ($iend < ($pages+1))
		echo "...";
	echo "<br>";

	$spoz = ($search_page-1) * $search_per_page;
	$epoz = $spoz + $search_per_page;

	echo "<hr>";
	// vypiseme nalezene objekty
	for ($i=$spoz; $i<$epoz && $i<$len && $pole[$i]->_score>=$nejmin; $i++) {
		// protoze je to setrizeno sestupne, tak konec kdyz narazima
		// na prvni prvek, kde nic nebylo nalezeno
		dkf_render_one($pole[$i]);
	}
	echo "<br><hr>";

	echo "<font color=\"$COLOR_LIGHT\">";
	echo "Seznam strnek: </font>";
	for ($i=$istart; $i<$iend && $i<=$pages; $i++) {
		if ($i != $search_page)
			echo "<a href=\"search.php?$retez&search_page=$i\">$i</a> ";
		else
			echo "$i ";
	}
	if ($iend < ($pages+1))
		echo "...";
	echo "<br>";
	// navigace po vyhledanych objektech
	echo "<font color=\"$COLOR_LIGHT\">";
	echo "Strnka: $search_page/$pages<br>\n";
	// vypiseme pocet objektu
	echo "Poet nalezench objekt je <b>$nalezeno</b><br>\n";
	echo "</font>";


}

function srch($txt, $zp, $id)
{ 
	global $glob_found;
	$glob_found = NULL;
	$num = 0;
	$tot = 0;
	$pom = prepare_index($txt);
	$tok = strtok($pom, " ");
	while ($tok) {
		if (dba_exists($tok, $id)) {
			$obsah = dba_fetch($tok, $id);
//			echo "$tok --> $obsah<br>\n";
			$glob_found["$tok"] = $obsah;
			$num++;
		}
		$tot++;
		$tok = strtok(" ");
	}
	if (($zp == 1) && ($num > 0)) {
		return $glob_found;
	}
	if (($zp == 0)) {
		if ($num < $tot)
			return NULL;
	}
	
	return NULL;
}

function coll_is_in($coll, $srch_coll)
{
	if (! $coll || ! $srch_coll) return 0;

	foreach ($srch_coll as $c) {
		if (($c==$coll) || ($c==0)) return 1;
	}

	return 0;
}

function dobry_prava($srch_coll, $id, $table, $parents)
{
	global $log_user, $READ_RIGHT;

	$len = sizeof($parents);
	if ($table != "coverage") {
		switch ($len) {
			case 2:
				$coll = $parents[0];
				$folder = $parents[1];
				$photo = $id;
				break;
			case 1:
				$coll = $parents[0];
				$folder = $id;
				$photo = 0;
				break;
			default:
				$coll = $id;
				$folder = $photo = 0;
				break;
		}
	} else {
		switch ($len) {
			case 3:
				$coll = $parents[0];
				$folder = $parents[1];
				$photo = $parents[2];
				break;
			case 2:
				$coll = $parents[0];
				$folder = $parents[1];
				$photo = 0;
				break;
			default:
				$coll = $parents[0];
				$folder = $photo = 0;
				break;
		}
	}

	if (coll_is_in($coll, $srch_coll) &&
	    check_obj_rights($log_user, $coll, $folder, $photo, $READ_RIGHT)) {
		return 1;
	}

	return 0;
}

function mk_objs($srch_coll, $found, $col)
{
	global $dkf;

	$added = 0;
    $bonus = 0;
    if ($col == "title" || $col == "identifier" || $col == "user_identifier")
        $bonus += 5;
	foreach ($found as $key => $value) {
		if (! strstr($value, ":$col:"))
			continue;

		$pom = explode(".", $value);
		foreach($pom as $val2) {
			if (! strstr($val2, $col)) {
				continue;
			}
			$pom2 = explode(":", $val2);
			if (strstr($pom2[0], "collection")) {
				$indexes = NULL;
			} else {
				$indexes = explode(" ", $pom2[3]);
			}

			if (dobry_prava($srch_coll, $pom2[1], $pom2[0], $indexes)) {
				$obj =& new srchFolder($pom2[0], $pom2[1]);
				if (! $dkf->add($obj, $indexes, $bonus))
					return 0;
				$added++;
			}
		}
	}
	
	if (! $added)
		return 0;
	return 1;
}

function search($srch_coll, $title, $descr, $subj, $ident, $cov_place, $cov_date, $join, $perm, $zp)
{
	global $dkf, $dkf_all;
	
	$id = dkf_index_open("rd");
	if (! $id)
		die("nepodarilo se otevrit dkf_index.db");

	$ret = 0;
	$res = NULL;
	$l = 0;
    $cols = array("title" => "$title", "description" => "$descr", "subject" => "$subj",
                  "identifier" => "$ident", "user_identifier" => "$ident", "shellfref" => "$ident",
		"place" => "$cov_place", "date" => "$cov_date");
	foreach ($cols as $key => $value) {	
		if (trim($value) == "")
			continue;

		if ($found = srch($value, $zp, $id)) {
			if (mk_objs($srch_coll, $found, $key))

				$res[$key] += 1;
		}
		$l++;
	}

	$nejmin = 0;
	
	if ($join == 0) {
		$ret = 1;
		$nejmin = $l*10;
	}
	if ($join == 1) {
		$ret = 1;
		$nejmin = 1;
	}
	if ($ret) {
		$dkf->update();
//		$dkf->sort();
//		$dkf->render();
//		dkf_sort (&$dkf_all);
		usort($dkf_all, dkf_compare);
		dkf_render($srch_coll, $dkf_all,$nejmin);
//		$dkf->_show_tree();
	}
	dkf_index_close($id);
	return $ret;
}
?>
