<? 
/* $Id: show_folder.php3,v 1.7.2.12 2007/04/05 16:20:15 petr Exp $ */

require_once("get_user.php3");
require_once("lib/metadata.php");

/*
 * zobrazi informace o aktualnim objektu 
 */

?>


<?php

function render_property($name, $value, $class='property_value')
{
    if ($GLOBALS["coll_prop"])
        $limit = (int)$GLOBALS["coll_prop"]->metadata_len;
    if (!$limit)
        $limit = 500;

    $str = '';

    if (!$value || $value == '')
        return $str;

    $str .= "<tr>\n";
    $str .= "\t<th>$name</th>\n";

    $tim = microtime();
    $jsid = md5("${name}_$tim");

    // prilis dlouha metadata budou rozbalovaci
    // budeme skryvat vic nez 50 znaku (skryvat jenom tecku nebo jedno slovo nema smysl)
    if (strlen($value) > ($limit+50) && !$_GET["nojavascript"]) {
        $nojs_url = $_SERVER["REQUEST_URI"] . "&nojavascript=true";
        $url = "<br /><a href=\"$nojs_url\" onClick=\"javascript:toggle_property('$jsid');return false;\">%s</a>";

        $str .= "<script language=\"javascript\">";
        $str .= "hash['property']['$jsid'] = \""
             . js_escape( $value . sprintf($url, '&lt;&lt;&lt;') )
             . "\"";
        $str .= "</script>";

        $str .= "\t<td id=\"$jsid\" name=\"$jsid\" class=\"$class\">";
        $str .= orez($value, $limit);
        $str .= sprintf($url, 'Vce &gt;&gt;');
        $str .= "</td>\n";
    } else {
        $str .= "\t<td class=\"$class\">$value</td>\n";
    }

    $str .= "</tr>\n";

    return $str;
}


// priprava promenne typu prohlizeni
if (! isset($view_type)) {
    require_once("get_preferences.php");
    $view_type=$view_type_local;
}


// vypis nazvu slozky v cervene barve a datem narozeni a umrti
if ("$fold_line[4]" != "") {
    $cov = '';
    $value = "<b>$fold_line[4]</b>";

    // datum nar a umreni
    if ($view_type != 1 && $cov_query) {
        $fresult = mysql_query($cov_query);
        $coverage = mysql_fetch_object($fresult);
        if ($coverage->datum)
            $value .= "&nbsp;($coverage->datum)";
        $cov = render_property($COV_PLACE_NAME, $coverage->place);
    }

    $page .= render_property("Nzev", $value, 'title');
    $page .= $cov;
}


// popis slozky
$page .= render_property('Popis', $fold_line[9]);


// vypis medailonku
if ($medailonek_query) {
    $med_result = mysql_query($medailonek_query);

    if ($med_result && mysql_num_rows($med_result)) {
        while ($medailonek = mysql_fetch_object($med_result)) {
            $page .= render_property('Medailonek', $medailonek->description);
        }
    }
}


// dalsi metadata zobrazovat jenom kdyz je
// zapnuto zobrazovani detailu
if ($view_type != 1) {

    // vypis vsech subjektu
    if ($subject_query) {
        $fresult = mysql_query($subject_query);
        $subject_rows=0;
        if ($fresult && mysql_num_rows($fresult)) {
            while ($subj = mysql_fetch_object($fresult)) {
                $page .= render_property('Subjekt', $subj->subject);
            }
        }
    }

    // vypis autoru
    if ($author_query) {
        $fresult = mysql_query($author_query);
        $auth_rows=0;
        if ($fresult && mysql_num_rows($fresult)) {
            while($author = mysql_fetch_object($fresult)) {
                $page .= render_property("Autor fotografie", $author->author);
            }
        }
    }

    // vypis informaci o zdroji
    if ($src_query) {
        $fresult = mysql_query($src_query);
        while($fresult && mysql_num_rows($fresult) &&
                ($src = mysql_fetch_object($fresult))) {
            $page .= render_property($SRC_TYP_NAME, $src->typ);
            $page .= render_property($SRC_DAT_NAME, $src->created);
            if ($src->collection) {
                $value = $src->collection;
                if ($log_user == $anonym)
                    $value .= "&nbsp;($src->shellfref)";
                $page .= render_property($SRC_COLL_NAME, $value);
            }
            $page .= render_property($SRC_SHELLF_NAME, $src->shellfref);
        }
    }

    if ($log_user != $anonym) {
        if (isset($machine_query)) {
            $machine_result = mysql_query($machine_query);
            $machine = mysql_fetch_object($machine_result);
            $page .= render_property('Digitalizan zazen', $machine->machine);
            $page .= render_property('Digitalizan rozlien', $machine->resolution);
        }
    }

    // kdo publikoval
    $page .= render_property('Publikoval', $fold_line[8]);

    // vypis technicke poznamky
    if ($note_query) {
        $fresult = mysql_query($note_query);
        while($fresult && mysql_num_rows($fresult) && ($note = mysql_fetch_object($fresult))) {
            $page .= render_property('Poznmka', $note->note);
        }
    }


    // extra metadata
    $metas = meta_get_metadata($coll, $folder, $photo);
    $metadata = meta_select_language($metas, $GLOBAL["languages"][0]);
    if ($metadata) {
        foreach($metadata as $meta) {
            $value = '';
            if ($schema->getMeta($meta->name, $meta->lang, "typ") == 'article') {
                $element_name = 'article';
                $params = "article.php?article_id=$meta->id";
                $value .= "<a href=\"$params\" onClick=\"javascript:return popup('$params', 700, 600);\">Zobrazit</a>";
            } else {
                $value .= $meta->value;
            }
            $page .= render_property($meta->title, $value);
        }
    }


    // vypis znacek
    if ($log_user != $anonym) {
        $query = "select name from marks, mark_register where id_object=$id and typ=$typ and id_mark_register=id";
        $res = mysql_query($query);
        if ($res && mysql_num_rows($res) > 0) {
            $value = '';
            while (($line = mysql_fetch_row($res)) != NULL) {
                if ($value != '') $value .= "<br>";
                $value .= ($line[0]);
            }
            $page .= render_property('Znaky', $value);
        }
    }
} // view_type


$page .= render_property('Identifiktor', $fold_line[10]);

// adminovi zobrazit technicke informace
if (author(4)) {
    $page .= render_property('Uivatelsk Id', $fold_line[12]);
    $page .= render_property('Zznam pozen', $fold_line[5]);
    $user_obj = user_get($fold_line[2]);
    $page .= render_property($FOLD_CREATED, "$fold_line[5], uivatelem $user_obj->nickname");
    $user_obj = user_get($fold_line[7]);
    $page .= render_property("Aktualizace", "$fold_line[6], uivatelem $user_obj->nickname");
}


// prihlaseny uzivatel vidi, jestli je objekt
// pristupny i zvenku nebo mimo univerzitu
if (is_log_user()) {
    $page .= render_property('Pstup', accessibility($coll, $folder, $photo));
}

?>
