<?php

require_once("../../colors.php3");
require_once("../../orez.php");

class Instance {
	var $id;
	var $num;
	var $format;
	var $file_size;
	var $file_name;
	var $check_sum;

	var $image;


	function Instance($line)
	{
		$this->id = $line[0];
		$this->num = $line[1];
		$this->format = $line[2];
		$this->file_size = $line[3];
		$this->file_name = $line[4];
		$this->check_sum = $line[5];

		$this->get_image();
	}

	function update()
	{
		if (! $id) return FALSE;

		$query = "select * from instance where id=$this->id";
		$result = mysql_query($query);
		if (! $result)
			die("Instance:update:nezdaril se dotaz:$query\n");
		$line = mysql_fetch_row($result);

		$this->num = $line[1];
		$this->format = $line[2];
		$this->file_size = $line[3];
		$this->file_name = $line[4];
		$this->check_sum = $line[5];

		mysql_free_result($result);
		
		$this->get_image();
	}

	function get_image()
	{
		$query = "select image.* from image, instance_image where instance_image.id_instance=$this->id and instance_image.id_image=image.id";
		$result = mysql_query($query);
		if (! $result)
			die("Instance:update:nezdaril se dotaz:$query\n");
		$this->image = mysql_fetch_object($result);
		mysql_free_result($result);
	}
}



function child_compare (&$obj1, &$obj2)
{
	if ((! $obj1) && (! $obj2)) return 0;
	if (! $obj1) return -1;
	if (! $obj2) return 1;
	if ((! $obj->source) && (! $obj2->source)) return 0;
	if (! $obj1->source) return -1;
	if (! $obj2->source) return 1;

	foreach ($obj1->source as $v) {
		if ($v->shellfref) {
			$shellfref1 = $v->shellfref;
			break;
		}
	}
	foreach ($obj2->source as $v) {
		if ($v->shellfref) {
			$shellfref2 = $v->shellfref;
			break;
		}
	}

	$id1 = preg_replace('/^CfotI-(.*)/i', '$1', $shellfref1);
	$id2 = preg_replace('/^CfotI-(.*)/i', '$1', $shellfref2);

	if ($id1 < $id2) return -1;
	if ($id1 > $id2) return 1;

	return 0;
/*	echo "obj1=$obj1->title == obj2=$obj2->title : $cmp\n";
	echo "shellfref1=" . $shellfref1 . " == shellfref2=" . $shellfref2 . "\n";
	if ($obj1->source->shellfref < $obj2->source->shellfref)
		return -1;
	if ($obj1->source->shellfref > $obj2->source->shellfref)
		return 1;

	echo "ahoj\n";
	return 0;*/
}



class Folder {
	var $_base;
	var $_table;
	var $_children_table;
	var $_table_child;
	var $_child_base;
	var $_parent;
	var $_prev;
	var $_next;

	var $_navig;
	var $_abeceda;
	var $_idzdroje;

	var $_children;
	var $_children_src;

	var $id;
	var $owner;
	var $title;
	var $created;
	var $modified;
	var $modifier;
	var $publisher;
	var $description;
	var $identifier;
	var $user_identifier;
	var $creator;

	var $medailonek;
	var $coverage;
	var $note;
	var $source;
	var $subject;
	var $instance;

	function Folder ($t, $id, $abc)
	{
		$this->_table = $t;
		$this->_base = preg_replace('/(.*)s$/', '$1', $t);
		switch ($t) {
			case "collections" :
				$this->_children_table = "folders";
				$this->_table_child = "collection_folder";
				break;
			case "folders" :
				$this->_children_table = "photos";
				$this->_table_child = "folder_photo";
				break;
			default :
				$this->_children_table = NULL;
				$this->_table_child = NULL;
				break;
		}

		$this->_child_base = preg_replace('/(.*)s$/', '$1', $this->_children_table);

		$this->_parent = NULL;
		$this->_prev = NULL;
		$this->_next = NULL;

		$this->_children = NULL;
		$this->_children_src = NULL;

		$this->_navig = NULL;
		$this->_abeceda = $abc;
		$this->_idzdroje = false;

		$this->id = $id;
		$this->owner = NULL;
		$this->title = NULL;
		$this->created = NULL;
		$this->modified = NULL;
		$this->modifier = NULL;
		$this->publisher = NULL;
		$this->description = NULL;
		$this->identifier = NULL;
		$this->user_identifier = NULL;
		$this->creator = NULL;

		$this->medailonek = NULL;
		$this->coverage = NULL;
		$this->note = NULL;
		$this->source = NULL;
		$this->subject = NULL;
		$this->instance = NULL;
	}


	function sort_children_src()
	{
		if (! $this->_children)
			return 0;
		$this->_children_src = NULL;
		foreach ($this->_children as $key => $child) {
			$this->_children[$key]->sort_children_src();
			$this->_children_src[] = &$this->_children[$key];
		}
		usort($this->_children_src, child_compare);
	}

	function update ()
	{
		if ($this->_parent) {
			$this->_idzdroje = $this->_parent->_idzdroje;
		}
		if ($this->_table) {
			$query = "select * from $this->_table where id=$this->id";
			$result = mysql_query($query);
			if (! $result)
				die("nezdaril se dotaz do databaze: $this->_table:$this->id\n");
			$line = mysql_fetch_object($result);
			mysql_free_result($result);
			
			$query = "select nickname from users where id=$line->owner";
			$result = mysql_query($query);
			if (! $result)
				die("nezdaril se dotaz do databaze: users\n$query\n");
			$owner = mysql_fetch_object($result);
			mysql_free_result($result);

			$query = "select nickname from users where id=$line->modifier";
			$result = mysql_query($query);
			if (! $result)
				die("nezdaril se dotaz do databaze: users\n$query\n");
			$modifier = mysql_fetch_object($result);
			mysql_free_result($result);

			$this->owner = $owner->nickname;
			$this->title = $line->title;
			$this->created = $line->created;
			$this->modified = $line->modified;
			$this->modifier = $modifier->nickname;
			$this->publisher = $line->publisher;
			$this->description = $line->description;
			$this->identifier = $line->identifier;
			$this->user_identifier = $line->user_identifier;
			$this->creator = $line->creator;
		}

		$this->get_medailonek();
		$this->get_coverage();
		$this->get_note();
		$this->get_source();
		$this->get_subject();
		$this->get_instance();

		if (! $this->_children)
			return TRUE;
		foreach ($this->_children as $key => $child) {
			$this->_children["$key"]->update();
		}

		$this->sort_children_src();

		return TRUE;
	}
	
	function get_children ()
	{
		if (! $this->_children_table)
			return 0;

		$count = 0;

		$query = "select $this->_table_child.id_$this->_child_base from $this->_table_child, $this->_children_table where id_$this->_base=$this->id and $this->_children_table.id=$this->_table_child.id_$this->_child_base order by $this->_children_table.title";
		$result = mysql_query($query);
		if (! $result)
			die("nezdaril se dotaz do databaze pro children: $query");
		$prev = NULL;
		while ($line = mysql_fetch_row($result)) {
			$new_fold =& new Folder($this->_children_table, $line[0], $this->_abeceda);
			$this->_children["$line[0]"] =& $new_fold;
			$new_fold->_parent =& $this;
			$new_fold->get_children();
			++$count;
			if ($prev) {
				$prev->_next = &$new_fold;
				$new_fold->_prev = &$prev;
			}
			$prev =& $new_fold;
		}
		mysql_free_result($result);

		return $count;
	}

	function get_medailonek()
	{
    if ($this->_table != 'folder') {
      return;
    }
		$query = "select * from medailonek where id_folder=$this->id";
		$result = mysql_query($query);
		if (! $result)
			die("get_medailonek:$this->_table:$this->id\n");
		$this->medailonek = NULL;
		while ($line = mysql_fetch_row($result)) {
			$this->medailonek[] = $line[1];
		}
		mysql_free_result($result);
	}

	function get_coverage ()
	{
		$query = "select coverage.* from coverage, coverage_$this->_base where coverage_$this->_base.id_$this->_base=$this->id and coverage.id=coverage_$this->_base.id_coverage";
		$result = mysql_query($query);
		if (! $result)
			die("get_coverage:$this->_table:$this->id\n");
		$this->coverage = NULL;
		while ($objekt = mysql_fetch_object($result)) {
			$this->coverage[] = $objekt;
		}
		mysql_free_result($result);
	}

	function get_note()
	{
		$query = "select * from " . $this->_base . "_note where id_$this->_base=$this->id";
		$result = mysql_query($query);
		if (! $result)
			die("get_note:$this->_table:$this->id\n");
		$this->note = NULL;
		while ($line = mysql_fetch_row($result)) {
			$this->note[] = $line[1];
		}
		mysql_free_result($result);
	}

	function get_source()
	{
		$query = "select source.* from source, " . $this->_base . "_source where " . $this->_base . "_source.id_$this->_base=$this->id and source.id=" . $this->_base . "_source.id_source";
		$result = mysql_query($query);
		if (! $result)
			die("get_source:$this->_table:$this->id\n");
		$this->source = NULL;
		while ($objekt = mysql_fetch_object($result)) {
			$this->source[] = $objekt;
		}
		mysql_free_result($result);
	}

	function get_subject()
	{
		$query = "select * from " . $this->_base . "_subject where id_$this->_base=$this->id";
		$result = mysql_query($query);
		if (! $result)
			die("get_subject:$this->_table:$this->id\n");
		$this->subject = NULL;
		while ($line = mysql_fetch_row($result)) {
			$this->subject[] = $line[1];
		}
		mysql_free_result($result);
	}

	function get_instance()
	{
		if ($this->_table != "photos")
			return TRUE;

		$query = "select instance.* from instance, photo_instance where photo_instance.id_photo=$this->id and photo_instance.id_instance=instance.id";
		$result = mysql_query($query);
		if (! $result)
			die("Folder:get_instance:spatna query:$query\n");
		while ($line = mysql_fetch_row($result)) {
			$this->instance["$line[1]"] =& new Instance($line);
		}
	}

	function _show_tree()
	{
		echo "<ul>\n";
		echo "<li>table = $this->_table\n";
		echo "<ul>\n";
		echo "<li>id = $this->id\n";
		echo "<li>owner = $this->owner\n";
		echo "<li>title = $this->title\n";
		echo "<li>created = $this->created\n";
		echo "<li>modified = $this->modified\n";
		echo "<li>modifier = $this->modifier\n";
		echo "<li>publisher = $this->publisher\n";
		echo "<li>description = $this->description\n";
		echo "<li>identifier = $this->identifier\n";
		echo "<li>user_identifier = $this->user_identifier\n";
		echo "<li>creator = $this->creator\n";
		$this->_show_medailonek();
		$this->_show_coverage();
		$this->_show_note();
		$this->_show_source();
		$this->_show_subject();
		echo "</ul>";
		if ($this->_children) {
			foreach($this->_children as $key => $child) {
				$child->_show_tree();
			}
		}
		echo "</ul>\n";
	}

	function _show_medailonek()
	{
		if (! $this->medailonek) return TRUE;

		foreach ($this->medailonek as $med) {
			echo "<li>medailonek = $med\n";
		}
	}

	function _show_coverage()
	{
		if (! $this->coverage) return TRUE;

		echo "<li>coverage->\n";
		echo "<ul>\n";
		foreach ($this->coverage as $cov) {
			echo "<li>id = $cov->id\n";
			echo "<li>title = $cov->title\n";
			echo "<li>place = $cov->place\n";
			echo "<li>datum = $cov->datum\n";
		}
		echo "</ul>\n";
	}

	function _show_note()
	{
		if (! $this->note) return TRUE;

		foreach ($this->note as $not) {
			echo "<li>note = $not\n";
		}
	}

	function _show_source()
	{
		if (! $this->source) return TRUE;

		echo "<li>source->\n";
		echo "<ul>\n";
		foreach ($this->source as $src) {
			echo "<li>id = $src->id\n";
			echo "<li>typ = $src->typ\n";
			echo "<li>created = $src->created\n";
			echo "<li>collection = $src->collection\n";
			echo "<li>shellfref = $src->shellfref\n";
		}
		echo "</ul>\n";
	}

	function _show_subject()
	{
		if (! $this->subject) return TRUE;

		foreach ($this->subject as $subj) {
			echo "<li>subject = $subj\n";
		}
	}

	function _export_line ($tabs, $nazev, $obsah)
	{
		$txt =	"$tabs<tr valign=\"top\" align=\"left\">\n" .
	    		"$tabs\t<td><b>$nazev</b></td>\n" .
	    		"$tabs\t<td>$obsah</td>\n" .
	    		"$tabs</tr>\n";

		return $txt;
	}

	function _export_instance($tabs, $dir, $idz)
	{
		$txt =	"$tabs<tr>\n" .
			"$tabs\t<td><b>Instance</b></td>\n" .
			"$tabs\t<td><b>Formt</b></td>\n" .
			"$tabs\t<td><b>Velikost souboru</b></td>\n" .
			"$tabs\t<td><b>Orientace</b></td>\n" .
			"$tabs\t<td><b>Rozlien</b></td>\n" .
			"$tabs\t<td><b>ka</b></td>\n" .
			"$tabs\t<td><b>Vka</b></td>\n" .
			"$tabs\t<td><b>Komprese</b></td>\n" .
			"$tabs\t<td><b>Bit na pixel</b></td>\n" .
			"$tabs\t<td><b>Barevn md</b></td>\n" .
			"$tabs\t<td><b>Checksum</b></td>\n" .
		    	"$tabs</tr>\n";
		foreach ($this->instance as $key => $value) {
			$num = $value->num;
			$orient = ($value->image->orientation==0) ? "landscape" : "portrait";
			$vartxt = ($num==0) ? "archivn-originl" : (($num==1) ? "vt" : (($num==2) ? "normln" : (($num==3) ? "nhled" : "archivn-alternativn")));
			$txt .= "$tabs<tr>\n" .
				"$tabs\t<td>";
      if ($num != 0 && $num != 4) {
				$txt .= "<a href=\"$this->identifier.$num";
				if ($idz) $txt .= ".idz";
				$txt .= ".html\">";
			}
			$txt .=	"$vartxt";
			if ($num != 0 && $num != 4)
				$txt .= "</a>";
			$txt .=	"</td>\n" .
				"$tabs\t<td>$value->format</td>\n" .
				"$tabs\t<td>$value->file_size</td>\n" .
				"$tabs\t<td>$orient</td>\n" .
				"$tabs\t<td>" . $value->image->resolution . "</td>\n" .
				"$tabs\t<td>" . $value->image->dim_horizontal . "</td>\n" .
				"$tabs\t<td>" . $value->image->dim_vertical . "</td>\n" .
				"$tabs\t<td>" . $value->image->compression . "</td>\n" .
				"$tabs\t<td>" . $value->image->bit_depth . "</td>\n" .
				"$tabs\t<td>" . $value->image->color_mode . "</td>\n" .
				"$tabs\t<td>" . $value->check_sum . "</td>\n" .
				"$tabs</tr>\n";
		}

		return $txt;
	}

	function _export_children ($tabs, $dir, $idz)
	{
		if (! $this->_children)
			return "";
		$txt = "";
		$sloupec = 0;
		$popisek = NULL;

		if ($this->_table == "folders") foreach ($this->_children as $key => $value) {
			if ($this->_children["$key"]->instance["3"]) {
				$fname = $this->_children["$key"]->instance["3"]->file_name;
				$width = $this->_children["$key"]->instance["3"]->image->dim_horizontal;
				$height = $this->_children["$key"]->instance["3"]->image->dim_vertical;
				if (file_exists("../../img/$fname"))
					copy("../../img/$fname","$dir/img/$fname");
			} else {
				$fname = "";
				$width = "";
				$height = "";
			}
			if ($sloupec == 0)
				$txt .= "$tabs<tr valign=\"bottom\" align=\"left\">\n";
			$txt .=	"$tabs\t<td><a href=\"$value->identifier.2";
			if ($idz) $txt .= ".idz";
			$txt .= ".html\">" .
				"<img src=\"../img/$fname\" " .
				"width=\"$width\" height=\"$height\">" .
				"</a>" .
#				"<a href=\"$value->identifier.2.html\">$value->title</a>" .
				"</td><td width=\"10\">&nbsp;</td>\n";
				$popisek["$value->identifier"] = $value->title;
/*				"$tabs\t<td>\n" .
				"$tabs\t\t<a href=\"$value->identifier.2.html\">$value->title</a>" .
				"$tabs\t</td>\n";*/
			$sloupec += 1;
			if ($sloupec == 4) {
				$txt .= "$tabs</tr>\n" .
					"$tabs<tr valign=\"top\" align=\"left\">\n";
				foreach ($popisek as $pop_key => $pop) {
					$txt .= "$tabs\t<td>" .
						"<a href=\"$pop_key.2";
					if ($idz) $txt .= ".idz";
					$txt .= ".html\">" .
						"$pop" .
						"</a></td><td></td>\n";
				}
				$txt .= "$tabs</tr>\n";
				$popisek = NULL;
			}

			$this->_children["$key"]->export($dir);
			if ($sloupec > 3)
				$sloupec = 0;
		} else if ($this->_idzdroje && $idz && $this->_table=="collections" && $this->_children_src) foreach ($this->_children_src as $value) {
			$aname="";

			$shellfref = "";
			if ($value->source) {
				foreach ($value->source as $v) {
					if ($v->shellfref) {
						$shellfref = $v->shellfref;
						break;
					}
				}
			}
			#			if ($sloupec == 0)
				$txt .= "$tabs<tr valign=\"bottom\" align=\"left\">\n";
			$txt .=	"$tabs\t<td><a href=\"$value->identifier.idz.html\" $aname>" .
				"$shellfref&nbsp;</td><td>" .
				"$value->title</a></td>\n";
				#				"$tabs\t<td>" . orez($value->description, 200) . "</td>\n";
				#$sloupec += 1;
			#if ($sloupec == 2) {
				$txt .= "$tabs</tr>\n";
				#$sloupec = 0;
				#}

			$this->_children["$value->id"]->export($dir);
		} else foreach ($this->_children as $key => $value) {
			$aname="";
			if ($this->_table == "collections" and $this->_abeceda) {
				if ($this->_navig[strtoupper($value->title[0])] == 0) {
					$aname="name=\"".strtoupper($value->title[0]) . "\"";
					$this->_navig[strtoupper($value->title[0])] = 1;
				}
			}

			$txt .= "$tabs<tr valign=\"top\" align=\"left\">\n" .
				"$tabs\t<td><a href=\"$value->identifier";
			if ($idz) $txt .= ".idz";
			$txt .= ".html\" $aname>" .
				"$value->title</a></td>\n" .
				"$tabs\t<td>" . orez($value->description, 200) . "</td>\n" .
				"$tabs</tr>\n";

			$this->_children["$key"]->export($dir);
		}
		if ($sloupec != 4 && $popisek && $this->_table == "folders") {
			$txt .= "$tabs</tr>\n" .
				"$tabs<tr valign=\"top\" align=\"left\">\n";
			foreach ($popisek as $pop_key => $pop) {
				$txt .= "$tabs\t<td $aname>" .
					"<a href=\"$pop_key.2";
				if ($idz) $txt .= ".idz";
				$txt .= ".html\">" .
					"$pop" .
					"</a></td><td></td>\n";
			}
			$txt .= "$tabs</tr>\n";
			$popisek=NULL;
		} else if ($sloupec != 0 && $idz && $this->_idzdroje) {
			$txt .= "$tabs\t</tr>\n";
		}


		return $txt;
	}

	function _export_navigace($tabs, $num, $sys, $idz)
	{
		if (! $sys) {
			$index = "../";
			$html = "";
			$img = "";
		} else {
			$index = "";
			$html = "html/";
			$img = "html/";
		}
		$txt =	"$tabs<table width=\"100%\">\n" .
			"$tabs\t<tr>\n" .
			"$tabs\t\t<td align=\"left\">\n" .
			"$tabs\t\t\t<a href=\"" . $index . "index";
		if ($idz) $txt .= ".idz";
		$txt .= ".html\">" .
			"Hlavn strnka" .
			"</a>&nbsp;\n" .
			"$tabs\t\t\t<a href=\"" . $html . "dkf";
		if ($idz) $txt .= ".idz";
		$txt .= ".html\">Seznam kolekc</a>&nbsp;\n";
		if ($this->_parent) {
			$pom =& $this->_parent;
			$pomstr = "";
			while ($pom) {
				if (! $pom->_parent) {
					$pom =& $pom->_parent;
					continue;
				}
				$p = "$tabs\t\t\t<a href=\"$pom->identifier";
				if ($idz) $p .= ".idz";
				$pomstr = $p . ".html\">$pom->title</a>&nbsp;\n" . $pomstr;
				$pom =& $pom->_parent;
			}
			if (! $this->instance) {
				$txt .= $pomstr . "$tabs\t\t\t<a href=\"$this->identifier";
				if ($idz) $txt .= ".idz";
				$txt .= ".html\">$this->title</a>&nbsp;\n";
			} else
				$txt .= $pomstr;
			$pom = NULL;
			$pomstr = NULL;
		}
		
		$txt .=	"$tabs\t\t</td>\n" .
			"$tabs\t\t<td align=\"right\">\n";

		$txt .= "$tabs\t\t\t<a href=\"" . $index . "kontakt";
		if ($idz) $txt .= ".idz";
		$txt .= ".html\">Kontakt</a>\n" .
			"$tabs\t\t</td>\n" .
			"$tabs\t</tr>\n" .
			"$tabs</table>\n";

		if ((! $sys) && ($this->_parent || $this->_prev || $this->_next))
			$txt .= "$tabs<hr width=\"100%\">\n";
		if ($this->instance && $num) {
			$infix = ".$num";
		} else {
			$infix = NULL;
		}
		if ($idz) $infix .= ".idz";
if ((! $sys) && ($this->_parent || $this->_prev || $this->_next)) {
		$txt .= "$tabs<table width=\"100%\">\n$tabs\t<tr>\n$tabs\t\t<td>\n";
		$txt .= "$tabs&nbsp;\n";
		if ($this->_prev) {
			$prev = $this->_prev;
			$last = NULL;
			while ($prev) {
				$loops++;
				$last = $prev;
				$prev = $prev->_prev;
			}
			$fitem = $last->identifier . $infix;
			$txt .= "$tabs<a href=\"$fitem.html\">" .
				"<img src=\"" . $img . "first.gif\" border=\"0\" width=\"32\" height=\"32\">" .
				"</a>" .
				"&nbsp;\n$tabs" .
				"<a href=\"" . $this->_prev->identifier . "$infix.html\">" .
				"<img src=\"" . $img . "prev.gif\" border=\"0\" width=\"32\" height=\"32\">" .
				"</a>";

		} else {
			$txt .= "<img src=\"" . $img . "firstn.gif\" border=\"0\" width=\"32\" height=\"32\">" .
				"&nbsp;\n$tabs" .
				"<img src=\"" . $img . "prevn.gif\" border=\"0\" width=\"32\" height=\"32\">";
		}
		$txt .= "&nbsp;\n$tabs";
		if ($this->_parent) {
			$up = "dkf";
			if ($this->_parent->identifier) {
				$up = $this->_parent->identifier;
			}
			if ($idz) $up .= ".idz";
			$txt .= "<a href=\"" . $up . ".html\">" .
				"<img src=\"" . $img . "up.gif\" border=\"0\" width=\"32\" height=\"32\">" .
				"</a>";
		} else {
			$txt .= "<img src=\"" . $img . "upn.gif\" border=\"0\" width=\"32\" height=\"32\">";
		}
		$txt .= "&nbsp;\n$tabs";
		if ($this->_next) {
			$txt .= "<a href=\"" . $this->_next->identifier . "$infix.html\">" .
				"<img src=\"" . $img . "next.gif\" border=\"0\" width=\"32\" height=\"32\">" .
				"</a>";
		} else {
			$txt .= "<img src=\"" . $img . "nextn.gif\" border=\"0\" width=\"32\" height=\"32\">";
		}
		$txt .= "&nbsp;\n$tabs";
		if ($this->_next) {
			$next =& $this->_next;
			$last = NULL;
			while ($next) {
				$last =& $next;
				$next =& $next->_next;
			}
			$txt .= "<a href=\"" . $last->identifier . "$infix.html\">" .
				"<img src=\"" . $img . "last.gif\" border=\"0\" width=\"32\" height=\"32\">" .
				"</a>";
		} else {
			$txt .= "<img src=\"" . $img . "lastn.gif\" border=\"0\" width=\"32\" height=\"32\">";
		}
		$txt .= "$tabs\t\t</td>\n" .
			"$tabs\t\t<td align=\"right\">\n";
		$txt .= "&nbsp;\n";
		if ($this->_idzdroje && $this->_abeceda && $this->_table=="collections") {
			$txt .= "\t\t\t\t<a href=\"";
			if ($this->identifier)
				$txt .= $this->identifier;
			else if ($this->title == "Kontakty")
				$txt .= "kontakt";
			else if ($this->title == "Seznam kolekc")
				$txt .= "dkf";
			else
				$txt .= "index";
			if (! $idz) $txt .= ".idz";
			$txt .= ".html\">Tdit podle ";
			if ($idz) $txt .= "abecedy";
			else $txt .= "identifiktor";
			$txt .= "</a>\n";
		}
		$txt .= "$tabs\t\t</td>\n$tabs\t</tr>\n$tabs</table>\n";
}
		return $txt;
	}

	function _export_start($title, $num, $sys, $idz)
	{
		$txt =	"<html>\n" .
			"<head>\n" .
			"\t<meta HTTP-EQUIV=\"Content-Type\" content=\"text/html; " .
			"charset=iso-8859-2\">\n" .
			"\t<title>$title</title>\n" .
			"</head>\n" .
			"<body bgcolor=\"#aaaaaa\" text=\"#000000\" " .
			"alink=\"#ffffff\" vlink=\"#151515\" link=\"#000000\">\n" .
			"\t<table cellspacing=5 width=\"100%\">\n" .
			"\t\t<tr bgcolor=\"#998877\" valign=\"middle\" align=\"center\">\n" .
			"\t\t\t<th colspan=3>\n" .
			"\t\t\t\t<h1 valign=\"middle\" align=\"center\">$this->title</h1>\n" .
			"\t\t\t</th>\n" .
			"\t\t</tr>\n" .
			"\t\t<tr align=\"left\" valign=\"top\">\n" .
			"\t\t\t<td align=\"left\" width=\"100%\" colspan=3 " .
			"bgcolor=\"#887766\">\n";
		$tabs = "\t\t\t\t";
		$txt .= $this->_export_navigace($tabs, $num, $sys, $idz) .
			"\t\t\t</td>\n";
		$txt .=	"\t\t</tr>\n";
		$txt .= "\t</table>\n";

		return $txt;
	}

	function _export_prepare($dir, $num, $idz)
	{
		$txt = "";

		$txt .= $this->_export_start($this->title, $num, NULL, $idz) .
			"\t<table>\n" .
			"\t\t<tr align=\"left\" valign=\"top\">\n" .
			"\t\t\t<td width=\"100%\" colspan=3>\n";
		if ($this->instance) {
			$fname = $this->instance["$num"]->file_name;
			$refnum = ($num > 1) ? $num-1 : 0;
			if ($refnum > 0 && $refnum != 4) {
				$txt .=	"\t\t\t\t<a href=\"$this->identifier.$refnum";
				if ($idz) $txt .= ".idz";
				$txt .= ".html\">\n";
			}
			$txt .= "\t\t\t\t\t<img src=\"../img/$fname" .
				"\" width=\"" .
				$this->instance["$num"]->image->dim_horizontal .
				"\" height=\"" .
				$this->instance["$num"]->image->dim_vertical .
				"\">\n";
			if ($refnum > 0 && $refnum != 4)
				$txt .= "\t\t\t\t</a>\n";
			if (file_exists("../../img/$fname"))
				copy("../../img/$fname","$dir/img/$fname");
		}
		if ("$this->_table" != "") {
			$txt .= "\t\t\t\t<table cellpadding=\"0\" cellspacing=\"10\">\n";
			$tabs = "\t\t\t\t\t";
			$txt .= $this->_export_line($tabs, "Nzev", "<font color=\"#990000\"><b>" . $this->title . "</b></font>");
			if ($this->coverage) foreach ($this->coverage as $v) {
				if ($v->place) $txt .= $this->_export_line($tabs, "Msto", $v->place);
				if ($v->datum) $txt .= $this->_export_line($tabs, "Doba", $v->datum);
			}
			if ($this->description)
				$txt .= $this->_export_line($tabs, "Popis", $this->description);
			if ($this->subject) foreach ($this->subject as $v) {
				if ($v)
					$txt .= $this->_export_line($tabs, "Subjekt", $v);
			}
			if ($this->source) foreach ($this->source as $v) {
				if ($v->typ) $txt .= $this->_export_line($tabs, "Typ", $v->typ);
				if ($v->created) $txt .= $this->_export_line($tabs, "Datum vzniku", $v->created);
				if ($v->collection) $txt .= $this->_export_line($tabs, "Archiv", $v->collection);
				if ($v->shellfref) $txt .= $this->_export_line($tabs, "Identifikace zdroje", $v->shellfref);
			}
			
			if ($this->publisher) $txt .= $this->_export_line($tabs, "Publikoval", $this->publisher);
			if ($this->identifier) $txt .= $this->_export_line($tabs, "Identifiktor", $this->identifier);
			if ($this->user_identifier) $txt .= $this->_export_line($tabs, "Uivatelsk identifiktor", $this->user_identifier);
			if ($this->created) $txt .= $this->_export_line($tabs, "Zznam pozen", $this->created . " (uivatelem $this->owner)");
			if ($this->modified) $txt .= $this->_export_line($tabs, "Aktualizace", $this->modified . " (uivatelem $this->modifier)");
			if ($this->medailonek) foreach ($this->medailonek as $m) {
				if ($m) $txt .= $this->_export_line($tabs, "Medailonek", $m);
			}
			if ($this->note) foreach ($this->note as $v) {
				if ($v) $txt .= $this->_export_line($tabs, "Poznmka", $v);
			}

			if (sizeof($this->_children) > 0)
				$txt .= $this->_export_line($tabs, "Poet objekt", sizeof($this->_children));
			$txt .=	"\t\t\t\t</table>\n";
			$txt .=	"\t\t\t\t<hr><br>\n";
			if ($this->_table == "collections" and ! $idz) {
				for ($i=ord('A'); $i<= ord('Z'); $i++) {
					$this->_navig["" . chr($i)] = 0;
					$txt .= "\t\t\t\t<a href=\"#" . chr($i) . "\">" . chr($i) . "</a>&nbsp;\n";
				}
				$txt .=	"\t\t\t\t<hr>\n";
			}
		}
		$txt .=	"\t\t\t\t<table align=\"left\" border=\"0\" cellpadding=\"0\" cellspacing=\"10\">\n";
		$tabs = "\t\t\t\t\t";
		if ($this->instance) {
			$txt .= $this->_export_instance($tabs, $dir, $idz);
		} else {
			$txt .= $this->_export_children($tabs, $dir, $idz);
		}
		$txt .=	"\t\t\t\t</table>\n" .
			"\t\t\t</td>\n" .
			"\t\t</tr>\n" .
			"\t</table>\n" .
			"</body>\n" .
			"</html>\n";
		
		return $txt;
	}

	function export($dir)
	{
		$idir = $dir . "/img";
		$hdir = $dir . "/html";

		if ($this->instance) {
			foreach ($this->instance as $key => $value) {
				if ("$key" == "0")
					continue;
				$fhname = $this->identifier .".$key.html";
				$fw = fopen("$hdir/$fhname","w");
				if (! $fw)
					die("nelze otevrit pro zapis $hdir/$fhname\n");
				$txt = $this->_export_prepare($dir, "$key", false);
				fwrite($fw, $txt);
				fclose($fw);

				$fhname = $this->identifier .".$key.idz.html";
				$fw = fopen("$hdir/$fhname","w");
				if (! $fw)
					die("nelze otevrit pro zapis $hdir/$fhname\n");
				$txt = $this->_export_prepare($dir, "$key", true);
				fwrite($fw, $txt);
				fclose($fw);

			}
		} else {
			if (! $this->identifier)
				echo "$this->_table:$this->title\n";
			$fhname = $this->identifier . ".html";
			if (! $this->_table)
				$fhname = "dkf.html";

			$fw = fopen("$hdir/$fhname","w");
			if (! $fw)
				die("nelze otevrit pro zapis $hdir/$fhname\n");

			$txt = $this->_export_prepare($dir, "", false);
			fwrite($fw, $txt);
			fclose($fw);

			#if ($this->_table == "collections") {
			if ($this->_idzdroje) {
				if ($this->identifier)
					$fhname = $this->identifier . ".idz.html";
				else
					$fhname = "dkf.idz.html";
				$fw = fopen("$hdir/$fhname","w");
				if (! $fw)
					die("nelze otevrit pro zapis $hdir/$fhname\n");
				$txt = $this->_export_prepare($dir, "", true);
				fwrite($fw, $txt);
				fclose($fw);
			}
		}

	}
}



class Dkf extends Folder{
	function Dkf ($abc, $idz)
	{
		parent::Folder(NULL, NULL, $abc);
		$this->title = "Seznam kolekc";
		$this->_idzdroje = $idz;
	}

	function read ()
	{
		$prev = NULL;
		
		$query = "select id from collections order by title";
		$result = mysql_query($query);

		if (! $result)
			die("dkf: nezdaril se dotaz do databaze, kvuli kolekcim\n");
		while ($line = mysql_fetch_row($result)) {
			$new_coll =& new Folder("collections", $line[0], $this->_abeceda);
			$this->_children["$line[0]"] =& $new_coll;
			$new_coll->_parent =& $this;
			$new_coll->get_children();
			if ($prev) {
				$prev->_next =& $new_coll;
				$new_coll->_prev =& $prev;
			}
			$prev =& $new_coll;
		}
		mysql_free_result($result);
	}

	function read_collections ($colls)
	{
		foreach ($colls as $title) {
			$query = "select id from collections where title='$title'";
			$result = mysql_query($query);

			if (! $result)
				die("dkf: nezdaril se dotaz do databaze, kvuli kolekcim: query=$query\n");
			while ($line = mysql_fetch_row($result)) {
				$new_coll =& new Folder("collections", $line[0], $this->_abeceda);
				$this->_children["$line[0]"] =& $new_coll;
				$new_coll->_parent =& $this;
				$new_coll->get_children();
				if ($prev) {
					$prev->_next =& $new_coll;
					$new_coll->_prev =& $prev;
				}
				$prev =& $new_coll;
			}
			mysql_free_result($result);
		}
	}

	function update () {
		foreach($this->_children as $key => $coll) {
			$this->_children["$key"]->update();
		}
	}

	function show () {
		foreach($this->_children as $key => $coll) {
			$coll->_show_tree();
		}
	}

	function _export_index($dir, $idz)
	{
		$txt =	$this->_export_start($this->title, NULL, 1, $idz) .
			"\t<table width=\"100%\">\n" .
			"\t\t<tr align=\"left\" valign=\"top\">\n" .
			"\t\t\t<td width=\"100%\" colspan=3 align=\"center\" valign=\"middle\">\n" .
			"\t\t\t\t<a href=\"html/dkf";
		if ($idz) $txt .= ".idz";
		$txt .= ".html\">\n" .
			"\t\t\t\t\t<img src=\"html/uvod.jpg\" border=\"0\" width=\"630\" height=\"630\">\n" .
			"\t\t\t\t</a>\n" .
			"\t\t\t</td>\n" .
			"\t\t</tr>\n" .
			"\t</table>\n" .
			"</body>\n" .
			"</html>\n";
		return $txt;
	}

	function _export_kontakt($dir, $idz)
	{
		$txt =	$this->_export_start($this->title, NULL, 1, $idz) .
			"\t<table>\n" .
			"\t\t<tr align=\"left\" valign=\"top\">\n" .
			"\t\t\t<td width=\"100%\" colspan=3 align=\"left\" valign=\"top\">\n" .
			"\t\t\t\t<b>Dotazy, pipomnky:</b><br>\n" .
			"\t\t\t\t<A href=\"mailto:dkf@dkf.ics.muni.cz\">dkf@dkf.ics.muni.cz</a><br>\n" .
			"\t\t\t\t<br>\n" .
			"\t\t\t\t<b>Vedouc prce:</b><br>\n" .
			"\t\t\t\tMiroslav Bartoek (<a href=\"mailto:bartosek@ics.muni.cz\">bartosek@ics.muni.cz</a>)<br>\n" .
			"\t\t\t\t<br>\n" .
			"\t\t\t\t<b>Programtoi:</b><br>\n" .
			"\t\t\t\tPetr Kov (<a href=\"mailto:petr@dkf.ics.muni.cz\">petr@dkf.ics.muni.cz</a>)<br>\n" .
			"\t\t\t\tVlastimil Krej (<a href=\"mailto:xkrejci4@fi.muni.cz\">xkrejci4@fi.muni.cz</a>)<br>\n" .
			"\t\t\t\t<br>\n" .
			"\t\t\t\t<b>Scannerista:</b><br>\n" .
			"\t\t\t\tLeo Poruba (<a href=\"mailto:xporuba@fi.muni.cz\">xporuba@fi.muni.cz</a>)<br>\n" .
			"\t\t\t\t<br>\n" .
			"\t\t\t\t<b>stav vpoetn techniky</b><br>\n" .
			"\t\t\t\tBotanick 68a, 602 00 Brno<br>\n" .
			"\t\t\t\tTelefon: 541 512 211, Fax: 541 212 747<br>\n" .

			"\t\t\t</td>\n" .
			"\t\t</tr>\n" .
			"\t</table>\n" .
			"</body>\n" .
			"</html>\n";
		return $txt;
	}

	function _export_sys_img($dir)
	{
		copy("../../uvod.jpg", "$dir/html/uvod.jpg");

		copy("../../first.gif", "$dir/html/first.gif");
		copy("../../firstn.gif", "$dir/html/firstn.gif");

		copy("../../prev.gif", "$dir/html/prev.gif");
		copy("../../prevn.gif", "$dir/html/prevn.gif");

		copy("../../next.gif", "$dir/html/next.gif");
		copy("../../nextn.gif", "$dir/html/nextn.gif");

		copy("../../last.gif", "$dir/html/last.gif");
		copy("../../lastn.gif", "$dir/html/lastn.gif");

		copy("../../up.gif", "$dir/html/up.gif");
		copy("../../upn.gif", "$dir/html/upn.gif");
	}

	function export ($dir)
	{
		if (is_file($dir)) {
			die("$dir je souborem\n");
		}
		if (! is_dir($dir) && ! mkdir($dir)) {
			die("nelze vytvorit $dir\n");
		}

		mkdir("$dir/img");
		mkdir("$dir/html");
		
		$date = getdate();
		$this->title = "Digitln knihovna fotografi MU<br><font size=\"-3\">(export " . $date['mday'] . "/" . $date['mon'] . "/" . $date['year'] . ")</font>";
		$fw = fopen("$dir/index.html", "w");
		$txt = $this->_export_index($dir, false);
		fwrite($fw, $txt);
		fclose($fw);
		if ($this->_idzdroje) {
			$fw = fopen("$dir/index.idz.html", "w");
			$txt = $this->_export_index($dir, true);
			fwrite($fw, $txt);
			fclose($fw);
		}

		$this->title = "Kontakty";
		$fw = fopen("$dir/kontakt.html", "w");
		$txt = $this->_export_kontakt($dir, false);
		fwrite($fw, $txt);
		fclose($fw);
		if ($this->_idzdroje) {
			$fw = fopen("$dir/kontakt.idz.html", "w");
			$txt = $this->_export_kontakt($dir, true);
			fwrite($fw, $txt);
			fclose($fw);
		}

		$this->title = "Seznam kolekc";
		$this->_export_sys_img($dir);

		parent::export($dir);
/*		foreach ($this->_children as $key => $coll) {
			
			$this->_children["$key"]->export($dir);
		}*/
 	}
 }

require_once("../../pconnect_db.php3");


$STDIN = fopen("php://stdin", "r");

echo "Exportovat:\na) Ve\nb)Vybran kolekce\n? ";
$odpoved = trim(fgets($STDIN, 5));

echo "Generovat abecedn navigaci [a/n]? ";
$genabc = trim(fgets($STDIN, 5));

if ($genabc == 'a' || $genabc == 'A') {
	$genabc = true;
} else {
	$genabc = false;
}

echo "Pouvat identifiktor zdroje [a/n]? ";
$idz = trim(fgets($STDIN, 5));

if ($idz == 'a' || $idz == 'A') {
	$idz = true;
} else {
	$idz = false;
}


$dkf =& new Dkf($genabc, $idz);

if ($odpoved == "a" || $odpoved == "A") {
	$dkf->read();
} elseif ($odpoved == "b" || $odpoved == "B") {
	echo "Nyn zadvejte jmna kolekc, kter chcete exportovat. ";
	echo "Kad jmno na zvltn dek. Zadvn ukonete tak, e";
	echo " stisknete enter na przdnm dku.\n";
	$colls=NULL;
	do {
		$odpoved = trim(fgets($STDIN, 4096));
		if ("$odpoved" != "")
			$colls[] = $odpoved;
	} while ("$odpoved" != "");
	$dkf->read_collections($colls);
}

$dkf->update();
//$dkf->show();
if ($argc == 2)
	$dir = $argv[1];
else
	$dir = "exp";
$dkf->export($dir);


fclose($STDIN);
?>
