<?php
require_once("convert_functions.php");


function generate($fname)
{
	$old_prefix = preg_replace('/(.*)\..\....$/', "\$1", $fname);
	$old_identifier = preg_replace('/.*\/([^\/]*)$/', "\$1", $old_prefix);

	convert($fname, $old_prefix . ".2.jpg", 480, 95);
	convert($old_prefix . ".2.jpg", $old_prefix . ".3.jpg", 120, 95);

}


for ($i=1; $i<$argc; $i++) {
	$fname = $argv[$i];
	if (! file_exists($fname))
		continue;
	
	generate($fname);
}
?>
