<?php
/* $Id: import_imgs.php,v 1.5.2.1 2006/03/20 11:37:29 krejvl Exp $ */

/*
 * importovani souboru do databaze
 */

require_once("pconnect_db.php3");
require_once("str_quote.php3");
require_once("cfg.php");

/*
 * nastavime scanovane rozliseni obrazku
 */
if (!isset($res) || "$res" == "")
	$res=600;

require_once("get_parent.php");


function gen_ident($coll, $folder)
{
	/*
	 * nastaveni promennych pro slozku, kolekci a fotku
	 */
	if (isset($folder)) {
		$TABLE_NAME="photos";
		$PREF_NAME="folders";
		$suff = "";
		$prefid = $folder;
		$preflen = 9;
		$len = 3;
	} else if (isset($coll)) {
		$suff = ".000";
		$TABLE_NAME="folders";
		$PREF_NAME="collections";
		$prefid = $coll;
		$preflen = 3;
		$len = 5;
	} else {
		$suff = "00000.000";
		$preflen = 0;
		$len = 3;
		$TABLE_NAME="collections";
	}
	/*
	 * pokud nezvysujeme primo prvni cast
	 * je treba zjistit prefix
	 */
	if (isset($prefid)) {
		$result = mysql_query("select identifier from $PREF_NAME where id=$prefid");
		if (! $result) {
			echo ("neni $prefid\n");
		}
		$line = mysql_fetch_row($result);
		$pref = substr($line[0], 0, $preflen);
		$WHERE = "where identifier like \"$pref%\"";
	} else {
		$WHERE = "";
	}
	/*
	 * vybereme posledni identifikator
	 */
	$query = "select identifier from $TABLE_NAME $WHERE order by identifier desc";
	$result = mysql_query($query);
	if ($result) {
		$rows = mysql_num_rows($result);
	} else {
		echo ("neni $prefid\n");
	}
	/*
	 * jedna se o prvni kolekci
	 */
	if ($rows == 0 && ! isset($prefid)) {
		return "00100000.000";
	} else if ($rows == 0) {
		/* jedna se o prvni objekt v nadrazenem */
		$number = 1;
	} else {
		/* jedna se o dalsi objekt, proto zjistime jaky mel cislo predchozi */
		$line = mysql_fetch_row($result);
		$number = (int)(substr($line[0], $preflen, $len));
		/* a zvysime o jednicku */
		$number = $number + 1;
	}
	/*
	 * doplnime cislo nulami
	 */
	$numstr = str_pad("$number", $len, "0", STR_PAD_LEFT);
	$ret = "$pref$numstr$suff";
	return $ret;
}

function photo_add_author($photo, $author)
{
	$insert_query = "insert into photo_author values('$photo', '$author')";
	$result = mysql_query($insert_query);
	if (! $result)
		die("$insert_query");
}


function photo_create($coll, $folder, $title, $publisher,
			$description, $identifier, $owner)
{
	$insert_query = "insert into photos values(0, 0, $owner, 0,
        '" . mysql_escape_string($title) . "', NOW(), NOW(), $owner, '" . mysql_escape_string($publisher) . "',
			 '$description', '$identifier', '', '')";
	$result = mysql_query($insert_query);
	if (! $result) die ($insert_query);

	$select_query = "select max(id) from photos where identifier='$identifier'";
	$result = mysql_query($select_query);
	if (! $result || mysql_num_rows($result)<=0) die($select_query);
	$line = mysql_fetch_row($result);
	mysql_free_result($result);
	$photo = $line[0];

	$insert_query = "insert into folder_photo values('$folder', '$photo')";
	$result = mysql_query($insert_query);
	if (! $result) die ($insert_query);

	return($photo);
}

function folder_create($coll, $title, $publisher,
			$description, $identifier, $owner)
{
	$insert_query = "insert into folders values(0, 0, $owner, 0,
			 '$title', NOW(), NOW(), $owner, '$publisher',
			 '$description', '$identifier', '', '')";
	$result = mysql_query($insert_query);
	if (! $result) die ("folder_create: $insert_query");

	$select_query = "select max(id) from folders where identifier='$identifier'";
	$result = mysql_query($select_query);
	if (! $result || mysql_num_rows($result)<=0) die($select_query);
	$line = mysql_fetch_row($result);
	mysql_free_result($result);
	$folder = $line[0];

	$insert_query = "insert into collection_folder values('$coll', '$folder')";
	$result = mysql_query($insert_query);
	if (! $result) die ($insert_query);

	return($folder);
}



function import_img ($img_prefix, $img_name, $author, $title, $description,
			$publisher, $dst_prefix, $coll, $folder, $owner)
{
	global $res, $PHP_PATH;
	$UNKNOWN = "not_known";
	$img_path = $img_prefix . "/" .$img_name;

	$size = getimagesize($img_path);
	$imtyp = ($size[2] == 1) ? "gif" :(
 		($size[2] == 2) ? "jpg" :(
		($size[2] == 3) ? "png" :(
		($size[2] == 4) ? "swf" :(
		($size[2] == 5) ? "psd" :(
			($size[2] == 6) ? "bmp" : "not_known")))));

	if ($imtyp == "not_known") { 
		return false;
	}
	$userfile_type = ($imtyp == "jpg") ? "image/jpeg" : (
			($imtyp == "png") ? "image/png" : "unknown");

	$identifier = gen_ident($coll, $folder);
	$photo = photo_create($coll, $folder, $title, $publisher,
				$description, $identifier, $owner);
	photo_add_author($photo, $author);

	$trgname = $identifier . ".0." . $imtyp;
	copy($img_path, $dst_prefix . "/tmp." . $trgname);

	if (isset($coll))
		$c = $coll;
	else
		$c = 0;
	if (isset($folder))
		$f = $folder;
	else
		$f = 0;
	if (isset($photo))
		$p = $photo;
	else
		$p = 0;


	$longer_side = '1024';
	exec("$PHP_PATH ext_ins_photo.php3 $trgname '$userfile_type' '0' $photo '$identifier' '$c' '$f' '$p' '$longer_side' 'insert_new' '$res'");
	return true;
}



function parse_file($fname, $img_prefix, $dst_prefix, $coll, $folder, $owner)
{
	if (! file_exists($fname))
		die("$fname neni souborem");

	$f = fopen($fname, "r");
	while (! feof($f)) {
		$line = trim(fgets($f, 4096));
		$cells = explode("#", $line);
		if ("$img_prefix" != "")
			$img_prefix .= "/";
		if (file_exists($img_prefix . $cells[0])) {
			import_img($img_prefix, $cells[0], $cells[1],
						$cells[2], $cells[3],
						$publisher, $dst_prefix,
						$coll, $folder, $owner);
		}
	}
	fclose($f);
}

function import_files()
{
	$stdin = fopen("php://stdin", "r");

	echo "zadejte nazev slozky do ktere maji byt fotky pridany: ";
	$nazev = trim(fgets($stdin, 4096));
	$fres = mysql_query("select id, title from folders where title like '%$nazev%'");
	$fline = mysql_fetch_row($fres);
	$folder = $fline[0];
	$coll = get_folder_coll($folder);
	
	echo "zadejte cestu k adresari img/ (vcetne): ";
	$cesta = trim(fgets($stdin, 4096));

	echo "zadejte cestu kde jsou obrazky: ";
	$obrazky = trim(fgets($stdin, 4096));

	echo "zadejte jmeno souboru s metadaty: ";
	$metafile = trim(fgets($stdin, 4096));

	echo "zadejte id vlastnika: ";
	$owner = trim(fgets($stdin, 4096));

	parse_file($metafile, $obrazky, $cesta, $coll, $folder, $owner);

}

function import_dir($dirname, $coll, $dest, $owner, $publisher, $author)
{
	if (! is_dir($dirname)) {
		echo("ERROR: $dirname neni adresar\n");
		return NULL;
	}
	if (! $coll) {
		die("ERROR: nebyla zadana spravna kolekce\n");
		return NULL;
	}

	$title = basename($dirname);
    $title = preg_replace('/_/', ' ', $title);
    $title = preg_replace('/(.*)-(.*)/e', "''.ucfirst('\\1').' - '.ucfirst('\\2')", $title);
#    $title[0] = strtoupper($title[0]);
    echo "$title\n";
	$description = "";
	$identifier = gen_ident($coll, $folder);
	$folder = folder_create($coll, $title, $publisher,
	                        $description, $identifier, $owner);
	
	$odir = opendir($dirname);
	if (! $odir)
		die("ERROR: nelze otevrit adresar $dirname\n");
	while ($file = readdir($odir)) {
		if (is_dir($file))
			continue;
		if ((preg_match('/\.jpg$/i', $file) or preg_match('/\.png$/i', $file)) and
	            (! preg_match('/^tn_/i', $file) and
	             ! preg_match('/^thumb_/i', $file))) {
            $img_title = preg_replace('/\.[^\.]+$/', "", $file);
			import_img($dirname, $file, $author, $img_title, "", $publisher, $dest, $coll, $folder, $owner);
		}

	}
}

function import_dirs()
{
	$stdin = fopen("php://stdin", "r");

	echo "zadejte nazev kolekce, do ktere maji byt fotky pridany: ";
	$nazev = trim(fgets($stdin, 4096));
	$cres = mysql_query("select id, title from collections where title like '%$nazev%'");
	$cline = mysql_fetch_row($cres);
	$coll = $cline[0];
	
	echo "zadejte cestu k adresari img/ (vcetne): ";
	$cesta = trim(fgets($stdin, 4096));

	echo "zadejte cestu kde jsou adresare: ";
	$obrazky = trim(fgets($stdin, 4096));

	echo "zadejte id vlastnika: ";
	$owner = trim(fgets($stdin, 4096));

	echo "publisher: ";
	$publisher = trim(fgets($stdin, 4096));

	echo "autor: ";
	$author = trim(fgets($stdin, 4096));

	$dirs_string = `find $obrazky -type d`;
	$dirs = explode("\n", trim($dirs_string));
	
	foreach ($dirs as $dir) {
		if ($dir != $obrazky) {
			echo $dir . "\n";
			import_dir($dir, $coll, $cesta, $owner, $publisher, $author);
		}
	}

}

/*
 * Funkce import_imgs_dir vezme zadany adresar s fotkami a vsechny tyto fotky 
 * vlozi do zadane slozky v DKF
 *
 */

function import_imgs_dir()
{
	$stdin = fopen("php://stdin", "r");

	echo "Zadejte identifikator slozky: ";
	$folder = trim(fgets($stdin, 4096));

	$result = mysql_query("select id, title from folders where identifier='$folder'");
	if (! $result) die ("Chyba databaze [1].\n");
	else if ((mysql_num_rows($result) == 0) || 
	 	(mysql_num_rows($result) > 1)) die("Slozka $folder neexistuje nebo jina chyba.\n");
	$fold_res = mysql_fetch_row($result);
	echo "Nazev slozky: $fold_res[1]\n";
	$folder = $fold_res[0];
	$coll = get_folder_coll($folder);
	echo "Id kolekce $coll\n";

	echo "Zadejte id uzivatele (vklada fotky): ";
	$user = trim(fgets($stdin, 4096));

	$result = mysql_query("select access_category from users where id='$user'");
	if (! $result) die ("Chyba databaze [2].\n");
	else if ((mysql_num_rows($result) == 0) || 
		(mysql_num_rows($result) > 1)) die("Uzivatel s id $user neexistuje nebo jina chyba.\n");
	$user_res= mysql_fetch_row($result);
	if ($user_res[0] != 4) die("Uzivatel $user neni administrator.\n");

	echo "Kdo publikuje: ";
	$publish = trim(fgets($stdin, 4096));

	echo "Adresar s obrazky: ";
	$dir = trim(fgets($stdin, 4096));

	$author="";
	$descr="";
	$dst="img/";

	if (is_dir($dir))
		if ($dd = opendir($dir)) {
			while ($ff = readdir($dd)) {
				$file_path = $dir."/".$ff;
				if (is_file($file_path)) {
					echo "Importing $ff ...";
					
					import_img ($dir, $ff, $author, $ff, $descr,
					            $publish, $dst, $coll, $folder, $user);
					
					echo " OK\n";
				}
			}
		}
		else die ("Nemohu otevrit $dir");
	else die("$dir neni adresarem");
		
}
?>
