<?php
require_once("convert_functions.php");


function regenerate($fname)
{
	$old_prefix = preg_replace('/(.*)\..\....$/', "\$1", $fname);
	$old_identifier = preg_replace('/.*\/([^\/]*)$/', "\$1", $old_prefix);

	convert($fname, $old_identifier . ".1.jpg", 1024);
	convert($fname, $old_identifier . ".2.jpg", 640);
	convert($fname, $old_identifier . ".3.jpg", 160);

}



for ($i=1; $i<$argc; $i++) {
	$fname = $argv[$i];
	if (! file_exists($fname))
		continue;
	
	regenerate($fname);
}
?>
