#include<stdio.h>
#include<ctype.h>
#include<string.h>

#include"common.h"

#define VERSION "0.2"

int main(int argc, char **argv) 
{   FILE *in, *out;
    char str[256];

    if (argc != 2) {
	puts("gen_icons <soubor>");
	puts("Vygeneruje html sablonu pro ikony ze seznamu v souboru <soubor>.");
	printf("Verze: %s\n", VERSION);
	return 0;
    }

    if ((in=fopen(argv[1], "r")) == NULL) {
	fprintf(stderr, "gen_icons: Nemohu otevrit soubor %s\n", argv[1]);
	return -1;
    }
    
    if ((out=fopen(PICS_FILE, "w")) == NULL) {
	fprintf(stderr, "gen_icons: Nemohu otevrit soubor %s\n", PICS_FILE);
	return -1;
    }
    
    begin_html(out, "Obrzky a ikony", GEN_PICS);
    
    while (fgets(str, 255, in) != NULL) {
	str[strlen(str)-1]='\0'; /* zahod konec radku */
	
	fprintf(out, "<IMG src=\"../%s\" alt=\"%s\"><BR>%s<HR>\n", str, str, str);
    }
    
    fprintf(out, "</TABLE>\n");
    end_html(out);

    if (fclose(in) == EOF) {
	fprintf(stderr, "gen_icons: Nemohu uzavrit soubor %s\n", argv[1]);
	return -1;
    }
    if (fclose(out) == EOF) {
	fprintf(stderr, "gen_icons: Nemohu uzavrit soubor %s\n", PICS_FILE);
	return -1;
    }
    printf("gen_pics: %s vygenerovan OK\n", PICS_FILE);
    
    return 0;
}


