CREATE TABLE photos (
	id INT UNSIGNED AUTO_INCREMENT NOT NULL PRIMARY KEY,
	access_category TINYINT UNSIGNED NOT NULL,
	owner INT UNSIGNED NOT NULL,
	typ TINYINT UNSIGNED NOT NULL,
	title VARCHAR(255) NOT NULL,
	created DATETIME NOT NULL,
	modified DATETIME NOT NULL,
	modifier INT UNSIGNED NOT NULL,
	publisher VARCHAR(255) NOT NULL,
	description TEXT NOT NULL,
	identifier CHAR(12) UNIQUE NOT NULL,
	creator VARCHAR(255),
    user_identifier VARCHAR(255),
	INDEX(title),
	INDEX(created),
	INDEX(title, identifier, id),
	INDEX(created, identifier, id)
);
