<?php
/* $Id: auth.php3,v 1.15.2.5 2007/04/11 09:05:20 petr Exp $ */



	if (! isset($PXM_REG_GLOB)) {

		$PXM_REG_GLOB = 1;

		if (! ini_get('register_globals')) {
			
			$getpostvars = array_merge($_POST, $_GET);

			foreach ($getpostvars as $key => $val) {

				if (! is_array($getpostvars[$key])) {
					global $$key;
					$$key = (get_magic_quotes_gpc()) ? $val : addslashes($val);
				}
				else {

					if (! is_array($getpostvars[$key][$val])) {
						global $$key; 
						$$key = array();

						foreach($getpostvars[$key] as $key2 => $val2) {
							array_push($$key, 
								(get_magic_quotes_gpc()) ? $val2 : addslashes($val2));
						}
					}
				}
			}

			$servercookievars = array_merge($_SERVER, $_COOKIE);

			foreach ($servercookievars as $key => $val) {
				global $$key;
				$$key = $val;
			}	
			
			if (isset($_SESSION) && $_SESSION != null && count($_SESSION) > 0) {
				foreach ($_SESSION as $key => $val) {
					global $$key;
					$$key = $val;
				}
			}
		}

	/*	
		if (! get_magic_quotes_gpc()) {
			foreach ($_POST as $key => $val) {
		if (! is_array($_POST[$key])) $_POST[$key] = addslashes($val);
				else {
					if (! is_array($_POST[$key][$val])) {
						foreach($_POST[$key] as $second_key => $second_val) {
							if (! is_array($_POST[$second_key])) $_POST[$key][$second_key] = addslashes($second_val);
						}
					}
				}
			}
			foreach ($_GET as $key => $val) { 
				if (! is_array($_GET[$key])) $_GET[$key]  = addslashes($val);
				else {
					if (! is_array($_GET[$key][$val])) {
						foreach($_GET[$key] as $second_key => $second_val) {
							if (! is_array($_GET[$second_key])) $_GET[$key][$second_key] = addslashes($second_val);
						}
					}
				}
			}
		}
	 */ 
	}


require_once("log.php");
require_once("functions.php");
require_once("error.php3");	/* definice chybovych hlasek */
require_once("cfg.php");	/* konfigurace systemu */
require_once("rights.php");	/* manipulace s pristupovymi pravy */
require_once("locale.php");	/* nastavi LC_CTYPE na cs_CZ */
require_once("lib/user.php");

include("get_preferences.php"); /* nacte nastaveni prihl. uzivatele z databaze, anonymnimu nastavi default */

/*
 * znemozneni includovani vice nez jednou
 */
if (! isset($AUTH_INCLUDE)) {
$AUTH_INCLUDE=1;

$EXPIRE_TIME = 900;	/* 15 minut -- je prevzato z SSLSessionCacheTimeout */
$sess = 0;		/* informace o aktualnim sezeni pro prihlasene uziv.*/
$anonym = NULL;		/* id anonymniho uzivatele z databaze */
$log_user_access_category = 0;
$update_query = 0;	/* SQL prikaz k upgradu tabulky sezeni */
$my_session = 0;	/* id sezeni */

require_once("pconnect_db.php3");
require_once("locks.php");	/* funkce pro praci se zamky na objektech */
require_once("get_parent.php"); /* funkce pro zjisteni prislusnosti objektu k rodici */


/*
 * funkce provadi autentifikaci -- rozpoznani uzivatele
 */
function auth()
{
	global $my_session, $REMOTE_ADDR, $update_query, $MY_HTTPS_ROOT, $HTTPS, $session;

	if (! $my_session)
		return 0;
	/*
	 * ziskani informaci o sezeni uzivatele
	 */
	$query = "select * from sess where id='$my_session'";
	$result = mysql_query($query);
	if (! $result || mysql_num_rows($result)<=0)
		return(0);
	$line = mysql_fetch_row($result);

	/*
	 * pokud je navazano sifrovane sezeni se spravnym pocitacem
	 */
	if (("$line[5]" === "$REMOTE_ADDR") && ("$HTTPS" === "on")){
		/*
		 * nastavime cas posledniho pristupu
		 */
		$result = mysql_query($update_query);
		if (! $result)
			return(0);

		/*
		 * pokud by se uzivatel pokusel pristupovat
		 * jinak nez pres sifrovany protokol,
		 * tak jej na nej prepni
		 */
		 #if (!isset($HTTPS) || "$HTTPS" != "on") {
		 #	header("Location: $MY_HTTPS_ROOT");
		 #}

		/*
		 * sezenim bylo rozpoznano a patri spravnemu
		 * uzivateli, proto muzeme vratit info o sezeni
		 */
		return($line);
	}

	return(0);
}

/*
 * tato funkce je skore zastarala je treba je upravit podle rights.php
 * -------------------------------------------------------------------
 * funkce provadi autorizaci -- overovani prav daneho uzivatele k necemu
 * uzivatel musi mit prava aspon $access
 */
function author($access)
{
	global $sess, $log_user_access_category;

	//die("--$access--$sess--");
	/*
	 * pokud se jedna o neprihlaseneho uzivatele
	 * a staci pravo pro pristu, tak rekni ze ano
	 * jinak pokud je pozadovano vyssi pravo
	 * a jedna se o anonyma, tak rekni ne
	 */
	if (! $sess && $access<=0)
		return(1);
	else if (! $sess)
		return(0);
	
	/*
	 * pokud nema uzivatel dostatecne opravneni,
	 * tak ne, jinak ano
	 */
	if ($log_user_access_category < $access)
		return(0);
	return(1);
}

/*
 * provede presmerovani na stranku pro prihlaseni
 * uzivatele
 */
function go_login()
{
	global $MY_HTTP_ROOT;
	header("Location: $MY_HTTP_ROOT/login.php3");
}

/*
 * pokud byl poslan cookie session a neni podvrzena pak
 * vytvor SQL prikaz pro upraveni informaci o sezeni
 * jako, cas posledniho pristupu a uprava timeoutu
 */


if (isset($_COOKIE) && isset($session) &&
    $_COOKIE["session"] == $session) {
	$my_session = $session;
	$update_query = "update sess set first=first, last=CURRENT_TIMESTAMP,
		 expire=CURRENT_TIMESTAMP + interval $EXPIRE_TIME second
			where id='$my_session'";
}

/*
 * zjisteni id anonymniho uzivatele
 */
$anon_query = "select id from users where nickname='anonym'";
$anon_result = mysql_query($anon_query);
if ($anon_result && ($anon_line=mysql_fetch_row($anon_result)))
	$anonym = $anon_line[0];

/*
 * pokud se nezjisti jinak, pak se uzivatel bude povazovat
 * za anonymniho
 */
$log_user = $anonym;
$user_obj = NULL;


/*
 * overime jestli byli spravne zadani rodice k objektu
 */
$real_folder = (isset($photo)) ? get_photo_folder($photo) : 0;
if (($real_folder != 0) && ("$real_folder" != "$folder"))
	die("neplatna kombinace indexu");
$real_coll = ($folder) ? get_folder_coll($folder) : 0;
if (($real_coll != 0) && ("$real_coll" != "$coll"))
	die("neplatna kombinace indexu");

$element = get_element($coll, $folder, $photo);

require_once("properties.php");
require_once('lib/schema.php');
$schema = NULL;
$coll_prop = get_properties($coll);
if ($coll_prop)
    $schema = new Schema($coll_prop->id_schema);

/*
 * pokud se nejedna o prvni prihlasovani tak over totoznost
 * a nastav $sess, $log_user jinak proved prihlaseni
 */
if (! isset($login) || "$login" !== "1") {
	$sess = auth();
	if ($sess)
		$log_user = $sess[1];
	/*
	 * ziskani pristupove kategorie uzivatele
	 */
	$log_ac_result = mysql_query("select access_category from users
					where id='$log_user'");
	if ($log_ac_result && mysql_num_rows($log_ac_result) > 0) {
		$log_ac_line = mysql_fetch_row($log_ac_result);
		$log_user_access_category = $log_ac_line[0];
	}

	if (! author(4)) {
		/*
		 * prava anonyma se tykaji i ostatnich
		 */

		$anon_rights_cache->load($anonym);

		/*
		 * prava pro daneho uzivatele (prepise pripadne prava nastavena anonymem)
		 */
		if ($log_user != $anonym) {
			$rights_cache->load($log_user);
			foreach($rights_cache->usr_cll as $klic => $el) {
				$str.="[$klic]>$el,";
			}
//			loguj($log_user ." nahrana rights_cache: ".$str);
		}
	}
} else {
	/*
	 * overeni hesla a existence prihlasovaneho uzivatele
	 */
	$query = "select * from users where (nickname='$nickname') and (active=true) and (password=MD5('$passwd'))";
	$result = mysql_query($query);
	if (! $result || mysql_num_rows($result) <= 0)
		die("nelze se pihlsit");
	$line = mysql_fetch_row($result);

	/*
	 * zjisteni jestli se nepokousi prihlasit znovu
	 * jiz prihlaseny uzivatel a pokud ano,
	 * tak proved upgrade sessiony
	 */
	$result = mysql_query("select * from sess
				where (id_user='$line[0]') and
				      (id='$my_session')");
	if ($result && mysql_num_rows($result) <= 0)
		$result = 0;
	if ($result) {
		$result = mysql_query($update_query)
			or die("nelze se znovu prihlasit");
	} else {
		/*
		 * vytvoreni nove seesion
		 * jako id bude $SSL_SESSION_ID
		 * dale se uklade id uzivatele, cas prihlaseni
		 * cas posledniho pristupu, timeout, a ip adresa
         */
        #$ses_id = $_SERVER["SSL_SESSION_ID"];
        $time_tmp = time();
        $ses_id = md5("$line[0] $REMOTE_ADDR $time_tmp");
		$query = "insert into sess values(
			'$ses_id', '$line[0]',
			CURRENT_TIMESTAMP, CURRENT_TIMESTAMP,
			CURRENT_TIMESTAMP + interval $EXPIRE_TIME second,
			'$REMOTE_ADDR')";
		$result = mysql_query($query) ||
			die("nelze vytvorit novou session");

		/*
		 * vse zrejme probehlo dobre tak posleme SSL_SESSION_ID jako id
		 * nasi session
		 */
			
				SetCookie("session", "$ses_id");
	}

	/*
	 * prihlaseneho uzivatele presmerujeme
	 * na jeho domovskou stranku
	 */
	Header("Location: user.php3");
}

/*
 * pokud se po nas zada prace se zamky
 */
if ("$lock" != "") {
	if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT))
		die("$log_user: $NO_AUTHOR");
	switch ($lock) {
		case 0 :
			del_lock($coll, $folder, $photo);
			break;
		case 1 : 
			set_lock($coll, $folder, $photo);
			break;
		default :
			break;
	}
}

/*
 * konec ochrany pro vicenasobne vlozeni
 */
}
?>
