<?php

require_once("auth.php3");
require_once("locks.php");
require_once("dkf_index.php");

/*
 * pokud nema uzivatel pravo k editaci objektu, pak tady nema co delat
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT))
	die($NO_AUTHOR);

/*
 * pro pripad, ze by se snazil editovat nekdo neco, co neni
 */
if (!isset($coll) || "$coll" == "")
	die($UNKNOWN_COLL);

if (! isset($cp_to))
	die("nebylo zadano kam se ma objekt kopirovat");

if (strlen($cp_to) != 12)
	die("spatny identifikator");

/*
 * zkontrolujeme jestli je nastaven zamek. pokud neni, pak tato funkce byla
 * volana na nezamceny objekt a proto konec
 */
if (! get_lock($coll, $folder, $photo))
	die("objekt není zamčen");

if (isset($photo)) {
	$TABLE_NAME = "photos";
	$PARENT_TABLE = "folders";
	$ID_NAME = "id_photo";
	$ID_PARENT = "id_folder";
	$PAR_CUR = "folder_photo";
	$id = $photo;
} elseif (isset($folder)) {
	$TABLE_NAME = "folders";
	$PARENT_TABLE = "collections";
	$ID_NAME = "id_folder";
	$PAR_CUR = "collection_folder";
	$ID_PARENT = "id_collection";
	$id = $folder;
} else {
	die("spatne zadane parametry");
}


/*
 * rozparsovani noveho identifikatoru
 *
$coll_ident = substr($cp_to, 0, 3);
$fold_ident = substr($cp_to, 3, 5);
$photo_ident = substr($cp_to, 9, 3);

echo "$coll_ident, $fold_ident, $photo_ident";
*/

$query = "select id from $PARENT_TABLE where identifier='" . mysql_escape_string($cp_to) . "'";
$result = mysql_query($query);
if (! $result || mysql_num_rows($result) <=0)
	die("Nelze nalezt cilový objetk s identifikátorem $cp_to. Zkontrolujte jestli přesouváte fotku do složky nebo složku do kolekce, všechny ostatní možnosti nejsou správné.");
$line = mysql_fetch_row($result);
$new_par = $line[0];


$old_coll = $coll;
$old_folder = $folder;
$old_photo = $photo;

if ("$TABLE_NAME" == "photos") {
	require_once("get_parent.php");
	$photo=NULL;
	$folder=$new_par;
	$coll=get_folder_coll($folder);
	if ($coll == -1)
		die("nepodarilo se zjistit nadrazenou kolekci ke slozce $new_par");
} elseif ("$TABLE_NAME" == "folders") {
	$photo=NULL;
	$folder=NULL;
	$coll = $new_par;
} else {
	die ("tento objekt nelze presunout: $TABLE_NAME");
}

require_once("gen_ident.php3");
$new_ident = gen_ident($coll, $folder, $photo);

/*
 * uzivatel musi mit pravo zapisovat a pridavat do ciloveho objektu
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT) ||
    ! check_obj_rights($log_user, $coll, $folder, $photo, $ADD_RIGHT))
	die($NO_AUTHOR);


/*
 *
 */
function copy_object($PAR_CUR, $ID_PARENT, $ID_NAME, $TABLE_NAME, $old_coll, $old_folder, $old_photo, $coll, $folder, $id, $new_ident, $new_par)
{
	global $log_user;
	$base = preg_replace('/(.*)s$/', '$1', $TABLE_NAME);
	$query = "select * from $TABLE_NAME where id=$id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_object: nejde zjistit info o $id z $TABLE_NAME");
	$line = mysql_fetch_row($result);
	$query = "insert into $TABLE_NAME values(0," .
				"'" . mysql_escape_string($line[1]) . "'," .
				"'" . mysql_escape_string($log_user) . "'," .
				"'" . mysql_escape_string($line[3]) . "'," .
				"'" . mysql_escape_string($line[4]) . "'," .
				"NOW()," .
				"NOW()," .
				"'" . mysql_escape_string($log_user) . "'," .
				"'" . mysql_escape_string($line[8]) . "'," .
				"'" . mysql_escape_string($line[9]) . "'," .
				"'" . mysql_escape_string($new_ident) . "'," .
				"'" . mysql_escape_string($line[11]) . "'," .
				"'" . mysql_escape_string($line[12]) . "')";

	$result = mysql_query($query);
	if (! $result)
		die("copy_object: nejde pridat novy objekt do $TABLE_NAME\n");
	$query = "select max(id) from $TABLE_NAME where identifier='$new_ident'";
	$result = mysql_query($query);
	if (! $result)
		die("copy_object: nenalezen pridany objekt");
	$line_id = mysql_fetch_row($result);
	$new_id = $line_id[0];


	$query = "insert into $PAR_CUR values($new_par, $new_id)";
	$result = mysql_query($query);
	if (! $result)
		die("copy_object: nepodarilo se propojit novy objekt s rodicem\n");
	/*
	 * naindexujeme
	 */
	$db_id = dkf_index_open("wd");
	if ($db_id == FALSE)
		die("nelze naindexovat");
	$custom = create_custom($TABLE_NAME, $new_id);
	naindexuj($line[4], $TABLE_NAME, 'title', $custom, $new_id, $db_id);
	naindexuj($line[9], $TABLE_NAME, 'description', $custom, $new_id, $db_id);
	naindexuj($line[10], $TABLE_NAME, 'identifier', $custom, $new_id, $db_id);
	naindexuj($line[12], $TABLE_NAME, "user_identifier", $custom, $new_id, $db_id);
	dkf_index_close($db_id);

	/*
	 * copy subjects
	 */
	$query = "select * from ${base}_subject where $ID_NAME=$id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o subjektech pro $id v $TABLE_NAME");

	$db_id = dkf_index_open("wd");
	if ($db_id == FALSE)
		die("nelze naindexovat");
	$custom = create_custom("${base}_subject", $new_id);
	while ($line = mysql_fetch_row($result)){
		$ins_query = "insert into ${base}_subject values($new_id, '" . mysql_escape_string($line[1]) . "')";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat subjekty");
	    naindexuj($line[1], "${base}_subject", 'subject', $custom, $new_id, $db_id);
	}
	dkf_index_close($db_id);

	/*
	 * copy medailonky
	 */
    if ($base == 'folder') {
    	$db_id = dkf_index_open("wd");
	    if ($db_id == FALSE)
		    die("nelze naindexovat");
    	$custom = create_custom("medailonek", $new_id);
    	$query = "select * from medailonek where $ID_NAME=$id";
	    $result = mysql_query($query);
    	if (! $result)
	    	die("copy_ojbect: nepodarilo se ziskat info o medailonkach pro $id v medailonek: $query");
    	while ($line = mysql_fetch_row($result)){
	    	$ins_query = "insert into medailonek values($new_id, '" . mysql_escape_string($line[1]) . "')";
		    $ins_res = mysql_query($ins_query);
    		if (! $ins_res)
	    		die ("copy_object: nepodarilo se prekopirovat medailonky: $query");
	        naindexuj($line[1], "medailonek", 'description', $custom, $new_id, $db_id);
    	}
	    dkf_index_close($db_id);
    }
	
	/*
	 * copy poznamky
	 */
	$query = "select * from ${base}_note where $ID_NAME=$id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o poznamkach pro $id v $TABLE_NAME");
	while ($line = mysql_fetch_row($result)){
		$ins_query = "insert into ${base}_note values($new_id, '" . mysql_escape_string($line[1]) . "')";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat poznamky");
	}

	/*
	 * copy pusobiste
	 */
	$query = "select coverage.* from coverage_${base}, coverage where coverage_${base}.$ID_NAME=$id and coverage_${base}.id_coverage=coverage.id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o pusobistich pro $id v $TABLE_NAME");
	while ($line = mysql_fetch_row($result)){
		$ins_query = "insert into coverage values(0," .
				 "'" . mysql_escape_string($line[1]) . "'," .
				 "'" . mysql_escape_string($line[2]) . "'," .
				 "'" . mysql_escape_string($line[3]) . "')";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat pusobiste: $ins_query");
		$ins_query = "select max(id) from coverage where " .
			"title='" . mysql_escape_string($line[1]) . "' and " .
			"place='" . mysql_escape_string($line[2]) . "' and " .
			"datum='" . mysql_escape_string($line[3]) . "'";
		$ins_result = mysql_query($ins_query);
		if (! $ins_result)
			die ("copy_object: nepodarilo se zjistit id vlozeneho pusobiste");
		$ins_line = mysql_fetch_row($ins_result);
		$ins_query = "insert into coverage_${base} values($new_id, $ins_line[0])";
		$ins_result = mysql_query($ins_query);
		if (! $ins_result)
			die ("copy_object: nepodarilo se propojit vlozene pusobiste $ins_line[0] pro $TALBE_NAME $id");
		/*
		 * naindexujeme
		 */
		$db_id = dkf_index_open("wd");
		if ($db_id == FALSE)
			die("nelze naindexovat coverage\n");
		$custom = create_custom("coverage", $ins_line[0]);
		naindexuj($line[2], "coverage", 'place', $custom, $ins_line[0], $db_id);
		naindexuj($line[3], "coverage", 'date', $custom, $ins_line[0], $db_id);
		dkf_index_close($db_id);
	}

	/*
	 * copy source
	 */
	$query = "select source.* from ${base}_source, source where ${base}_source.$ID_NAME=$id and ${base}_source.id_source=source.id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o zdrojich pro $id v $TABLE_NAME");
	while ($line = mysql_fetch_row($result)){
		$ins_query = "insert into source values(0," .
				 "'" . mysql_escape_string($line[1]) . "'," .
				 "'" . mysql_escape_string($line[2]) . "'," .
				 "'" . mysql_escape_string($line[3]) . "'," .
				 "'" . mysql_escape_string($line[4]) . "')";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat zdroj: $ins_query");
		$ins_query = "select max(id) from source where " .
			"typ='" . mysql_escape_string($line[1]) . "' and " .
			"created='" . mysql_escape_string($line[2]) . "' and " .
			"collection='" . mysql_escape_string($line[3]) . "' and " .
			"shellfref='" . mysql_escape_string($line[4]) . "'";
		$ins_result = mysql_query($ins_query);
		if (! $ins_result)
			die ("copy_object: nepodarilo se zjistit id vlozeneho zdroje");
		$ins_line = mysql_fetch_row($ins_result);
		$ins_query = "insert into ${base}_source values($new_id, $ins_line[0])";
		$ins_result = mysql_query($ins_query);
		if (! $ins_result)
			die ("copy_object: nepodarilo se propojit vlozeny zdroj  $ins_line[0] pro $TALBE_NAME $id");
		/*
		 * naindexujeme
		 */
		$db_id = dkf_index_open("wd");
		if ($db_id == FALSE)
			die("nelze naindexovat source\n");
		$custom = create_custom("source", $ins_line[0]);
		naindexuj($line[4], "source", "shellfref", $custom, $ins_line[0], $db_id);
		dkf_index_close($db_id);
	}


    if ($base == "photo" || $base == "folder") {
	    /*
    	 * copy author
	     */
        $AUTHOR_NAME = "folder_author";
        if ($base == "photo") {
            $AUTHOR_NAME = "photo_author";
        }
    	$query = "select * from $AUTHOR_NAME where id=$id";
	    $result = mysql_query($query);
    	if (! $result)
	    	die("copy_ojbect: nepodarilo se ziskat info o autorech pro $id v $TABLE_NAME");
    	while ($line = mysql_fetch_row($result)){
	    	$ins_query = "insert into $AUTHOR_NAME values($new_id, '" . mysql_escape_string($line[1]) . "')";
		    $ins_res = mysql_query($ins_query);
    		if (! $ins_res)
	    		die ("copy_object: nepodarilo se prekopirovat autory");
    	}
    }

	/*
	 * pokud jsme nekopirovali fotku, tak muzem skoncit
	 */
	if ($base != "photo")
		return $new_id;

   /*
	* jinak musime prekopirovat jeste par tabulek a vsechny instance;
   	*/

	/*
	 * copy photo_size
	 */
	$query = "select * from photo_size where id=$id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o velikosti delsi strany pro $id v $TABLE_NAME");
	while ($line = mysql_fetch_row($result)){
		$ins_query = "insert into photo_size values($new_id, '" . mysql_escape_string($line[1]) . "')";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat velikost delsi strany");
	}

	/*
	 * copy photo_machine
	 */
	$query = "select * from photo_machine where id=$id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_object: nepodarilo se ziskat info o digitalizacnich zarizenich  pro $id v $TABLE_NAME");
	while ($line = mysql_fetch_row($result)){
		$ins_query = "insert into photo_machine values($new_id, '" . mysql_escape_string($line[1]) . "', " . mysql_escape_string($line[2]) . ")";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat digitalizacni zarizeni");
	}

	/*
	 * copy photo_instance
	 */
	$query = "select instance.* from photo_instance, instance where photo_instance.$ID_NAME=$id and photo_instance.id_instance=instance.id";
	$result = mysql_query($query);
	if (! $result)
		die("copy_ojbect: nepodarilo se ziskat info o instancich pro $id v $TABLE_NAME");
	while ($line = mysql_fetch_row($result)){
		$pripona = preg_replace('/.*\.(.*)$/', '.$1', $line[4]);
/*		if ($line[1] == 0)
			$new_filename = $new_ident . $pripona;
		else*/
			$new_filename = $new_ident . ".$line[1]" . $pripona;
		if (file_exists("img/$line[4]"))
			if (! copy("img/$line[4]", "img/$new_filename"))
				die("nepodarilo se zkopirovat soubor $line[4] do $new_filename");

		$ins_query = "insert into instance values(0," .
				 "'" . mysql_escape_string($line[1]) . "'," .
				 "'" . mysql_escape_string($line[2]) . "'," .
				 "'" . mysql_escape_string($line[3]) . "'," .
				 "'" . mysql_escape_string($new_filename) . "'," .
				 "'" . mysql_escape_string($line[5]) . "')";
		$ins_res = mysql_query($ins_query);
		if (! $ins_res)
			die ("copy_object: nepodarilo se prekopirovat instanci");
		$ins_query = "select max(id) from instance where " .
			"num='" . mysql_escape_string($line[1]) . "' and " .
			"format='" . mysql_escape_string($line[2]) . "' and " .
			"file_size='" . mysql_escape_string($line[3]) . "' and " .
			"file_name='" . mysql_escape_string($new_filename) . "' and " .
			"check_sum='" . mysql_escape_string($line[5]) . "'";
		$ins_result = mysql_query($ins_query);
		if (! $ins_result)
			die ("copy_object: nepodarilo se zjistit id vlozene instance ");
		$ins_line = mysql_fetch_row($ins_result);
		$ins_id = $ins_line[0];
		$ins_query = "insert into photo_instance values($new_id, $ins_id)";
		$ins_result = mysql_query($ins_query);
		if (! $ins_result)
			die ("copy_object: nepodarilo se propojit vlozenou instanci $ins_line[0] pro $TALBE_NAME $id");

		$im_query = "select image.* from instance_image, image where instance_image.id_instance=$line[0] and instance_image.id_image=image.id";
		$im_result = mysql_query($im_query);
		if (! $im_result)
			die("copy_object: nepodarilo se zkopirovat images\n");
		while ($im_line = mysql_fetch_row($im_result)) {
			$imcp_query = "insert into image values (0," .
				"'$im_line[1]'," .
				"'$im_line[2]'," .
				"'$im_line[3]'," .
				"'$im_line[4]'," .
				"'" . mysql_escape_string($im_line[5]) . "'," .
				"'$im_line[6]'," .
				"'" . mysql_escape_string($im_line[7]) . "')";
			$imcp_result = mysql_query($imcp_query);
			if (! $imcp_result)
				die("copy_object: nepodarilo se vlozit nove images\n");
			$imcp_query = "select max(id) from image where " .
				"orientation='$im_line[1]' and " .
				"resolution='$im_line[2]' and " .
				"dim_horizontal='$im_line[3]' and " .
				"dim_vertical='$im_line[4]' and " .
				"compression='" . mysql_escape_string($im_line[5]) . "' and " .
				"bit_depth='$im_line[6]' and " .
				"color_mode='" . mysql_escape_string($im_line[7]) . "'"; 
			$imcp_result = mysql_query($imcp_query);
			if (! $imcp_result)
				die("copy_object: nepodarilo se zjistit id vlozeneho image: $imcp_query\n");
			$imcp_line = mysql_fetch_row($imcp_result);

			/*
			 * propojeni image s instanci
			 */
			$imcp_query = "insert into instance_image values($ins_id, $imcp_line[0])";
			$imcp_result = mysql_query($imcp_query);
			if (! $imcp_result)
				die("copy_object: nepodarilo se provazat instanci a image\n");
		}
	}

	return $new_id;
}

/*
 * kopirovani objektu
 */
$new_id = copy_object($PAR_CUR, $ID_PARENT, $ID_NAME, $TABLE_NAME, $old_coll, $old_folder, $old_photo, $coll, $folder, $id, $new_ident, $new_par);

if ("$TABLE_NAME" == "photos")
	$redir = "coll=$coll&folder=$folder&photo=$new_id";
elseif ("$TABLE_NAME" == "folders")
	$redir = "coll=$coll&folder=$new_id";

/*
 * jestlize kopirujeme slozku, tak musime taky zkopirovat fotky
 */
if ("$TABLE_NAME" == "folders") {
	$folder = $new_id;
	$query = "select * from folder_photo where id_folder=$old_folder";
#	echo $query;
	$result = mysql_query($query);
	if (! $result)
		die("chyba pri zjistovani potomku slozky $folder");
	while ($line = mysql_fetch_row($result)) {
		$new_ident = gen_ident($coll, $folder, $photo);
		$new_photo = copy_object("folder_photo", "id_folder", "id_photo", "photos", $old_coll, $old_folder, $old_photo, $coll, $folder, $line[1], $new_ident, $new_id);
	}
}


$coll = $old_coll;
$folder = $old_folder;
$photo = $old_photo;


header("Location: edit_folder.php3?$redir");

?>
