<?php
/* $Id: edit_obj_rights.php,v 1.8.2.2 2007/04/06 12:44:05 petr Exp $ */

/*
 * editor pristupovych prav k objektu
 */
$PAGE_ID='rights';

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require("obj_rights_name.php"); /* nastaveni jmen tabulek pro prava v zavislosti na objektu */

if (! check_obj_rights($log_user, $coll, $folder, $photo, $ALL_ADMIN_OBJ))
	die($NO_AUTHOR);

require_once("pconnect_db.php3");
$is_rights=1; /* kvuli (ne)zobrazovani navigacnich ikon */
/*
 * zacatek generovani html kodu
 */
require("start_html.php3");

/*
 * pomocna funkce pro pole formulare checkbox
 */
function is_checked($rights, $mask) {
	return ($rights & $mask) ? "checked" : "";
}

/*
 * sprava prav uzivatelu daneho objektu
 */
echo "<br><b>Sprva uivatel</b><br>";
if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_USER_OBJ_RIGHT | $DEL_USR_RIGHT)) {
	/*
	 * vytvoreni seznamu uzivatelu pri danem objektu
	 */
	 $user_list_query = "select $obj_rights_name.*, users.nickname from $obj_rights_name left join users on $obj_rights_name.id_user=users.id where $obj_id_name='$obj_id' order by users.nickname";
	 $user_list_result = mysql_query($user_list_query);
	 if ($user_list_result) {
	 	/*
		 * vytvoreni formulare pro editaci prav uzivatelu k objektu
		 */
		echo "<form action=\"change_usr_obj.php\" method=\"get\">";
		echo "<table border=1 cellpadding=11>";
		echo "<b><tr><td colspan=2 rowspan=3>Uivatel</td>\n";
		echo "<td colspan=8 align=\"center\">Prva pro</td></tr>\n";
		echo "<tr><td colspan=4 align=\"center\">prci s objektem</td>";
		echo "<td colspan=4 align=\"center\">administraci objektu</td>";
		echo "<tr><td>ten</td><td>editace</td><td>pidn</td><td>mazn</td>";
		echo "<td>pidn uivatel</td><td>editace prv</td>";
		echo "<td>mazn uivatel</td>\n";
		echo "<td>archivn soubor</td></b></tr>\n";
		$i = 0;
		/*
		 * vypis vsech uzivatelu do tabulky a jednotliva prava zobrazena skrz checkboxy
		 */
	 	while ($user_line = mysql_fetch_row($user_list_result)) {
			echo "<input type=\"hidden\" name=\"usr_obj[$i][0]\" value=$user_line[0]>\n";
			echo "<tr><td><input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][1]\" value=$user_line[0]></td>\n";
			echo "<td>" . htmlspecialchars($user_line[3], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "</td>";
			echo "<td>";
			$checked = is_checked($user_line[2], $READ_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][2]\" value=$READ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $EDIT_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][3]\" value=$EDIT_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $ADD_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][4]\" value=$ADD_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $DEL_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][5]\" value=$DEL_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $ADD_USR_OBJ_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][6]\" value=$ADD_USR_OBJ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $EDIT_USR_OBJ_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][7]\" value=$EDIT_USR_OBJ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $DEL_USR_OBJ_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][8]\" value=$DEL_USR_OBJ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($user_line[2], $ARCHIV_RIGHT);
			echo "<input type=\"checkbox\" class=\"check\" name=\"usr_obj[$i][9]\" value=$ARCHIV_RIGHT $checked>\n";
			echo "</td></tr>\n";
			$i++;
		}
		echo "</table>\n";
		/*
		 * nutno predat pozici pri odesilani formulare
		 */
		if ("$coll" != "") {
			echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
			if ("$folder" != "") {
				echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
				if ("$photo" != "")
					echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
			}
		}
		echo "<input type=\"submit\" name=\"save\" value=\"Uloit zmny\">";
		echo "<input type=\"submit\" name=\"savemark\" value=\"Uloit zmny pouze u oznaench uivatel\">";
		/*
		 * pro uzivatele majici pravo mazani objetku zobrazime mazaci talcitku
		 */
		if (check_obj_rights($log_user, $coll, $folder, $photo, $DEL_USR_OBJ_RIGHT)) {
			echo "<br><input type=\"submit\" name=\"delete\" value=\"Vyjmout oznaen uivatele z objektu\">";
		}
		echo "</form>";
	} 
}

/*
 * seznam uzivatelu k pridani
 * -- takovi uzivatele, kteri jeste nejsou ve skupine
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $ADD_USR_OBJ_RIGHT)) {
	$user_list_query = "select users.id, users.nickname from users left join $obj_rights_name on $obj_rights_name.id_user=users.id and $obj_rights_name.$obj_id_name='$obj_id' where $obj_rights_name.$obj_id_name is null order by users.nickname";
	$user_list_result = mysql_query($user_list_query);
	if (! $user_list_result)
		die("nelze vytvorit seznam uzivatelu, kteri nejsou pri objektu");
	echo "<form action=\"insert_usr_obj.php\" method=\"get\">";
	echo "Pidat uivatele ";
	echo "<select name=\"new_usr_obj\" size=1>\n";
	while ($user_line = mysql_fetch_row($user_list_result)) {
		echo "<option value=$user_line[0]>" . htmlspecialchars($user_line[1], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\n";
	}
	echo "</select>";
	if ("$coll" != "") {
		echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
		if ("$folder" != "") {
			echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
			if ("$photo" != "")
				echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
		}
	}
	echo " <input type=\"submit\" name=\"add\" value=\"Pidat uivatele k objektu\">";
	echo "</form>";
}


/*
 * sprava prav skupin daneho objektu
 */
echo "<br><b>Sprva skupin</b><br>";
if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_USER_OBJ_RIGHT | $DEL_USR_RIGHT)) {
	 $grp_list_query = "select $obj_grp_rights_name.*, groups.name from $obj_grp_rights_name left join groups on $obj_grp_rights_name.id_group=groups.id where $obj_id_name='$obj_id' order by groups.name";
	 $grp_list_result = mysql_query($grp_list_query);
	 if ($grp_list_result) {
	 	/*
		 * formular pro editaci prav skupin k danemu objektu
		 */
		echo "<form action=\"change_grp_obj.php\" method=\"get\">";
		echo "<table border=1 cellpadding=11>";
		echo "<b><tr><td colspan=2 rowspan=3>Skupina</td>\n";
		echo "<td colspan=7 align=\"center\">Prva pro</td></tr>\n";
		echo "<tr><td colspan=4 align=\"center\">prci s objektem</td>";
		echo "<td colspan=3 align=\"center\">administraci objektu</td>";
		echo "<tr><td>ten</td><td>editace</td><td>pidn</td><td>mazn</td>";
		echo "<td>pidn skupin</td><td>editace prv</td>";
		echo "<td>mazn skupin</td></b></tr>\n";
		$i = 0;
		/*
		 * vypis vsech skupin
		 */
	 	while ($grp_line = mysql_fetch_row($grp_list_result)) {
			echo "<input type=\"hidden\" name=\"grp_obj[$i][0]\" value=$grp_line[0]>\n";
			echo "<tr><td><input type=\"checkbox\" name=\"grp_obj[$i][1]\" value=$grp_line[0]></td>\n";
			echo "<td>" . htmlspecialchars($grp_line[3], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "</td>";
			echo "<td>";
			$checked = is_checked($grp_line[2], $READ_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][2]\" value=$READ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($grp_line[2], $EDIT_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][3]\" value=$EDIT_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($grp_line[2], $ADD_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][4]\" value=$ADD_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($grp_line[2], $DEL_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][5]\" value=$DEL_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($grp_line[2], $ADD_USR_OBJ_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][6]\" value=$ADD_USR_OBJ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($grp_line[2], $EDIT_USR_OBJ_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][7]\" value=$EDIT_USR_OBJ_RIGHT $checked>\n";
			echo "</td><td>\n";
			$checked = is_checked($grp_line[2], $DEL_USR_OBJ_RIGHT);
			echo "<input type=\"checkbox\" name=\"grp_obj[$i][8]\" value=$DEL_USR_OBJ_RIGHT $checked>\n";
			echo "</td></tr>\n";
			$i++;
		}
		echo "</table>\n";
		/*
		 * nutno predat pozici
		 */
		if ("$coll" != "") {
			echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
			if ("$folder" != "") {
				echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
				if ("$photo" != "")
					echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
			}
		}
		echo "<input type=\"submit\" name=\"save\" value=\"Uloit zmny\">";
		echo "<input type=\"submit\" name=\"savemark\" value=\"Uloit zmny pouze u oznaench skupin\">";
		if (check_obj_rights($log_user, $coll, $folder, $photo, $DEL_USR_OBJ_RIGHT)) {
			echo "<br><input type=\"submit\" name=\"delete\" value=\"Vyjmout oznaen skupiny z objektu\">";
		}
		echo "</form>";
	} 
}

/*
 * seznam skupin k pridani
 * -- takovi uzivatele, kteri jeste nejsou ve skupine
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $ADD_USR_OBJ_RIGHT)) {
	$grp_list_query = "select groups.id, groups.name from groups left join $obj_grp_rights_name on $obj_grp_rights_name.id_group=groups.id and $obj_grp_rights_name.$obj_id_name='$obj_id' where $obj_grp_rights_name.$obj_id_name is null order by groups.name";
	$grp_list_result = mysql_query($grp_list_query);
	if (! $grp_list_result)
		die("nelze vytvorit seznam skupine, kteri nejsou pri objektu");
	echo "<form action=\"insert_grp_obj.php\" method=\"get\">";
	echo "Pidat skupinu ";
	echo "<select name=\"new_grp_obj\" size=1>\n";
	while ($grp_line = mysql_fetch_row($grp_list_result)) {
		echo "<option value=$grp_line[0]>" . htmlspecialchars($grp_line[1], $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "\n";
	}
	echo "</select>";
	if ("$coll" != "") {
		echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
		if ("$folder" != "") {
			echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
			if ("$photo" != "")
				echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
		}
	}
	echo " <input type=\"submit\" name=\"add\" value=\"Pidat skupinu k objektu\" />";
	echo "</form>";
}

/*
 * sprava prav ip adres daneho objektu
 */
echo "<br><b>Sprva IP adres</b><br>";
if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_USER_OBJ_RIGHT | $DEL_USR_RIGHT)) {
	$ip_order_query = "select $obj_ip_order_name.* from $obj_ip_order_name where $obj_id_name='$obj_id'";
	$ip_order_res = mysql_query($ip_order_query);
	if ($ip_order_res && (mysql_num_rows($ip_order_res) > 0))
		$ip_order = mysql_fetch_row($ip_order_res);
	else
		$ip_order = 0;
	$ip_list_query = "select $obj_ip_rights_name.* from $obj_ip_rights_name where $obj_id_name='$obj_id' order by ip, mask";
	$ip_list_result = mysql_query($ip_list_query);
	if ($ip_list_result) {
		if ($ip_order) {
			$checked1 = is_checked($ip_order[1], 1);
			$checked2 = is_checked($ip_order[1], 2);
		} else {
			$checked1 = "";
			$checked2 = "checked";
		}
	 	/*
		 * vytvoreni formulare pro editaci prav ip adres k danemu objektu
		 */
		echo "<form action=\"change_ip_obj.php\" method=\"get\">";
		echo "<input type=\"radio\" class=\"check\" name=\"ip_order\" value=1 $checked1>";
		echo " pstup je <b>zkzn pro vechny</b> mimo ne vypsanch, kterm je povolen<br>";
		echo "<input type=\"radio\" class=\"check\" name=\"ip_order\" value=2 $checked2>";
		echo " pstup je <b>povolen pro vechny</b> mimo ne vypsanch, kterm je zakzn<br>";
		echo "<input type=\"submit\" name=\"save\" value=\"Uloit zmny\"><br><br>";

		echo "<table border=1 cellpadding=11>";
		echo "<b><tr><td colspan=2 align=\"center\">IP</td>\n";
		echo "<td align=\"center\">Maska</td></tr>\n";
		$i = 0;
		/*
		 * vypis vsech ip adres
		 */
	 	while ($ip_line = mysql_fetch_row($ip_list_result)) {
			echo "<input type=\"hidden\" name=\"ip_obj[$i][0]\" value=$ip_line[0]>\n";
			echo "<tr><td><input type=\"checkbox\" name=\"ip_obj[$i][1]\" value=$ip_line[0]></td>\n";
			echo "<td>" . htmlspecialchars(long2ip($ip_line[2]), $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "</td>";
			echo "<td>" . htmlspecialchars(long2ip($ip_line[3]), $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "</td>";
			echo "</tr>\n";
			$i++;
		}
		echo "</table>\n";
		/*
		 * pri poslani formulare musime predat pozici
		 */
		if ("$coll" != "") {
			echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
			if ("$folder" != "") {
				echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
				if ("$photo" != "")
					echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
			}
		}
		if (check_obj_rights($log_user, $coll, $folder, $photo, $DEL_USR_OBJ_RIGHT)) {
			echo "<input type=\"submit\" name=\"delete\" value=\"Vyjmout oznaen adresy z objektu\">";
		}
		echo "</form>";
	} 
}

/*
 * pridani ip adresy
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $ADD_USR_OBJ_RIGHT)) {
	/*
	 * formular pro pridani nove ip adresy
	 */
	echo "<form action=\"insert_ip_obj.php\" method=\"get\">";
	echo "<table>\n";
	echo "\t<tr>\n";
	echo "\t\t<td>IP adresa</td>\n";
	echo "\t\t<td><input type=text name=\"ip\"></td>\n";
	echo "\t</tr>\n";
	echo "\t<tr>\n";
	echo "\t\t<td>Maska</td>\n";
	echo "\t\t<td><input type=text name=\"ip_mask\"></td>\n";
	echo "\t</tr>\n";
	echo "</table>";

	/*
	 * spolu s novou adresou je take potreba prenest
	 * vztah ke kteremu objektu se to vaze
	 */
	if ("$coll" != "") {
		echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
		if ("$folder" != "") {
			echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
			if ("$photo" != "")
				echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
		}
	}

	/*
	 * tlacitko k odeslani
	 */
	echo "\n<input type=\"submit\" name=\"add\" value=\"Pidat IP adresu k objektu\">";
	echo "</form>";
}

	/*
	 * konec html vystupu
	 */
	include("end_html.php3");
?>
