<?php
/* $Id: email.php,v 1.6.2.3 2007/03/15 15:38:53 petr Exp $ */  

/*
 * formular  pro rozesilani mejlu (url odkazy, obrazky)
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("functions.php");

/*
 * pokud nema uzivatel pravo k prohlizeni objektu, pak tady nema co delat
 */
if (($anonym == $log_user) || (! check_obj_rights($anonym, $coll, $folder, $photo, $READ_RIGHT) && ! check_obj_rights($log_user, $coll, $folder, $photo, $READ_RIGHT)))
	die($NO_AUTHOR);
/*
 * pro pripad, ze by se snazil nekdo neco, co neni
 */
if (!isset($coll) || "$coll" == "" || "$folder" == "" || "$photo" == "")
	die($UNKNOWN_COLL);

require("get_folder.php3");		/* soubor nacita informace o kolekci, slozce, fotce */

/*
 * nastaveni promennych a nazvu stranky
 */
include("photo_names.php3");
$PAGE_TITLE = "e-mailovn fotky $fold_line[4]";

$PAGE_ID = "e-mail";		/* promenna kvuli vypisu napisu editace nebo zobrazeni */
$MAIN_TITLE = $PAGE_TITLE;	/* nadpis stranky */
$is_edit=0; 			/* kvuli vypnuti navigacnich ikon */

require("start_html.php3");	/* zacatek html stranky */

/*
 * zobrazeni nahledove fotky
 */
$dim = getInstanceDim( $photo, 3 );
echo "<table>\n";
echo "<tr valign=top align=left><td valign=\"top\" align=\"left\">";
echo "<div class=\"photo_thumb\" style=\"width:" . ($dim[0] + 10) . "px; height:" . ($dim[1] + 10) . "px;\">";
echo "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$photo&num=2\">";
echo "<img src=\"get_img.php3?coll=$coll&folder=$folder&photo=$photo&num=3\" width=\"$dim[0]\" height=\"$dim[1]\" /></a>\n";
echo "</div>";
echo "</td><td class=\"title\"><b>$fold_line[4]</b><br />$fold_line[9]</td></tr></table><br>\n";


/*
 * odeslani e-mailu
 */
if ("$email" != "") {
	$num=3;
	$message = $email_popis;
	/*
	 * ziskame e-mail prihlaseneho uzivatele
	 */
	$res = mysql_query("select nickname, email from users where id=$log_user");
	$lin = mysql_fetch_row($res);
	$from_email = $lin[1];

	if ("$from_email" == "") {
		$from_email = $DEFAULT_MAIL;
		$message = "$lin[0], uzivatel systemu $MY_HTTP_ROOT si Vam dovoluje zaslat, nasledujici zpravu:\n\n" . $message;
	}

	$hlavicka = "From: $from_email\r\n" .
		    "Reply-To: $from_email\r\n" .
		    "MIME-Version: 1.0\r\n";
	
	if ("$email_co" == "0") {
		$hlavicka .= "Content-Type: text/plain; charset=iso-8859-2\r\n" .
			     "Content-Disposition: inline\r\n" .
			     "Content-Transfer-Encoding: 8bit\r\n";
		$subject = (! strlen($your_subject) ? "DKF: zajimavy odkaz" : $your_subject);
		$message .= "\nURL: $MY_HTTP_ROOT/show_photo.php3?coll=$coll&folder=$folder&photo=$photo&num=2\n";
	} else if ("$email_co" == "1") {
		$subject = (! isset($your_subject) ? "DKF: nahledovy obrazek" : $your_subject);
		$num = 3;
	}
	else if ("$email_co" == "2") {
		$subject = (! strlen($your_subject) ? "DKF: obrazek" : $your_subject);
		$num = 2;
	} else if ("$email_co" == "3") {
		$subject = (! strlen($your_subject) ? "DKF: vetsi obrazek" : $your_subject);
		$num = 1;
	} else if ("$email_co" == "4") {

		$subject = (! strlen($your_subject) ? "DKF: archivn-originl" : $your_subject);
		$num = 0;
	} else if ("$email_co" == "5") {

		$subject = (! strlen($your_subject) ? "DKF: archivn-alternativn" : $your_subject);
		$num = 4;
	}

/*
 * pokud nema uzivatel pravo k editaci objektu, pak nemuze posilat archivni
 * soubor
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT) && (("$email_co" == "4") || ("$email_co" == "5")))
	die($NO_AUTHOR);
	
	if ($email_co >= 1) {
		$inst_res = mysql_query("select instance.* from photo_instance left join instance on instance.id=photo_instance.id_instance where instance.num='$num' and photo_instance.id_photo='$photo'");
		$inst_lin = mysql_fetch_row($inst_res);
		$BOUNDARY = "----------DKF-IMAGE (" . time() . "): $inst_lin[4]----------";
		$hlavicka .= "Content-Type: multipart/mixed;" .
			     " boundary=\"$BOUNDARY\"\r\n" .
			     "Content-Transfer-Encoding: 8bit\r\n";
		$message = "--$BOUNDARY\n" .
			   "Content-Type: text/plain; charset=\"iso-8859-2\"\n" .
			   "Content-Disposition: inline\n" .
			   "Content-Transfer-Encoding: 8bit\n\n" .
			   "$message\n".
			   "--$BOUNDARY\n" .
			   "Content-Type: $inst_lin[2]; name=\"$inst_lin[4]\"\n" .
			   "Content-Disposition: attachment; filename=\"$inst_lin[4]\"\n" .
			   "Content-Transfer-Encoding: base64\n\n";
		$fd = fopen("img/$inst_lin[4]", "rb");	   
		if (! $fd)
			die("neni soubor img/$inst_lin[4]");
		$message .= chunk_split(base64_encode(fread($fd, filesize("img/$inst_lin[4]"))));
		fclose($fd);
		$message .= "\n" .
			   "--$BOUNDARY--\n";
		
	}

	$em_res = mail("$email", "$subject", "$message", "$hlavicka");
	if ($em_res)
		echo "<b>e-mail byl pravdpodobn spn odesln</b><br><br>\n";
	else
		echo "<font color=\"#990000\"><b>e-mail neby spn odesln</b></font><br>\n";
}


/*
 * definice defaultniho tela mejlu
 */
 $def_popis="";

/*
 * vlastni formular
 */
echo "<form action=\"email.php\" method=\"get\">\n";
echo "<b>Poslat na email</b> <input type=\"text\" size=50 name=\"email\">\n<BR><br>";
echo "<input type=\"radio\" class=\"check\" name=\"email_co\" value=0 checked> URL ";
echo "<input type=\"radio\" class=\"check\" name=\"email_co\" value=1> Nhled ";
echo "<input type=\"radio\" class=\"check\" name=\"email_co\" value=2> Normln velikost ";
echo "<input type=\"radio\" class=\"check\" name=\"email_co\" value=3> Vt velikost ";
/*
 * pokud nema uzivatel pravo k editaci objektu, pak nemuze posilat archivni
 * soubor
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT)) {
	echo "<input type=\"radio\" class=\"check\" name=\"email_co\" value=4> Archivn originl";
	echo "&nbsp;<input type=\"radio\" class=\"check\" name=\"email_co\" value=5> Archivn alternativn";
}
echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
echo "<input type=\"hidden\" name=\"folder\" value=$folder>\n";
echo "<input type=\"hidden\" name=\"photo\" value=$photo>\n";
echo "<br><br>";
echo "<b>Pedmt: </b><input type=\"text\" size=50 name=\"your_subject\">\n";
echo "<br><br>\n";
echo "<b>Zprva pro pjemce</b><br>";
echo "<textarea name=\"email_popis\" rows=10 cols=50 wrap=virtual>";
echo "$def_popis";
echo "</textarea>";
echo "<br><br>";
echo "<input type=\"submit\" name=\"poslat\" value=\"Poslat\">";
echo "</from>";



/*
 * konec html vystupu
 */
include("end_html.php3");


?>
