<?php
/* $Id: insert_user.php3,v 1.6.2.1 2005/10/04 14:04:27 petr Exp $ */

/* 
 * prida uzivatele do databaze
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("lib/user.php");

/*
 * pridat uzivatele do databaze muze jen administrator
 */
if (! author(4))
	die($NO_AUTHOR);
/*
 * login uzivatele je povinny
 */
if (! isset($nickname) || "$nickname" == "")
	die($BAD_NICK);

/*
 * uzivatel musi zadat a potvrdit heslo
 */
if (! (isset($passwd) && isset($passwd2) &&
    $passwd == $passwd2) || (strlen($passwd) < 6))
	die($BAD_PASSWD);

/*
 * pridani uzivatele
 */
$user = new User();

# jeste nemame id tak nemame ani preference
$user->preferences = NULL;
 
$user->nickname = $nickname;
$user->access_category = 1;
$user->password = md5($passwd);
$user->email = $email;
$user->active = true;
$user->save();

if ($GLOBALS["error"]) {
    die($GLOBALS["error"]);
}

$preferences = new Preferences();
$preferences->id_user = $user->id;
$preferences->show_type = 1;
$preferences->cols_no = 3;
$preferences->sort_by = 0;
$preferences->view_type = 0;
$preferences->show_thumbs = 1;
$preferences->save();

if ($GLOBALS["error"]) {
    die($GLOBALS["error"]);
}

/*
 * presmerovani na editaci informaci a nastaveni uzivatele
 */
header("Location: edit_user.php3?user=$user->id");
?>
