<?php

//require_once("pconnect_db.php3");
require_once("lib/mysql_object.php");


class Schema extends MySQLObject {
    protected $_table='metadata_schema';
    protected $_id_name='id';

    protected $metadata;

    public function __construct($id=NULL) {
        parent::__construct($id);
        $metadata = array();
    }

    function load($id) {
        if (! parent::load($id)) return false;

        $this->load_metadata();
    }

    function load_metadata() {
        $query = "select schema_metadata.*, lang, title from schema_metadata left join metadata_register on schema_metadata.name=metadata_register.name WHERE schema_metadata.id='$this->_id' ORDER BY prefix,name";
        $result = mysql_query($query);
        if ($result) {
            while ($meta = mysql_fetch_object($result)) {
                $this->metadata[$meta->name][$meta->lang]["repeatable"] = $meta->repeatable;
                $this->metadata[$meta->name][$meta->lang]["description"] = $meta->description;
                $this->metadata[$meta->name][$meta->lang]["title"] = $meta->title;
                $this->metadata[$meta->name][$meta->lang]["typ"] = $meta->typ;
                $this->metadata[$meta->name][$meta->lang]["prefix"] = $meta->prefix;
                $this->metadata[$meta->name][$meta->lang]["mandatory"] = $meta->mandatory;
            }
        }
    }

    function getMeta($name=NULL, $lang=NULL, $prop=NULL) {
        if (! $name) return $this->metadata;
        if (! $lang) return $this->metadata[$name];
        if (! $prop) return $this->metadata[$name][$lang];
        return $this->metadata[$name][$lang][$prop];
    }

    function add_property($meta) {
        $name = $meta['name'];
        if ($this->metadata[$name]) {
            $this->load_metadata();
            return true;
        }

        $query = "INSERT INTO schema_metadata VALUES('$this->_id', '"
                                                    . $meta['name'] . "', '"
                                                    . $meta['typ'] . "', '"
                                                    . $meta['repeatable'] . "', '"
                                                    . $meta['description'] . "', '"
                                                    . $meta['prefix'] . "', '"
                                                    . $meta['mandatory']
                                                    . "')";
        $result = mysql_query($query);
        if ($result) $this->load_metadata();
        else $GLOBALS["error"] = "Nepodarilo se pridat atribut $query";

        return $result;
    }

    function render() {
        $page = parent::render();
        if (! $this->metadata) return $page;

        foreach($this->metadata as $name => $metas) {
            foreach($metas as $lang => $props) {
                $page .= $props['title'];
                $page .= " repeatable=" . $props['repeatable'];
                $page .= " mandatory=" . $props['mandatory'];
                $page .= " prefix=" . $props['prefix'];
                $page .= " typ=" . $props['typ'];
                $page .= " description=" . $props['description'];
            }
            $page .="<br />";
        }

        return $page;
    }

    public static function ls() {
        $pom = parent::ls('metadata_schema');
        $schemas = array();
        foreach($pom as $obj) {
            $schema = new Schema();
            foreach($obj as $key => $value) {
                $schema->$key = $value;
            }
            $schemas[] = $schema;
        }
        return $schemas;
    }

    public static function load_schema($name) {
        $query = "SELECT * FROM metadata_schema WHERE name='$name'";
        $result = mysql_query($query);
        if (! $result || mysql_num_rows($result) == 0)
            return NULL;
        $obj = mysql_fetch_object($result);

        $schema = new Schema();
        $schema->load($obj->id);

        return $schema;
    }
}
?>
