<?php
require_once("functions.php");
require_once("lib/mysql_object.php");

class Preferences extends MySQLObject
{
    protected $_table='preferences';
    protected $_id_name='id_user';
}

class User extends MySQLObject
{
	protected $_table='users';
    protected $_id_name='id';
    
    public $preferences;
    
    public function __construct($id=NULL)
    {
    	parent::__construct($id);
    	$this->preferences = new Preferences($id);
    }
    
    public static function ls($cond=NULL)
    {
    	$opt = array( 'order' => 'nickname');
    	if ($cond) $opt['cond'] = $cond;
    	
    	$users = parent::ls('users', __CLASS__, $opt);
        foreach($users as $user) {
        	if ($user->id) $user->_id = $user->id;    	
        }
        
    	return $users;
    }
    
    public function save()
    {
    	if (! parent::save())
    	   return false;
    	   
    	if ($this->preferences != NULL)
    	   return $this->preferences->save();
    	
    	return true;
    }
    
    public function delete()
    {
    	if (! $this->_id) return false;
        /*
        * mazani tabulek na uzivateli zavislych
        */
        $result = mysql_query("delete from user_group_rights where id_user='$this->_id'")
            or die("Nelze odstranit uzivatele ze skupin");
        $result = mysql_query("delete from user_collection_rights where id_user='$this->_id'")
            or die("Nelze odstranit uzivatele z kolekci");
        $result = mysql_query("delete from user_folder_rights where id_user='$this->_id'")
            or die("Nelze odstranit uzivatele ze slozek");
        $result = mysql_query("delete from user_photo_rights where id_user='$this->_id'")
            or die("Nelze odstranit uzivatele z fotek");
        $result = mysql_query("delete from user_instance_rights where id_user='$this->_id'")
            or die("Nelze odstranit uzivatele z instanci");
        
        $this->preferences->delete();
        
        return parent::delete();
    }
    
    public function count_photos() { return count_user_photos($this->id); }
    public function ac() { return ac_to_s($this->access_category); }
}

?>