<?php
/* $Id: list_folders.php3,v 1.22.2.23 2007/04/05 14:40:06 petr Exp $ */

/*
 * vytvari seznam objektu (pro fotky i s nahledama)
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("properties.php");
require_once("functions.php");
require_once("lib/collection.php");

/*
 * pokud listujeme aspon kolekci pak musime mit pravo tuto kolekci cist
 */
if ($coll)
	if (! (check_obj_rights($anonym, $coll, $folder, $photo, $READ_RIGHT) || check_obj_rights($log_user, $coll, $folder, $photo, $READ_RIGHT)))
		die("$NO_AUTHOR");


include("get_folder.php3");	/* nacteme informace o kolekci, slozce, fotce */
/*
 * pokud neni prihlasen tak se nastavi pristupova kategorie na 0 (anonym)
 * ZASTARALE !!!
 */
if (! isset($sess) || ! $sess)
	$user_line[2] = 0;
else {
	require_once("get_user.php3");
    $user_obj = user_get($sess[1]);
}


require("get_names.php3");	/* nastaveni promennych pro objekt */
require("prop_query.php3");	/* nastaveni dotazu v zavyslosti na pozici */

/* jak se to bude tridit */

/*
 * nastaveni nazvu stranky
 */
$PAGE_TITLE = "DKF: ";
if ($photo) {
	$PAGE_TITLE .= "Fotka: $fold_line[4]";
    $typ = 3;
    $id = $photo;
    $obj_name = 'photo';
    $obj_subname = '';
} else if ($folder) {
	$PAGE_TITLE .= "Sloka: $fold_line[4]";
	$NAME = "Sloka";
    $typ = 2;
    $id = $folder;
    $obj_name = 'folder';
    $obj_subname = 'photo';
} else if ($coll) {
	$PAGE_TITLE .= "Kolekce: $fold_line[4]";
	$NAME = "Kolekce";
    $typ = 1;
    $id = $coll;
    $obj_name = 'collection';
    $obj_subname = 'folder';
} else {
	$PAGE_TITLE .= "Seznam kolekc";
	$NAME = "Seznam kolekc";
    $typ = 0;
    $id = 0;
}
$MAIN_TITLE = $PAGE_TITLE;
$is_list=1; // kvuli trideni, promenna indikujici, ze se jedna o slozku, ve ktere ma ikona trideni smysl

$can_edit = false;
//loguj($log_user . " - ". $EDIT_RIGHT);
if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT)) {
    $can_edit = true;
}

//loguj($log_user . " - ". $can_edit);

$page = '';
$alphabet = array();
$years = array();


function doMark($name, $subname, $id, $typ, $all, $set)
{
    global $_GET, $page;
    if ($name == NULL || $name == 'photo') return;
    // smazem prvne vsechny dosavadni oznaceni
    $query = "select id_$subname, id_mark_register from ${name}_${subname} left join marks on id_$subname=marks.id_object and marks.typ='$typ' where id_$name=$id";
//    $page .= $query;
    $res = mysql_query($query);
    if (! $res) die($query);
    $pole = array();
    if (isset($_GET['vyber'])) $pole = $_GET['vyber'];
    while (($line = mysql_fetch_row($res)) != null) {
        // otestujeme jestli doslo ke zmene
        $query = null;
        $obj_id = mysql_escape_string($line[0]);
        if ((in_array($line[0], $pole) && $line[1] != '1' && $all==false) ||
            ($all == true && $set == 1 && $line[1] != '1')) {
            $query = "insert into marks values($obj_id, 1, $typ)";
            $set = 1;
        } elseif ((! in_array($line[0], $pole) && $line[1]=='1' && $all==false) ||
                  ($all == true && $set == 0 && $line[1] == '1')) {
            $query = "delete from marks where id_object='$obj_id' and typ='$typ'";
            $set = 0;
        }
        // pokud doslo ke zmene, tak menime, vcetne celeho podstromu
        if ($query != null) {
            $r = mysql_query($query);
            if (! $r) die("nepodarilo se upravit oznaceni: $query");
            if ($name == 'collection')
                doMark('folder', 'photo', $line[0], $typ + 1, true, $set);
        }
    }
}
if ($can_edit == true && isset($_GET['add_mark'])) {
    $pom_typ = $typ + 1;
    $mark = mysql_escape_string($_GET['mark']);
    doMark($obj_name, $obj_subname, $id, $pom_typ, false, -1);
}

function renderAlphabet($items, $delim=' ') {
    sort($items);
    $str = '';

    $str .= "<span class=\"alphabet\">";
    foreach($items as $item) {
        $str .= "<a href=\"#$item\">$item</a>$delim\n";
    }
    $str .= "</span>";

    return $str;
}

function generateAlphabet($items, $delim=' ') {
    sort($items);

    $str = '';
    $str .= "<span class=\"alphabet\">";
	for ($i=65; $i<=90; $i++) {
        if (in_array(chr($i), $items))
            $str .= "<a href=\"#" . chr($i) . "\">";

        $str .= chr($i);

        if (in_array(chr($i), $items))
            $str .= "</a>\n";

        if (i < 90) $str .= $delim;
	}
    $str .= "</span>";

    return $str;
}

function folder_navigation($coll, $folder, $sort_by, $alphabet, $years) {
    $str = '';
    $str .= "<input type=\"submit\" name=\"add_mark\" value=\"Uloit oznaen\">&nbsp;";

    if ($coll && (! $folder) && ($sort_by == 0)) {	
	    $str .= generateAlphabet($alphabet);
        if (count($years) > 0) {
            $str .= '&nbsp;';
            $str .= renderAlphabet($years);
        }
	    $str .= "<br />\n";
    }	

    return $str;
}


/*
 * zacatek html stranek
 */
include("start_html.php3");

/*
 * nastaveni trideni pro dotaz
 */
if ($sort_by == 0)
	$ret_sort="title";
else
	$ret_sort="created DESC";
/*
 * vytvoreni dotazu do databaze vzhledem k pozici
 */
if ($folder) {
	$folder_list_query = "select photos.id, photos.title, photos.description, marks.id_mark_register
		from folder_photo, photos left join marks on photos.id=marks.id_object and marks.typ=3
		where folder_photo.id_folder=$folder
		and folder_photo.id_photo=photos.id
		and photos.access_category<='$user_obj->access_category'
		order by photos.$ret_sort";
} 
else if ($coll) {
		$folder_list_query = "select folders.id, folders.title, folders.description, marks.id_mark_register
			from collection_folder, folders left join marks on folders.id=marks.id_object and marks.typ=2
			where collection_folder.id_collection='$coll'
			and collection_folder.id_folder=folders.id
			and folders.access_category<='$user_obj->access_category'
			order by folders.$ret_sort";
} else {
	$folder_list_query = "select id, title, description from collections
			where access_category<='$user_obj->access_category' order by $ret_sort";
}

/*
 * ziskani seznamu, z ktereho se bude vypisovat
 */
$result = mysql_query($folder_list_query);
if (! $result)
	die("nelze vygenerovat seznam: $folder_list_query");
$rows = mysql_num_rows($result);


/*
 * pokud se nejedna o seznam kolekci vypis info o objektu
 * v kterem se nachazime
 */
if ($coll) {
    $page .= "<table>";
    $page .= "<tr>";
    if (!$folder && !$photo) {
        $page .= "<td style=\"text-align:right; vertical-align:top;\">";
        $page .= obj_render_photo($coll);
        $page .= "</td>";
    } elseif ($folder) {
        $page .= "<td style=\"text-align:right; vertical-align:top;\">";
        $page .= obj_render_photo($coll, $folder);
        $page .= "</td>";
    }
    $page .= "<td width=\"100%\">";
	$page .= "<table class=\"info\">\n";
	require("show_folder.php3");
	if ($view_type != 1) {
		$page .= "<tr><th>Poet objekt</th>";
		$page .= "<td>$rows</td></tr>";
	}
	if (! $folder and ! $photo and $log_user != $anonym) {
		$page .= "<tr>\n";
		$page .= "\t<th>Export</th>\n";
		$page .= "\t<td><a href=\"export_xml_coll.php?coll=$coll\">XML</a>,&nbsp;";
        $page .= "<a href=\"export_xml_coll.php?coll=$coll&vyber=1\">XML-vbr</a></td>\n";
		$page .= "</tr>\n";
	}
	$page .= "</table></td>\n";
    $page .= "</tr>";
    $page .= "</table>";
	/*
	 * zjistime info o uzivateli
	 */
	if (isset($user)) include("get_user.php3");

} else {
    $page .= "<h1>" . $NAME . "</h1>";
    $page .= "<p>";
    $page .= "<i>Seznam vech kolekc v DKF bez ohledu na kategorie.</i>";
    $page .= "</p>";
#    if ($log_user == $anonym) $page .= "<h1>Digitln knihovna fotografi MU</h1>";
}

if ($rows == 0) {
    $page .= "<p>";
	if ($folder)
		$page .= "<b>V tto sloce nejsou dn fotografie.</b>";
	else if ($coll)
		$page .= "<b>V tto kolekci nejsou vytvoeny dn sloky.</b>";
	else
		$page .= "<b>Systm DKF nem zatm vytvoeny dn kolekce.</b>";
    $page .= "</p>";
}
else {

if (! $result) 
	die ("error pri $NAME\n");
else if ($photo) {
/*
 * v pripade ze se jedna o fotku, tak nic nedelej
 * jinak vylistuj
 */
} else {
	$CELL_SIZE=10;
	$CELL_PHOTO=185;

  $show_check = false;
  if ((($can_edit == true) && isset($coll)) &&
    ((! isset($folder)) || (isset($folder) && $show_type==0)) &&
    ($view_type == 0)) {
      $show_check = true;
  }

	if (($show_type == 1) && ($folder)) { 
		$page .= "<hr />\n";
		require("preview_table.php");  /* zobrazeni nahledu do tabulky */
        $page .= $element_list;
	}
	else {
        if (isset($coll)) $page .= "<br />";
        if ($show_check) {
          $page .= "<form>\n";
          $page .= "<input type=\"hidden\" name=\"coll\" value=\"$coll\">\n";
          if (isset($folder))
              $page .= "<input type=\"hidden\" name=\"folder\" value=\"$folder\">\n";
        }

		require("preview_list.php");

        $page .= folder_navigation($coll, $folder, $sort_by, $alphabet, $years);

        if (isset($coll)) $page .= "<br />\n";
					
        $page .= $element_list;
	}
     if ($show_check) {
        $page .= "<br />";
        $page .= folder_navigation($coll, $folder, $sort_by, $alphabet, $years);

        $page .= "</form>\n";
     }
}

/*
 * konec html vystupu
 */

}

echo $page;

include("end_html.php3");
?>
