<?php
/* $Id: navigace.php3,v 1.30.2.15 2007/04/10 10:42:38 krejvl Exp $ */

/*
 * navigace v zavislosti na pozici v dokumentu a pripadne
 * dalsi nastaveni pri browsdani
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("cfg.php");	/* nacteni konfigurace systemu */
require_once("functions.php");
require_once("lib/category.php");

include ("get_preferences.php"); /* nacte nastaveni prihl. uzivatele z databaze, anonymnimu nastavi default */
require_once("set_pref_params.php"); /* obsahuje funkci pro pripravu parametru pro odkaz pro promenne z preferences */

?>

<table class="navig_top">
    <tr>
        <td class="navig_left" nowrap="true">

<?php
/* kontrola spravnosti nastavenych promennych (se kterymi je skript volan), popr. jejich oprava */
if (isset($show_type)) $show_type_local=check_bool($show_type);
if (isset($cols_no)) $cols_no_local=check_cols($cols_no);
if (isset($sort_by)) $sort_by_local=check_bool($sort_by);
if (isset($view_type)) $view_type_local=check_bool($view_type);
if (isset($show_thumbs)) $show_thumbs_local=check_bool($show_thumbs);

/*
 * vytvori odkaz na hlavni stranku
 *
 * pokud se jedna o anonymniho uzivatele, tak si zapamatujeme parametry
 */
$retez="";
if ($log_user == $anonym)
	$retez .= set_params($show_type, $cols_no, $sort_by, $view_type, $show_thumbs);


/*
 * odkaz na seznam kolekci
 * -- pro anonyma si musime pamatovat promenne v odkaze
 */

if ($log_user == $anonym) {
	$ref_pref= set_params($show_type_local, $cols_no_local, $sort_by_local, $view_type_local, $show_thumbs_local); /* odkaz. paramatry */
	$amp="&";
	$interr="?";
} 
else {
	$ref_pref=""; /* prihlaseny uzivatel neodkazuje parametry preferences */
	/* nyni updatuji zmenene polozky v databazi pro prihlaseneho uzivatele 
	 * updatuji se jen ty polozky, ktere jsou predany v parametrech skriptu
         * tedy ty udaje, ktere prihlaseny uzivatel menil
	 */
	$apm="";
	$interr="";
	if (isset($show_type)) { 
		$result=mysql_query("update preferences set show_type=$show_type_local where id_user=$log_user");
		if (! $result) die("Nemohu zmenit nastaveni vzhledu show_type v databazi.");
	}
	if (isset($cols_no)) {
		$result=mysql_query("update preferences set cols_no=$cols_no_local where id_user=$log_user");
		if (! $result) die("Nemohu zmenit nastaveni vzhledu cols_no v databazi.");
	}
	if (isset($sort_by)) {
		$sort_result=mysql_query("update preferences set sort_by=$sort_by_local where id_user=$log_user");
		if (! $sort_result) die("Nemohu ulozit typ trideni do databaze.");
	}
	if (isset($view_type)) {
		$view_result=mysql_query("update preferences set view_type=$view_type_local where id_user=$log_user");
		if (! $view_result) die("Nemohu nastavit view_type pro uzivatele cislo $log_user");
	}
	if (isset($show_thumbs)) {
		$thumbs_result=mysql_query("update preferences set show_thumbs=$show_thumbs_local where id_user=$log_user");
		if (! $thumbs_result) die("Nemohu nastavit show_thumbs pro uzivatele cislo $log_user");
	}
}


echo drobecek("Kategorie", "category.php?$ref_pref", "Seznam kategori", false);
echo drobecek("Kolekce", "list_folders.php3?$ref_pref", "Seznam kolekc", false);


$show_type=$show_type_local;
$cols_no=$cols_no_local;
$sort_by=$sort_by_local;
$view_type=$view_type_local;
$show_thumbs=$show_thumbs_local;


if (isset($category) && "$category" != "") {
    $cat_obj = category_get($category);
    echo drobecek($cat_obj->title, "category.php?category=$cat_obj->id&coll=$coll$amp$ref_pref");
}

/*
 * pokud jsme alespon v kolekci, tak zobrazime
 * nazvy slozky prip i fotky, kde se zrovna nachazime
 */
if (isset($coll) && "$coll" != "") {
	/*
	 * ziskani nazvu kolekce
	 */
	$hresult = mysql_query("select title from collections
			where id=$coll");
	if (! $hresult || mysql_num_rows($hresult)<=0)
		die("neni kolekce $coll");
	$hline = mysql_fetch_row($hresult);
	$coll_name=$hline[0];
	/*
	 * zobrazeni odkazu na slozku
	 * -- pro anonyma opet nutno pamatovat promenne
	 */
    echo drobecek($hline[0], "list_folders.php3?coll=$coll$amp$ref_pref");
	
	/*
	 * pokud jsme ve slozce...
	 */
	if (isset($folder) && "$folder" != "") {
		/*
		 * zjistime nazev slozky
		 */
		$hresult = mysql_query("select title
			from folders where id=$folder");
		if (! $hresult || mysql_num_rows($hresult)<=0)
			die("neni kolekce $coll");
		$hline = mysql_fetch_row($hresult);
		$folder_name=$hline[0];
		/*
		 * zobrazeni v zavislosti na prihlasenosti uzivatele
		 */
        $url = "list_folders.php3?coll=$coll&folder=$folder";
        if ($log_user == $anonym)
            $url .= $amp . $ref_pref;
        echo drobecek($hline[0], $url);
	}
}
?>

    </td>
    <td class="navig_right" nowrap="true">

<?php
/*
 * zobrazeni prihlasovaciho/odhlasovaciho odkazu
 */
if (! $sess) {
    echo drobecek("Pihlsit", "login.php3", "Pihlsit uivatele do DKF", false);
} else {
    require_once('get_user.php3');
    $user_obj = user_get($sess[1]);
    $nick = $user_obj->nickname;
    echo drobecek("&lt;" . $nick . "&gt;", "user.php3", "Strnka uivatele $nick", false);
    echo drobecek("Odhlsit", "logout.php3", "Odhlsit uivatele $nick z DKF.", false);
}
echo drobecek("Informace", "info.php", "Informace o DKF, kontakty, jak se zapojit,...", false);
?>

        </td>
    </tr>
</table>

<?php
/*
 * navigacni tlacitka nezobrazujeme pri vyhledavani
 * a pri pridavani
 */
if (! isset($advanced_search) || ("$srch_tit" != "" || "$srch_descr" != "" || "$srch_ident" || "$srch_vse" != "" ||
	"$srch_cov_place" != "" || "$srch_cov_date" != "")) {
?>

<table class="navig_bottom">
    <tr>
        <td class="navig_left" nowrap="true">

<?php
	/* pokud pridavame slozku, kolekci nebo fotku tak nevigacni sipky nezobrazuj */
	if ((! isset($is_add)) && (! isset($is_edit)) && (! isset($is_rights))) { 
		/*
		 * popis pro jednotliva tlacitka -- inicializace ctyrprvkoveho pole 
		 */
		$description=Array("", "", "", "");
		/*
		 * nema smysl zobrazovat skakaci tlacitka, pokud jsme nikde
		 */
		if ($photo || $folder || $coll) {
			require("get_slide.php");	/* nacteni funce pro ziskani prv, predch... */
			/* pole description se predava odkazem */
			$slide=slide($description, $sort_by_local);
			/*
			 * nastaveni odkazu v zavislosti na objektu
			 */
			if (isset($photo)) {
				$sld_id = $photo;
				$sld_first = "show_photo.php3?coll=$coll&folder=$folder&photo=$slide[0]&num=$num";
				$sld_prev = "show_photo.php3?coll=$coll&folder=$folder&photo=$slide[1]&num=$num";
				$sld_up = "list_folders.php3?coll=$coll&folder=$folder";
				$sld_next = "show_photo.php3?coll=$coll&folder=$folder&photo=$slide[2]&num=$num";
				$sld_last = "show_photo.php3?coll=$coll&folder=$folder&photo=$slide[3]&num=$num";
				$sld_up_name = $folder_name;
			} else if (isset($folder)) {
				$sld_id = $folder;
				$sld_first = "list_folders.php3?coll=$coll&folder=$slide[0]";
				$sld_prev = "list_folders.php3?coll=$coll&folder=$slide[1]";
				$sld_up = "list_folders.php3?coll=$coll";
				$sld_next = "list_folders.php3?coll=$coll&folder=$slide[2]";
				$sld_last = "list_folders.php3?coll=$coll&folder=$slide[3]";
				$sld_up_name = $coll_name;
			} else if (isset($coll)) {
				$sld_id = $coll;
				$sld_first = "list_folders.php3?coll=$slide[0]";
				$sld_prev = "list_folders.php3?coll=$slide[1]";
				$sld_up = "list_folders.php3"; $up_flag=1; 
				$sld_next = "list_folders.php3?coll=$slide[2]";
				$sld_last = "list_folders.php3?coll=$slide[3]";
				$sld_up_name = "Seznam kolekc";
			}
			/*
			 * pokud je nejaky prvni, tak ukaz sipky prvni a predchozi, jinak vysvicene sipky
			 */
			if ($slide[0] != -1) {
				echo "<a href=\"$sld_first$amp$ref_pref\" title=\"$description[0]\">\n";
				echo "<img src=\"$STYLE/first.gif\" alt=\"$description[0]\" border=0></a>&nbsp;\n";
				echo "<a href=\"$sld_prev$amp$ref_pref\" title=\"$description[1]\" rel=\"previous\">\n";
				echo "<img src=\"$STYLE/prev.gif\" alt=\"$description[1]\" border=0></a>&nbsp;\n";
			} else {
				echo "<img src=\"$STYLE/firstn.gif\" alt=\"\" border=0>&nbsp;\n";
				echo "<img src=\"$STYLE/prevn.gif\" alt=\"\" border=0>&nbsp;\n";
			}
			/*
			 * odkaz o uroven vys
			 */
			if (! isset($up_flag))
				echo "<a href=\"$sld_up$amp$ref_pref\" title=\"$sld_up_name\" rel=\"parent\">\n";
			else 
				echo "<a href=\"$sld_up$interr$ref_pref\" title=\"$sld_up_name\" rel=\"parent\">\n";
			echo "<img src=\"$STYLE/up.gif\" alt=\"$sld_up_name\" border=0></a>&nbsp;\n";
			/*
			 * pokud existuje nejakej posledni, tak ukaz posledni a nasledujici sipky
			 */
			if ($slide[3] != -1) {
				echo "<a href=\"$sld_next$amp$ref_pref\" title=\"$description[2]\" rel=\"next\">";
				echo "<img src=\"$STYLE/next.gif\" alt=\"$description[2]\" border=0></a>&nbsp;\n";
				echo "<a href=\"$sld_last$amp$ref_pref\" title=\"$description[3]\">";
				echo "<img src=\"$STYLE/last.gif\" alt=\"$description[3]\" border=0></a>&nbsp;\n";
			} else {
				echo "<img src=\"$STYLE/nextn.gif\" alt=\"\" border=0>&nbsp;\n";
				echo "<img src=\"$STYLE/lastn.gif\" alt=\"\" border=0>&nbsp;\n";
			}
		}
	} /* konec pro if (! isset($is_add ... */
?>

        </td>
        <td class="navig_center" nowrap="true">

<?php
	/*
	 * formular pro vyhledavani
	 */
    echo "<div class=\"srch\">";
	echo "<form action=\"search.php\" method=\"get\">\n";
	echo "\t<input type=\"text\" name=\"squery\" />";
	echo "\t<input type=\"hidden\" name=\"search_page\" value=\"1\" />\n";
	if ($log_user == $anonym) {
		echo "<input type=\"hidden\" name=\"show_type\" value=\"$show_type\" />";
		echo "<input type=\"hidden\" name=\"cols_no\" value=\"$cols_no\" />";
		echo "<input type=\"hidden\" name=\"sort_by\" value=\"$sort_by\" />";
		echo "<input type=\"hidden\" name=\"view_type\" value=\"$view_type_local\" />";
		echo "<input type=\"hidden\" name=\"show_thumbs\" value=\"$show_thumbs_local\" />";
	}
	echo "\t<input type=\"submit\" name=\"search\" value=\"Hledej\" />\n";
	echo "\t<input type=\"submit\" name=\"advanced_search\" value=\"Rozen hledn\" />\n";
	echo "</form>";
?>

        </td>
        <td class="navig_right" nowrap="true">

<?php
	// cast pro praci s nahledy do tabulky (ikona "zvetsit/zmensit pocet sloupcu" a zmen typ nahledu
	if (($folder) && (! $photo) && (! isset($is_edit)) && (! isset($is_add)) && (! isset($is_rights))) {
		/* nasleduje pasaz pro zobrazeni ikon */
		if ($show_thumbs == 0) {
			echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
			if ($log_user == $anonym)
				echo set_params($show_type, $cols_no, $sort_by, $view_type, 1);
			else echo "show_thumbs=1";
			echo "\" title=\"Povol nhledy\">\n";
			echo "<img src=\"$STYLE/thumbs.gif\" alt=\"Povol nhledy\"   border=0></a>\n";
		}
		else {
			echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
			if ($log_user == $anonym)
				echo set_params($show_type, $cols_no, $sort_by, $view_type, 0);
			else echo "show_thumbs=0";
			echo "\" title=\"Zaka nhledy\">\n";
			echo "<img src=\"$STYLE/nothumbs.gif\" alt=\"Zaka nhledy\"   border=0></a>\n";
		}
		
		
		if ($show_type == 1) { // je-li typ zobrazeni na sloupce
			if ($cols_no <= 2) {
				$cols_no++;
				echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
				if ($log_user == $anonym) 
					echo set_params($show_type, $cols_no, $sort_by, $view_type, $show_thumbs);
				else echo "cols_no=$cols_no"; 
				echo "\" title=\"Pidej sloupec\">\n";
				echo "<img src=\"$STYLE/colsw.gif\" alt=\"Pidej sloupec\"   border=0></a>\n";
				echo "<img src=\"$STYLE/colsnn.gif\" alt=\"\"   border=0>\n";
				$cols_no--;
			}
			else {
				if ($cols_no >= 7) {
					$cols_no--;
					echo "<img src=\"$STYLE/colswn.gif\" alt=\"\"   border=0>\n";
					echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
					if ($log_user == $anonym) 
						echo set_params($show_type, $cols_no, $sort_by, $view_type, $show_thumbs);
					else echo "cols_no=$cols_no";
					echo "\" title=\"Uber sloupec\">\n";
					echo "<img src=\"$STYLE/colsn.gif\" alt=\"Uber sloupec\"   border=0></a>\n";
					$cols_no++;
				}
				else {
					$cols_no++;
					echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
					if ($log_user == $anonym) 
						echo set_params($show_type, $cols_no, $sort_by, $view_type, $show_thumbs);
					else echo "cols_no=$cols_no";
					echo "\" title=\"Pidej sloupec\">\n";
					echo "<img src=\"$STYLE/colsw.gif\" alt=\"Pidej sloupec\"   border=0></a>\n";
					$cols_no--; $cols_no--;
					echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
					if ($log_user == $anonym)
						echo set_params($show_type, $cols_no, $sort_by, $view_type, $show_thumbs);
					else echo "cols_no=$cols_no";
					echo "\" title=\"Uber sloupec\">\n";	
					echo "<img src=\"$STYLE/colsn.gif\" alt=\"Uber sloupec\"   border=0></a>\n";
					$cols_no++;
				}
			}
		}
				
		// cast pro zobrazeni ikony pro zmenu show_type
		if ($show_type == 1) {
			echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
			if ($log_user == $anonym)
				echo set_params(0, $cols_no, $sort_by, $view_type, $show_thumbs);
			else echo "show_type=0";
			echo "\" title=\"Zobraz pod sebou\">\n";
			echo "<img src=\"$STYLE/list.gif\" alt=\"Zobraz pod sebou\"   border=0>";
		}
		else {
			echo "<a href=\"list_folders.php3?coll=$coll&folder=$folder&";
			if ($log_user == $anonym)
				echo set_params(1, $cols_no, $sort_by, $view_type, $show_thumbs);
			else echo "show_type=1";
			echo "\" title=\"Zobraz v tabulce\">\n";
			echo "<img src=\"$STYLE/table.gif\" alt=\"Zobraz v tabulce\"   border=0>";
		}
		echo "</a>\n";
	
	/*
	 * zobrazime ikonky pro praci s fotografii (e-mail,...)
	 */
	} else if ("$photo" != "") {
		/*
		 * posilat fotku e-mailem smeji jen prihlaseni uzivatele
		 */
		if ($anonym != $log_user) {
			echo "<a href=\"email.php?typ=16&coll=$coll&folder=$folder&photo=$photo\""; 
			echo "title=\"Poslat fotografii emailem\">";
			echo "<img src=\"$STYLE/email.gif\" alt=\"Poslat fotografii emailem\" border=0></a>";
		
		}
		echo "&nbsp;\n";
	}


	//nasleduje cast, ktera zavadi ikonu pro trideni a s ni spojena nastavovanii
	// sort_by == 0 - trideni podle abecedy
	// sort_by == 1 - trideni podle casu vlozeni (modifikace)
	if (isset($is_list) && (! $photo) && (! isset($is_edit)) && (! isset($is_add)) && (! isset($is_rights))) {

		//nastaveni parametru pro predavani v odkazu		
		if ((! isset($coll)) && (! isset($folder)))  //jsme na seznamu kolekci
			$sort_params="?";
		else 
			if (isset($coll) && (! isset($folder))) //jsme v kolekci na seznamu slozek
				$sort_params="?coll=$coll&";
			else // jsme ve slozce na seznamu fotek
				$sort_params="?coll=$coll&folder=$folder&"; 

			echo "<a href=\"list_folders.php3$sort_params";
			if ($sort_by == 0) { //zarada ikonu pro trideni podle data vlozeni
				if ($log_user == $anonym)
					echo set_params($show_type, $cols_no, 1, $view_type, $show_thumbs);
				else echo "sort_by=1";
				echo "\" title=\"Seti podle data vloen\">";
				echo "<img src=\"$STYLE/sortm.gif\" alt=\"Seti podle data vloen\" border=0>";
			}
			else {  //zarad ikonu pro trideni podle abecedy
				if ($log_user == $anonym)
					echo set_params($show_type, $cols_no, 0, $view_type, $show_thumbs);
				else echo "sort_by=0";
				echo "\" title=\"Seti podle abecedy\">";
				echo "<img src=\"$STYLE/sorta.gif\" alt=\"Seti podle abecedy\" border=0>";
			}
			echo "</a>\n";
	}

	/* nasleduje cast pro prepinani rezimu prohlizeni pro prihlaseneho uzivatele */
	if ((! isset($is_edit)) && (! isset($INDEX_PAGE))) {
		$ref_coll="?";
		$ref_folder="";
		$ref_photo="";
		if (isset($coll)) { 
			$ref_coll="?coll=$coll&";
			if (isset($folder)) {
				$ref_folder="folder=$folder&";
				if (! isset($num)) $num=2;
				if (isset($photo)) $ref_photo="photo=$photo&num=$num&";
			}
		}
		$ref_all=$ref_coll.$ref_folder.$ref_photo;

		$script_name=substr($PHP_SELF, 1, strlen($PHP_SELF));	
		echo "<a href=\"$PHP_SELF$ref_all";
		if (isset($squery))
			echo "squery=". rawurlencode($squery) . "&search=Hledej&search_page=$search_page&";
		elseif (isset($advanced_search))
			echo "srch_vse=" . rawurlencode($srch_vse) . 
			     "&srch_tit=" . rawurlencode($srch_tit) .
			     "&srch_descr=" . rawurlencode($srch_descr) .
			     "&srch_ident=" . rawurlencode($srch_ident) .
			     "&srch_cov_place=" . rawurlencode($srch_cov_place) .
			     "&srch_cov_date=" . rawurlencode($srch_cov_date) .
			     "&srch_join=" . rawurlencode($srch_join) .
			     "&srch_zp=" . rawurlencode($srch_zp) .
			     "&advanced_search=Vyhledat" .
			     "&search_page=$search_page" .
			     "&";
		if ($view_type_local == 1) {
			if ($log_user == $anonym)
				echo set_params($show_type, $cols_no, $sort_by, 0, $show_thumbs);
			else echo "view_type=0";
			echo "\" title=\"Normln reim prohlen\">\n";
			echo "<img src=\"$STYLE/viewstd.gif\" alt=\"Normln reim prohlen\"   border=0>";
			echo "</a>\n";
		}
		else {
			if ($log_user == $anonym)
				echo set_params($show_type, $cols_no, $sort_by, 1, $show_thumbs);
			else echo "view_type=1";
			echo "\" title=\"Reim prohlen\">\n";
			echo "<img src=\"$STYLE/viewpic.gif\" alt=\"Reim prohlen\"   border=0>";
			echo "</a>\n";
		}
	}
?>
        </td>
    </tr>
</table>

<?php } ?>
