<?php // zobrazeni v seznamu pro list_folders.php3
require_once("auth.php3");
require_once("functions.php");
require_once("lib/metadata.php");

if (! isset($ref_pref)) { /* pokud neni odkazovana promenna nastavena */
	include("get_preferences.php"); /* nacte nastaveni prihl. uzivatele z databaze, anonymnimu nastavi default */
	require_once("set_pref_params.php"); /* obsahuje funkci pro pripravu parametru pro odkaz pro promenne z preferences */
	if ($log_user == $anonym) 
        	$ref_pref=set_params($show_type_local, $cols_no_local, $sort_by_local, $view_type_local, $show_thumbs_local); /* odkaz. parametry */
	else $ref_pref="";
}

if ($log_user == $anonym) $ref_pref="&".$ref_pref;
else $ref_pref="";

require_once("properties.php");
$coll_pref = get_properties($coll);
if ($coll_pref) {
	$tnl = ((int)$coll_pref->tab_name_len != 0) ?
	       "width=\"" . $coll_pref->tab_name_len . "\"" :
				 "auto";
	$tnl .= "\"";
	$tdl = ((int)$coll_pref->tab_desc_len != 0) ?
	       "width=\"" . $coll_pref->tab_desc_len . "\"" :
				 "auto";
				 "\"";
	$tnl .= "\"";
	$fdl = ((int)$coll_pref->fold_desc_len != 0) ?
	       $coll_pref->fold_desc_len :
				 250;
} else {
	$tnl = "";
	$tdl = "";
	$fdl = 250;
}

$first_char = null;

$element_list .= "<div id=\"photo_list\" name=\"photo_list\" class=\"photo_list\">\n";
$even=false;
while($line = mysql_fetch_row($result)) {
    $pozn = $line[2];

    // extra metadata nacpeme do poznamky
    if ($folder) {
        $metas = meta_get_metadata($coll, $folder, $line[0]);
    } else {
        $metas = meta_get_metadata($coll, $line[0], NULL);
    }
    if ($metas) {
        $metadata = meta_select_language($metas, $GLOBAL["languages"][0]);
        if ($folder) {
            foreach($metadata as $meta) {
                $pozn .= "<b>$meta->title: </b>";
                $pozn .= "$meta->value<br />";
            }
        } else {
            // u slozek zobrazit jenom popis, pokud tam je
            foreach($metadata as $meta) {
                if ($meta->name != description) continue;
                $pozn .= "$meta->value<br />";
            }
        }
    }

   	$pozn = orez($pozn, $fdl);

	/*
	 * pokud ma anonym povoleny pristup pro cteni, pak ho maji zrejme vsichni
	 * jinak je potreba otestovat konkretrni prava uzivatele
	 * pokud by se testovala jen prava uzivatele, pak by kazdy uzivatel musel byt
	 * prirazen alespon ke korenovemu objektu nebo zarazen do skupiny, ktera by
	 * byla prirazena korenovemu objektu
	 */
	if ($folder) {
		if (! (check_obj_rights($anonym, $coll, $folder, $line[0], $READ_RIGHT) ||
			check_obj_rights($log_user, $coll, $folder, $line[0], $READ_RIGHT)))
			continue;
	} else if ($coll) {
		if (! (check_obj_rights($anonym, $coll, $line[0], 0, $READ_RIGHT) ||
			check_obj_rights($log_user, $coll, $line[0], 0, $READ_RIGHT)))
			continue;
	} else if (! (check_obj_rights($anonym, $line[0], 0, 0, $READ_RIGHT) ||
			check_obj_rights($log_user, $line[0], 0, 0, $READ_RIGHT)))
		continue;

	/*
	 * vyber proporci obrazku do img tagu
	 */
#	$element_list .= "\t<tr valign=top align=left>\n";
    $odd_color = "#f9f9ff";
#    $even_color = "#f0f0ff";
#    $even_color = "#e9e9ef";
#    $even_color = "#e0e0ee";
    $even_color = "#e0eeee";
    $style = " style=\"border: #e9e9ef solid 1px;border-left:none;border-right:none;\"";
    $element_list .= "<div class=\"entry\"";
#    if ($even && $coll) $element_list .= $style;
#    $element_list .= $style;
    $element_list .= ">";
    $even= ($even) ? false : true;
	/*
	 * ve slozce se generuji nahledy
	 */
	if ($folder) {
        $element_list .= "<div class=\"check\">";
        if ($can_edit==true) {
//            $element_list .= "<input type=\"submit\" name=\"add_mark[$line[0]]\" value=\"O\">";
//            $element_list .= "<input type=\"checkbox\" disabled ";
            $element_list .= "<input type=\"checkbox\" class=\"check\" ";
            if ($line[3] == '1') $element_list .= "checked ";
            $element_list .= "name=\"vyber[]\" value=\"$line[0]\">\n";
        }
        $element_list .= "</div>";
        $element_list .= "\t\t<div class=\"title\">";
        $GLOBALS["url_prefs"]["photo"] = $line[0];
        $GLOBALS["url_prefs"]["num"] = 2;
        $href = build_href("show_photo.php3", $ref_pref);
        $element_list .= "<a href=\"$href\">";
#        $element_list .= "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$line[0]&num=2$ref_pref\">";
        $element_list .= "$line[1]";
        $element_list .= "</a>";
        if ($log_user != $anonym) {
            $element_list .= " <span class=\"cnt\">[ ";
            $element_list .= "Pstup: " . accessibility($coll, $folder, $line[0]);
            $element_list .= " ]</span>";
        }
        $element_list .= "</div>\n";
        $element_list .= "<table class=\"entry_table\">";
        $element_list .= "\t\t<tr><td class=\"photo_preview\" ";
#        if ($can_edit)
#            $element_list .= " style=\"padding-left: 25px;\"";
        $element_list .= ">\n";

		if ($show_thumbs == 0) {
            $GLOBALS["url_prefs"]["photo"] = $line[0];
            $GLOBALS["url_prefs"]["num"] = 2;
            $href = build_href("show_photo.php3", $ref_pref);
            $element_list .= "<a href=\"$href\">";
#			$element_list .= "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$line[0]&num=2$ref_pref\">";
			$element_list .= "$line[1]</a></div></div><div class=\"photo_title\">\n";
		} else {
			$info_query = "select image.dim_horizontal, image.dim_vertical
										from photo_instance, instance, instance_image, image
										where photo_instance.id_photo=$line[0] and 
										photo_instance.id_instance=instance.id and
										instance.num=3 and 
										instance_image.id_instance=instance.id and
										instance_image.id_image=image.id";
			$info_result = mysql_query($info_query);
			if (! $info_result) die("nelze ziskat info o obrazku");
			$info_line = mysql_fetch_row($info_result);
		
			/*
		 	 * nahled a odkaz
		 	 */
            $width = $info_line[0] + 10;
            $height = $info_line[1] + 10; 
            $element_list .= "\t\t<div class=\"photo_thumb\" style=\"width: ${width}px; height: ${height}px;\">\n";
            $GLOBALS["url_prefs"]["photo"] = $line[0];
            $GLOBALS["url_prefs"]["num"] = 2;
            $href = build_href("show_photo.php3", $ref_pref);
            $element_list .= "<a href=\"$href\">";
#			$element_list .= "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$line[0]&num=2";
#			$element_list .= "$ref_pref\">"; /* predani potrebnych odkazu -- u prihlaseneho uzivatele prazdne */
            $element_list .= "<img src=\"get_img.php3?coll=$coll&folder=$folder&photo=$line[0]&num=3\" width=$info_line[0] height=$info_line[1]></a>";
            $element_list .= "</div>";
		}

    	$element_list .= "<td class=\"note\">$pozn</td>\n";
        $element_list .= "</tr>\n";
        $element_list .= "</table>";
	} 
	/*
	 * pokud nejsme ve slozce, staci seznam
	 */
	else {
		if ($coll) {
			  $element_list .= "\t\t<div class=\"check\">";
            if ($can_edit==true) {
                //$element_list .= "<input type=\"submit\" name=\"add_mark[$line[0]]\" value=\"O\">";
                //$element_list .= "<input type=\"checkbox\" disabled ";
#                $element_list .= "<td>";
                $element_list .= "<input type=\"checkbox\" class=\"check\" ";
                if ($line[3] == '1') $element_list .= "checked ";
                $element_list .= "name=\"vyber[]\" value=\"$line[0]\">\n";
#                $element_list .= "</td>";
            }
			  #$element_list .= "\t\t<td $tnl>";
				// local jumps from navigation
				if ($sort_by == 0) {
                    $str = $line[1];
                    # pridame navesti pro letopocet
                    if (preg_match('/^(\d\d\d\d)/', $str, $match)) {# ||
#                        preg_match('/ (\d\d\d\d)$/', $str, $match)) {
                        $year = (int) $match[1];
                        if ($year > 1900 && $year < 2100) {
    						$element_list .= "<a name=\"$match[1]\" />\n";
                            if (! in_array($match[1], $years))
                                $years[] = $match[1];
                        }
                    }
                    # pridame navesti pro prvni pismeno
                    if ($first_char != strtoupper($str[0])) {
						$first_char = strtoupper($str[0]);
						$element_list .= "<a name=\"$first_char\" />\n";
                        if (! in_array($first_char, $alphabet) && $first_char >= chr(65) && $first_char <= chr(90))
                            $alphabet[] = $first_char;
					}
				}
              $GLOBALS["url_prefs"]["folder"] = $line[0];
              $href = build_href("list_folders.php3", $ref_pref);
              $element_list .= "<a href=\"$href\">";
              $element_list .= "$line[1]</a>";
              $element_list .= " <span class=\"cnt\">[ ";
              $element_list .= " Fotografi: " . count_folders( $line[0], 'folder_photo', 'id_folder' );
              if ($log_user != $anonym)
                  $element_list .= " | Pstup: " . accessibility($coll, $line[0], NULL);
              $element_list .= " ]</span>";
              $element_list .= "</div>\n";
		} else {
			$element_list .= "\t\t<div class=\"title\">";
            $GLOBALS["url_prefs"]["coll"] = $line[0];
            $href = build_href("list_folders.php3", $ref_pref);
            $element_list .= "<a href=\"$href\">";
#            $element_list .= "<a href=\"list_folders.php3?coll=$line[0]$ref_pref\">";
            $element_list .= "$line[1]</a>";
            $element_list .= " <span class=\"cnt\">[ ";
            $element_list .= "Sloek: " . count_folders( $line[0] ) . " | Fotografi: " . count_col_photos( $line[0] );
            if ($log_user != $anonym)
                $element_list .= " | Pstup: " . accessibility($line[0], NULL, NULL);
            $element_list .= " ]</span>";
            $element_list .= "</div>\n";
		}
    	$element_list .= "<div class=\"note\">$pozn</div>\n";
    }
    $element_list .= "</div>";
}
$element_list .= "</div>\n";

?>
