<?php
/* $Id: preview_table.php,v 1.12.2.10 2007/04/10 10:25:50 petr Exp $ */

/*
 * zobrazeni nahledu do tabulky pouze je-li ($folder)
 */

require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("functions.php");
require_once("lib/photo.php");

/*
 * vlastovo pocitadlo :)
 */
$vl_counter=0;

if (! isset($ref_pref)) { /* pokud neni odkazovana promenna nastavena */
	include("get_preferences.php"); /* nacte nastaveni prihl. uzivatele z databaze, anonymnimu nastavi default */
	require_once("set_pref_params.php"); /* obsahuje funkci pro pripravu parametru pro odkaz pro promenne z preferences */
	if ($log_user == $anonym)
		$ref_pref=set_params($show_type_local, $cols_no_local, $sort_by_local, $view_type_local, $show_thumbs_local); /* odkaz. paramatry */
	else $ref_pref="";
}

if ($log_user == $anonym) $ref_pref="&".$ref_pref;
else $ref_pref="";

$element_list .= "<table id=\"photo_list\" name=\"photo_list\" class=\"photo_list\">";
/*
 * pro kazdou polozku v seznamu
 */
while($line = mysql_fetch_row($result)) {
	$rows++;
	/*
	 * pokud ma anonym povoleny pristup pro cteni, pak ho maji zrejme vsichni
	 * jinak je potreba otestovat konkretrni prava uzivatele
	 * pokud by se testovala jen prava uzivatele, pak by kazdy uzivatel musel byt
	 * prirazen alespon ke korenovemu objektu nebo zarazen do skupiny, ktera by
	 * byla prirazena korenovemu objektu
	 */
	if ($folder) {
		if (! (check_obj_rights($anonym, $coll, $folder, $line[0], $READ_RIGHT) ||
			check_obj_rights($log_user, $coll, $folder, $line[0], $READ_RIGHT)))
			continue;
	} else if ($coll) {
		if (! (check_obj_rights($anonym, $coll, $line[0], 0, $READ_RIGHT) ||
			check_obj_rights($log_user, $coll, $line[0], 0, $READ_RIGHT)))
			continue;
	} else if (! (check_obj_rights($anonym, $line[0], 0, 0, $READ_RIGHT) ||
			check_obj_rights($log_user, $line[0], 0, 0, $READ_RIGHT)))
		continue;

	/*
	 * pokud jsme aspon ve slozce, tak se budou generovat nahledy
	 */
	if ($folder) {
		/*
		 * novy radek
		 */
		if ($vl_counter == 0) $element_list .= "<tr>\n";
		/*
		 * ziskani proporci obrazku, pro nastaveni img tagu
		 */
		 if ($show_thumbs != 0) {
             $info_line = getInstanceDim( $line[0], 3 );
		
		/*
		 * vytvoreni nahledu a odkazu, pro anonyma
		 * nutno predavat info o typu zobr. a sloupcich
		 */
			$element_list .= "\n<td class=\"photo_preview\">\n";
            $width = $info_line[0] + 10;
            $height = $info_line[1] + 10;
            $element_list .= "<div class=\"photo_thumb\" style=\"width: ${width}px; height: ${height}px;\">\n";
            $GLOBALS["url_prefs"]["photo"] = $line[0];
            $GLOBALS["url_prefs"]["num"] = 2;
            $href = build_href("show_photo.php3", $ref_pref);
            $element_list .= "<a href=\"$href\">";
#			$element_list .= "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$line[0]&num=2$ref_pref\">";
			$element_list .= "\n<img src=\"get_img.php3?coll=$coll&folder=$folder&photo=$line[0]&num=3\" ";
			$element_list .= "width=\"$info_line[0]\" height=\"$info_line[1]\" /></a>";
            $element_list .= "\n</td>";
#            $element_list .= "<td width=$CELL_SIZE></td>\n";
		}
		/*
		 * uprava promennych pro vytvareni tabulky
		 * zapamtovani si nazvu, ktere se potom vypisi pod jednotlive fotografie
		 */
		$vl_pole0[$vl_counter]=$line[0];
		$vl_pole1[$vl_counter]=$line[1];				
		$vl_counter++;
		
		/*
		 * pokud citac sloucu dosahl maxima udelej novy radek a postupne zobraz popisky
         */
		if ($vl_counter == $cols_no) { //---- Podtabulka pro zarovnani nazvu ----
            $element_list .= "<tr>";
            for ($i=0; $i < $vl_counter; $i++) {
                $element_list .= "<td class=\"photo_desc\">";
                $GLOBALS["url_prefs"]["photo"] = $vl_pole0[$i];
                $GLOBALS["url_prefs"]["num"] = 2;
                $href = build_href("show_photo.php3", $ref_pref);
                $element_list .= "<a href=\"$href\">";
#                "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$vl_pole0[$i]&num=2$ref_pref\">";
                $element_list .= $vl_pole1[$i];
                $element_list .= "</a>";
                $element_list .= "</td>\n";
            }
			$element_list .= "</tr>";
			$vl_counter=0;
		}
	} // konec if ($folder)
} /* konec while cyklu */
if ($vl_counter < $cols_no)
    $element_list .= "</tr>";
$element_list .= "<tr>";
for ($i=0; $i < $vl_counter; $i++) {
    $element_list .= "<td class=\"photo_desc\">";
    if (! $vl_pole1[$i]){
        $element_list .= "</td>\n";
        continue;
    }
    $element_list .= "<a href=\"show_photo.php3?coll=$coll&folder=$folder&photo=$vl_pole0[$i]&num=2$ref_pref\">";
    $element_list .= $vl_pole1[$i];
    $element_list .= "</td>\n";
}
$element_list .= "</tr>";

$element_list .= "</table>\n";
?>
