<?php
require_once("lib/photo.php");
/*
 * vylistuje seznam kolekci, slozek, fotek
 * $like -- vyhledavany podretezec v nazvu(muze byt prazdne)
 * $up_id -- pokud -1 tak vsechny jinak ty co nalezeji do $up a maji $up_id
 * $up -- jmeno nadrazene tabulky (napr. pro photo je to folder
 */
function lst_fold($like, $user_perm, $fold, $name, $up, $up_name, $up_id)
{
	$from = $fold;
	$where = "";

	if ($up_id != -1) {
		$from .= ", $up";
		$where .= "where $up.$up_name=$up_id and $up.$name=$fold.id";
		if ("$like" != "")
			$where .= " and ($fold.title like '%$like%')";
	}

	$query = "select id, title, description, identifier from $from $where";
	$res = mysql_query($query);
	
	return $res;
}

/*
 * funkce prohleda src na vyskyt retezce podle zpusobu zp
 */
function prohledej($src, $retez, $zp)
{
	/*
	 * pokud se nejedna o booleovsky vyraz, tak to zvladne
	 * perlovsky regularni vyraz
	 * !!! pokud prazdnej retezec, tak to vrati 1 !!!
	 */
	if (("$zp" == "0") || ("$zp" == "2")) {
		return preg_match("/$retez/i", $src);
	}
	
	/*
	 * jinak je retez pole retezcu, kde mezi slovy jsou defaultne a
	 * postupne zpracovavame jeden retezec za druhym (mezi polozkami pole
	 * je nebo, takze returneme hned jak je splnen jeden celej retezec
	 */
	 foreach ($retez as $cast) {
	 	$ok = 0;
		$count = 0;
	 	$tok = strtok($cast, " ");
		while($tok) {
			$ok = preg_match("/$tok/i", $src);
			if (! $ok)
				break;

	 		$tok = strtok(" ");

			$count++;
		}
		if ($ok)
			return $ok;
	 }

	 return 0;
}

/*
 * vyhledava v poli $line (pouze v 1., 2. a 3.) retezec $query
 */
function compare($fold, $title, $description, $identifier, $cov_place, $cov_date, $join, $line, $zp)
{
	/*
	 * pokud bude mezi retezci nebo, tak defaultni nalezena hodnota bude 0 (ne) jinak 1 (ano)
	 */
	if ($join == 1) {
		$t = $d = $i = $cp = $cd = 0;
	} else if ($join == 0)
		$t = $d = $i = $cp = $cd = 1;

	/*
	 * prohledame pole
	 */
	if ("$title" != "")
		$t = prohledej($line[1], $title, $zp);
	if ("$description" != "")
		$d = prohledej($line[2], $description, $zp);
	/*
	 * existuji dva identifikatory jeden je shellref a druhy identifier
	 */
	if ("$identifier" != "") {
		$i = prohledej($line[3], $identifier, $zp);
		$id_query = "select shellfref from source, " . $fold . "_source where id_$fold='$line[0]' and id_source=source.id";
		$id_result = mysql_query($id_query);
		if (! $id_result) {
			die("chyba pri shellfref\n");
		}
		while ((! $i) && ($id_line = mysql_fetch_row($id_result))) {
			$i = prohledej($id_line[0], $identifier, $zp);
		}
	}
	/*
	 * prohledani coverage
	 */
	 if (("$cov_place" != "") || ("$cov_date" != "")) {
	 	if ("$cov_place" != "")
			$cp = 0;
		if ("$cov_date" != "")
			$cd = 0;
	 	$cov_query = "select * from coverage, coverage_" . $fold . " where id_$fold='$line[0]' and id_coverage=coverage.id";
		$cov_query = mysql_query($cov_query);
		if (! $cov_query) {
			die("chyba pri cov_query\n");
		}
		while (((! $cp) || (! $cd)) && ($cov_line = mysql_fetch_row($cov_query))) {
			if ((! $cp) && ("$cov_place" != ""))
				$cp = prohledej($cov_line[2], $cov_place, $zp);
			if ((! $cd) && ("$cov_date" != ""))
				$cd = prohledej($cov_line[3], $cov_date, $zp);
		}
	 }

	/*
	 * rozhodnuti na zaklade logickeho a/nebo
	 * o nalezenosti
	 */
	if (($join == 0) && ($t && $d && $i && $cp && $cd))
		return 1;
	else if (($join == 1) && ($t || $d || $i || $cp || $cd))
		return 1;

	/*
	 * jinak reknem, ze jsme nic nenasli
	 */
	return 0;
}

/*
 * zobrazi zadanou kolekci, slozku, fotku
 */
function draw_fold($fold, $query, $line, $coll_par, $fold_par)
{
	global $log_user, $anonym, $show_type, $cols_no, $sort_by, $view_type_local,
	    $show_thumbs_local;
	/*
	 * zacatek seznamu
	 */
	echo "<ul>";
	/*
	 * nastaveni odkazovanych souboru
	 * a pro fotku se bude zobrazovat i nahled
	 */
	if ("$fold" == "photo") {
		$fn = "show_photo.php3";
		echo "<table><tr valign=\"top\" align=\"left\"><td>";
        $odkaz = "$fn?coll=$coll_par&folder=$fold_par&photo=$line[0]&num=2";
		$info_query = "select image.dim_horizontal, image.dim_vertical from photo_instance, instance, instance_image, image where photo_instance.id_photo=$line[0] and photo_instance.id_instance=instance.id and instance.num=3 and instance_image.id_instance=instance.id and instance_image.id_image=image.id";
		$info_result = mysql_query($info_query);
		if (! $info_result)
			die("nelze ziskat info o obrazku");
		$info_line = mysql_fetch_row($info_result);
#		echo "<img src=\"get_img.php3?coll=$coll_par&folder=$fold_par&photo=$line[0]&num=3\" width=$info_line[0] height=$info_line[1]><br>";
        echo photo_render($line[0], 3, $odkaz);
		echo "</td><td>";
	} else {
		$fn = "list_folders.php3";
	}

	/*
	 * nastaveni predavanych parametru
	 */
	if ($fold == "collection")
		$param = "coll=$line[0]";
	else if ($fold == "folder")
		$param = "coll=$coll_par&folder=$line[0]";
	else
		$param = "coll=$coll_par&folder=$fold_par&photo=$line[0]&num=2";

	/* predani parametru u anonymniho uzivatele */
	$retez="";
	if ($log_user == $anonym)
	    $retez .= "&" . set_params($show_type, $cols_no, $sort_by, 
			$view_type_local, $show_thumbs_local);
			
		
		
	/*
	 * vytvoreni odkazu na predem nastaveny soubor
	 */
	echo "<A href=\"$fn?$param$retez\">";

	/*
	 * pokud se tam nekde v textu zobrazuje hledany text, tak ho zvyraznime
	 */
	$paterns = array("/(" . preg_quote($query, "/") . ")/i");
	$replace = array("<b>\\1</b>");
	print preg_replace ($paterns, $replace, $line[1]);
	echo "</a><br>\n";
	/*
	 * pro fotku ukoncime tabulku
	 */
	if ($fold == "photo")
		echo "</td></tr></table>";
}

function prepare_search_query(&$q, $zp)
{
	/*
	 * pokud se ma retezec brat jako regularni vyraz
	 */
	if ("$zp" == "2") {
		$q = preg_replace("/\\//", "\\\\/", $q);

		/* defaultne mam v php.ini z bezpecnostnich duvodu
		 * nastaveno kvotovani vstupu. zde je potreba
		 * odkvotovat \
		 * \\ jsou potreba aby proslo \ pres php parser
		 * dalsi \\ jsou potreba aby se to ve funkci
		 * jevilo jako zadana \\ coz v reg vyrazu znamena jedno \
		 * takze na jedno lomitko jsou potreba ctyri :) */
		$q = preg_replace("/\\\\\\\\/", "\\\\", $q);
	} else if ("$zp" == "1") {
		/*
		 * pokud je to booleovskej vyraz
		 */
		$q = preg_quote($q, "/");
		$q = explode("\\|", $q);
	} else {
		/*
		 * jinak staci oquotovat jenom ukoncovaci znak
		 */
		$q = preg_quote($q, "/");
	}
}

/*
 * $coll -- id kolekce
 * $srch_coll -- pole idecek kolekci zadanych ve vyhledavacim formulari (0 == vse)
 */
function coll_is_in($coll, $srch_coll)
{
	if (! $coll || ! $srch_coll) return 0;

	foreach ($srch_coll as $c) {
		if (($c==$coll) || ($c==0)) return 1;
	}

	return 0;
}


/*
 * $srch_coll -- pole prohledavanych kolekci (kolekce 0==vse)
 * $query -- vyhledavany retezec
 * $user_perm -- pristup prava
 * $join -- logicka spojka mezi polozkami
 */
function search($srch_coll, $title, $description, $identifier, $cov_place, $cov_date, $join, $user_perm, $zp)
{
	global $anonym, $log_user, $READ_RIGHT;

	$nalezeno = 0;

	/*
	 * prvne proverime seznam kolekci na ktere ma uzivatele pravu
	 */
	if (! ($coll_res = lst_fold("", $user_perm, "collections", "", "", "", -1)))
		die("chyba pri hledani kolekci");

	/*
	 * upravime promenne tak, abychom je pak mohli uz jenom predhodit vyhledavaci funkci
	 */
	prepare_search_query($title, $zp);
	prepare_search_query($description, $zp);
	prepare_search_query($identifier, $zp);
	prepare_search_query($cov_place, $zp);
	prepare_search_query($cov_date, $zp);

	/*
	 * testujeme jednotlive vsechny kolekce
	 */
	while ($coll_line = mysql_fetch_row($coll_res)) {
		$coll_visible = 0;	/* kolekce nebude defaultne zobrazena */
		/*
		 * pokud na tuto kolekci nema uzivatel pravo, tak ji preskocime
		 */
		if (! (check_obj_rights($anonym, $coll_line[0], 0, 0, $READ_RIGHT) ||
			check_obj_rights($log_user, $coll_line[0], 0, 0, $READ_RIGHT))
			|| ! coll_is_in($coll_line[0], $srch_coll)) {
			continue;
		}
		/*
		 * zjisime jestli nejaka polozka v kolekci neobsahuje hledany retezec
		 */
		$show_coll = compare("collection", $title, $description, $identifier, $cov_place, $cov_date, $join, $coll_line, $zp);
		if ($show_coll) {
			/*
			 * pokud ano, tak ji zobrazime
			 */
			draw_fold("collection", $title, $coll_line, -1, -1);
			$coll_visible = 1;
		}
		/*
		 * vytvorime seznam kolekci v dane slozce
		 */
		if (! ($fold_res = lst_fold("", $user_perm, "folders", "id_folder", "collection_folder", "id_collection", $coll_line[0])))
			die("chyba pri hledani slozek");
		/*
		 * postupne pro vsechny slozky
		 */
		while ($fold_line = mysql_fetch_row($fold_res)) {
			$fold_visible=0;
			/*
			 * kontrola prav
			 */
			if (! (check_obj_rights($anonym, $coll_line[0], $fold_line[0], 0, $READ_RIGHT) ||
				check_obj_rights($log_user, $coll_line[0], $fold_line[0], 0, $READ_RIGHT))) {
				continue;
			}
			/*
			 * pokud slozka odpovida, tak ji zobrazime
			 */
			$show_fold = compare("folder", $title, $description, $identifier, $cov_place, $cov_date, $join, $fold_line, $zp);
			if ($show_fold) {
				/*
				 * pokud jeste nebyla zobrazena kolekce, tak ji ted zobrazime
				 */
				if (! $coll_visible) {
					draw_fold("collection", $title, $coll_line, -1, -1);
					$coll_visible = 1;
				}
				draw_fold("folder", $title, $fold_line, $coll_line[0], -1);
				$fold_visible = 1;
			}

			/*
			 * pro vsechny fotky ve slozce
			 */
			if (! ($photo_res = lst_fold("", $user_perm, "photos", "id_photo", "folder_photo", "id_folder", $fold_line[0])))
				die("chyba pri hledani fotek");
			while ($photo_line = mysql_fetch_row($photo_res)) {
				$photo_visible=0;
				/*
				 * zkontrolujem prava
				 */
				if (! (check_obj_rights($anonym, $coll_line[0], $fold_line[0], $photo_line[0], $READ_RIGHT) ||
					check_obj_rights($log_user, $coll_line[0], $fold_line[0], $photo_line[0], $READ_RIGHT)))
					continue;
				/*
				 * pokud odpovida hledanemu, tak ji zobrazime a spolu s ni vsechny
				 * nezobrazene rodice
				 */
				$show_photo = compare("photo", $title, $description, $identifier, $cov_place, $cov_date, $join, $photo_line, $zp);
				if ($show_photo) {
					if (! $coll_visible) {
						draw_fold("collection", $title, $coll_line, -1, -1);
						$coll_visible = 1;
					}
					if (! $fold_visible) {
						draw_fold("folder", $title, $fold_line, $coll_line[0], -1);
						$fold_visible = 1;
					}
					draw_fold("photo", $title, $photo_line, $coll_line[0], $fold_line[0]);
					$photo_visible = 1;
				}
				/*
				 * ukonceni seznamu fotek
				 */
				if ($photo_visible) {
					echo "</ul>";
					$nalezeno = 1;
				}
			}
			/*
			 * ukonceni seznamu slozek
			 */
			if ($fold_visible) {
				echo "\t</ul><br><br>\n";
				$nalezeno = 1;
			}
		}
		/*
		 * ukonceni seznamu kolekci
		 */
		if ($coll_visible) {
			echo "</ul>";
			$nalezeno = 1;
		}
	}

	return $nalezeno;
}
?>
