<?php
/* $Id: configure.php,v 1.7.2.6 2007/04/10 10:42:38 krejvl Exp $ */

/*
 * utilitka, ktera vytvori adresar img a nastavi prava pro apache
 * dale vytvori soubor log_ins_photo.log a nastavi prava pro apache
 * dale soubory cfg.php a pconnect_db.php3
 */

/*
 * otevreni standardniho vstupu
 */
$STDIN = fopen("php://stdin", "r");

echo "Chcete vytvorit adresar img a soubor log_ins_photo.log (A/N)?\n";
$odpoved = trim(fgets($STDIN, 5));
if ($odpoved == "A" || $odpoved == "a") {
	echo "zadejte skupinu pod kterou bezi webovy server: ";
	$HTTP_GRP=addslashes(trim(fgets($STDIN, 4096)));

	mkdir("img", 0770);
	chgrp("img", "$HTTP_GRP");
	$f = fopen("log_ins_photo.log", "w");
	fclose($f);
	chgrp("log_ins_photo.log", "$HTTP_GRP");
	chmod("log_ins_photo.log", 0660);
}


echo "Chcete vytvorit konfiguracni soubor (A/N)?\n";
$odpoved = trim(fgets($STDIN, 5));
if ($odpoved == "A" || $odpoved == "a") {
	/*
	 * nacteni konfiguracnich udaju
	 */
	echo "zadejte HTTP url (kde pobezi server -- obvykle FQDN http://...): ";
	$MY_HTTP_ROOT=addslashes(trim(fgets($STDIN, 4096)));
	
	echo "zadejte HTTPS url (FQDN): ";
	$MY_HTTPS_ROOT=addslashes(trim(fgets($STDIN, 4096)));

	if (! isset($HTTP_GRP)) {
		echo "zadejte skupinu, pod kterou bezi Apache: ";
		$HTTP_GRP=addslashes(trim(fgets($STDIN, 4096)));
	}
		
	echo "zadejte defaultni email pro odesilani: ";
	$DEFAULT_MAIL=addslashes(trim(fgets($STDIN, 4096)));
	
	echo "zadejte cestu k programu convert: ";
	$CONVERT_PATH=addslashes(trim(fgets($STDIN, 4096)));

	echo "zadejte kvalitu JPEGu: ";
	$QUALITY=addslashes(trim(fgets($STDIN, 4096)));

	echo "zadejte cestu k programu identify: ";
	$IDENTIFY_PATH=addslashes(trim(fgets($STDIN, 4096)));
	
	echo "zadejte cestu k programu php: ";
	$PHP_PATH=addslashes(trim(fgets($STDIN, 4096)));
	
	echo "zadejte cestu k programu nice: ";
	$NICE_PATH=addslashes(trim(fgets($STDIN, 4096)));
	
	/*
	 * formatovany zapis konfigurace do souboru cfg.php
	 */
	$cfg = fopen("cfg.php", "w");
	fwrite($cfg, "<?php\n/*\n * konfigurace systemu\n */\n\n");
	fwrite($cfg, "/*\n * hlavni stranka systemu\n */\n");
	fwrite($cfg, "\$MY_HTTP_ROOT=\"$MY_HTTP_ROOT\";\n\n");
	fwrite($cfg, "/*\n * hlavni stranka systemu se sifrovanym protokolem\n */\n");
	fwrite($cfg, "\$MY_HTTPS_ROOT=\"$MY_HTTPS_ROOT\";\n\n");
	fwrite($cfg, "\$HTTP_GRP=\"$HTTP_GRP\";\n\n");
	fwrite($cfg, "/*\n * cesta ke konverznimu programu convert\n */\n");
	fwrite($cfg, "\$CONVERT_PATH=\"$CONVERT_PATH\";\n\n");
	fwrite($cfg, "\$QUALITY=\"$QUALITY\";\n\n");
	fwrite($cfg, "\$IDENTIFY_PATH=\"$IDENTIFY_PATH\";\n\n");
	fwrite($cfg, "\$PHP_PATH=\"$PHP_PATH\";\n\n");
	fwrite($cfg, "\$NICE_PATH=\"$NICE_PATH\";\n\n");
	fwrite($cfg, "\$DEAFULT_MAIL=\"$DEFAULT_MAIL\";\n");
    fwrite($cfg, "\$STYLE=\"styles/default\";\n");
    fwrite($cfg, "?>\n");
	fclose($cfg);
}	

echo "Chcete nakonfigurovat pripojeni k databazi (A/N)?\n";
$odpoved = trim(fgets($STDIN, 5));
if ($odpoved == "A" || $odpoved == "a") {
	/*
	 * nacteni udaju pro pripojeni k databazi
	 */
	echo "zadejte adresu SQL serveru (domenove jmeno pocitace): ";
	$DB_LOCATION=addslashes(trim(fgets($STDIN, 1024)));
	
	echo "zadejte jmeno uzivatele databaze: ";
	$DB_USER=addslashes(trim(fgets($STDIN, 80)));
	
	echo "zadejte heslo uzivatele v databazi: ";
	$DB_PASSWD=addslashes(trim(fgets($STDIN, 80)));
	
	echo "zadejte nazev databaze (napr. dkf): ";
	$DB_NAME=addslashes(trim(fgets($STDIN, 80)));
	/*
	 * formatovany zapis udaju do souboru pconnect_db.php3
	 */
	$db = fopen("pconnect_db.php3", "w");
	fwrite($db, "<?php\n/*\n * soubor zajistuje navazani pernamentniho spojeni s databazi,\n");
	fwrite($db, " * pokud uz takove existuje, tak vrati spravny id\n */\n\n");
	fwrite($db, "/*\n * pripojeni k databazovemu serveru\n */\n");
	fwrite($db, "\$db_link = mysql_pconnect(\"$DB_LOCATION\", \"$DB_USER\", \"$DB_PASSWD\") ||\n");
	fwrite($db, "\tdie(\"nelze navazat spojeni s databazi\");\n\n");
	fwrite($db, "/*\n * vyber databaze\n */\n");
	fwrite($db, "mysql_select_db(\"$DB_NAME\") ||\n");
	fwrite($db, "\tdie(\"spatna databaze\");\n?>\n");
    fwrite($db, "mysql_query(\"SET SESSION character_set_results = 'latin2'\")\n");
    fwrite($db, "mysql_query(\"SET SESSION character_set_client = 'latin2'\")\n");
    fwrite($db, "mysql_query(\"SET SESSION character_set_connection = 'latin2'\")");

	fclose($db);
}


function pridej_uzivatele($name, $passwd, $email, $location, $dbuser, $dbpasswd, $dbname, $access)
{
	$db_link = mysql_pconnect($location, $dbuser, $dbpasswd);
	if (! $db_link) die("nelze navazat spojeni s databazi\n");
	mysql_select_db($dbname) || die("spatna databaze\n");

	$query = "insert into users values (0, '$name', $access, MD5('$passwd'), '$email')";
	$result = mysql_query($query);
	if (! $result) die("nepodarilo se pridat uzivatele $name\n");

	$query = "select id from users where nickname='$name'";
	$result = mysql_query($query);
	if (! $result) die("nepodarilo se ziskat id uzivatele $name\n");
	$line = mysql_fetch_row($result);

	$query = "insert into preferences values('$line[0]', '0', '3', '0', '0', '1')";
	$result = mysql_query($query);
	if (! $result) die("nepodarilo se pridat defaultni nastaveni pro uzivatele $name\n");
}
	


echo "Chcete vytvorit prvniho uzivatele (A/N)?\n";
$odpoved = trim(fgets($STDIN, 5));
if ($odpoved == "A" || $odpoved == "a") {
	echo "zadejte jmeno (login) uzivatele systemu DKF: ";
	$FIRST_USER_LOGIN=mysql_escape_string(trim(fgets($STDIN, 21)));

	echo "zadejte heslo pro uzivatele $FIRST_USER_LOGIN: ";
	$FIRST_USER_PASSWORD=mysql_escape_string(trim(fgets($STDIN, 4096)));

	echo "zadejte email pro uzivatele $FIRST_USER_LOGIN: ";
	$FIRST_USER_EMAIL=mysql_escape_string(trim(fgets($STDIN, 255)));

	if (! isset($DB_LOCATION)) {
	echo"zadejte adresu SQL serveru (domenove jmeno pocitace): ";
	$DB_LOCATION=addslashes(trim(fgets($STDIN, 1024)));
	}

	if (! isset($DB_USER)) {
	echo "zadejte jmeno uzivatele databaze: ";
	$DB_USER=addslashes(trim(fgets($STDIN, 80)));
	}

	if (! isset($DB_PASSWD)) {
	echo "zadejte heslo uzivatele v databazi: ";
	$DB_PASSWD=addslashes(trim(fgets($STDIN, 80)));
	}
	
	if (! isset($DB_NAME)) {
	echo "zadejte nazev databaze (napr. dkf): ";
	$DB_NAME=addslashes(trim(fgets($STDIN, 80)));
	}
	
	pridej_uzivatele($FIRST_USER_LOGIN, $FIRST_USER_PASSWORD,
			 $FIRST_USER_EMAIL,
			 $DB_LOCATION, $DB_USER, $DB_PASSWD, $DB_NAME,
			 4);

	/* prida tez anonymniho uzivatele s nahodnym heslem */
	$r1 = rand();
	$r2 = rand();
	pridej_uzivatele('anonym', '$r1$r2', '',
			 $DB_LOCATION, $DB_USER, $DB_PASSWD, $DB_NAME,
		 	 1);
}


/*
 * uzavreni standardniho vstupu
 */
fclose($STDIN);
?>
