<?php
require_once('../cfg.php');

function convert($src, $trg, $len, $quality=0)
{
    global $QUALITY;

	if (! file_exists($src))
		return false;

    if ($quality == 0)
        $quality = $QUALITY;

	$size = getimagesize($src);
	$ratio = (double)$size[0]/(double)$size[1];
	if ($ratio > 1.0) {
		$x = $len;
	} else {
		$x = (int)($len*$ratio);
	}
	$ex_cmd = "/usr/bin/convert $src -geometry {$len}x{$len} -strip -quality $quality -unsharp 1x1.5+0.5 $trg";
	echo $ex_cmd . "\n";
	exec($ex_cmd);
	chmod($trg, 0664);

	return true;
}

?>
