<?php
require_once("../pconnect_db.php3");


function gen_prev($num, $scale, $identifier, $file, $res, $photo_id)
{

	$QUALITY = 75;
	/*
	 * ziskani zakladnich info o obrazku
	 */ 
	$size = getimagesize($file);
	if (! $size)
		return 0;
	/*
	 * nastaveni barevnosti obrazku
	 * (vsecny nahledy jsou v jpegu, takze RGB)
	 */
	 $bits=24;
	 $color_space="RGB";

	/*
	 * uprava identifikatoru
	 */
	$qfile = escapeshellarg($file);
	$ofile = "$identifier.$num.jpg";
	$qofile = escapeshellarg($ofile);
	/*
	 * pokud je obrazek sirsi nez delsi, tak muzes pouzit
	 * neupravenou hodnotu, jinak ji uprav o pomer stran
	 */
	$ratio = (double)$size[0]/(double)$size[1];
	if ($ratio > 1.0) {
		$x = $scale;
	} else {
		$x = (int)($scale*$ratio);
	}
	$ex_cmd = "convert $qfile -geometry $x -colorspace RGB -quality $QUALITY -unsharp 1x1.5+0.5 $qofile";
	/*
	 * spustime prikaz ke konvertovani
	 */
	$ex=exec($ex_cmd);
	/*
	 * ziskani infa o vygenerovanym obr a zaroven test ze se to povedlo
	 */
	$size = getimagesize("$ofile");
	if (!$size)
		die("neni soubor");
	/*
	 * nastaveni velikosti souboru, md5sum a pridani do databaze
	 */
	$fsize = filesize("$ofile");
	$msum = substr(`/usr/bin/md5sum $qofile`, 0, 32);
	$insert_instance = "insert into instance values(
		0, $num, 'image/jpeg', '$fsize',
		'$ofile', '$msum')";
	$result = mysql_query($insert_instance);
	if (! $result)
		die("error: $file -> $ofile");
	/*
	 * zjisteni id naposled vlozenyho
	 */
	$result = mysql_query("select max(id) from instance where check_sum='$msum'");
	$instance_line = mysql_fetch_row($result);

	$file = $ofile;
	$qfile = $qofile;
	/*
	 * propojeni fotky s instanci
	 */
	$result = mysql_query("insert into photo_instance values(
			$photo_id, $instance_line[0])");
	$ratio = (double)$size[0]/(double)$size[1];
	if ($size[0] > $size[1])
		$orient = 0;
	else
		$orient = 1;
	if (!isset($res))
		$res=600;
	/*
	 * pridani infa o obrazku
	 */
	$result = mysql_query("insert into image values(
				0, $orient, $res, $size[0], $size[1],
				'JPEG:$QUALITY', '$bits', '$color_space')");
	if (!$result)
		die("nejde pridat image");
	/*
	 * propojeni instance s obrazkem
	 */
	$result = mysql_query("select max(id) from image where dim_horizontal='$size[0]' and dim_vertical='$size[1]' and bit_depth='$bits'");
	$img_line = mysql_fetch_row($result);
	$result = mysql_query("insert into instance_image values(
		$instance_line[0], $img_line[0])");
}

if ($argc != 3) { die("create_instance.php <orig_inst_id> <inst_type>\n"); }

$instance_id = $argv[1];
$instance_type = $argv[2];

if ($instance_type < 1 && $instance_type > 3) die("<inst_type> must be 1, 2 or 3\n");

$query = "select id_image from instance_image where id_instance = '$instance_id'";
$result = mysql_query($query);
if (! $result) die("Chyba - $query\n");
$row = mysql_fetch_row($result);
if (mysql_num_rows($result) != 1) die ("Chyba poctu != 1");
$query = "select resolution from image where id = '$row[0]'";
$result = mysql_query($query);
if (! $result) die("Chyba - $query\n");
$row = mysql_fetch_row($result);
if (mysql_num_rows($result) != 1) die ("Chyba poctu rozliseni != 1");
$res = $row[0];

$query = "select id_photo from photo_instance where id_instance = '$instance_id'";
$result = mysql_query($query);
if (! $result) die("Chyba - $query\n");
$row = mysql_fetch_row($result);
if (mysql_num_rows($result) != 1) die ("Chyba2 poctu != 1");
$query = "select id, identifier from photos where id = '$row[0]'";
$result = mysql_query($query);
if (! $result) die("Chyba - $query\n");
$row = mysql_fetch_row($result);
if (mysql_num_rows($result) != 1) die ("Chyba2 poctu id != 1");
$photo_id = $row[0];
$identifier = $row[1];


$query = "select file_name from instance where id = '$instance_id'";
$result = mysql_query($query);
if (! $result) die("Chyba - $query\n");
$row = mysql_fetch_row($result);
if (mysql_num_rows($result) != 1) die ("Chyba poctu instance != 1");
$file = $row[0];


$scale = Array(1024, 640, 160);

echo "gen_prev(".$instance_type.", ".$scale[$instance_type-1].", $identifier, \"../../img/$file\", $res, $photo_id);\n";

gen_prev($instance_type, $scale[$instance_type-1], $identifier, "../../img/$file", $res, $photo_id);

?>
