<?php
/* $Id: export_sofsem.php,v 1.2 2004/04/29 14:36:47 petr Exp $ */
/* 
 * Skript vyexportuje zadanou kolekci do XML
 */
require ("../pconnect_db.php3");

$dkf_all = NULL;
$dkf_all_counter = 0;

$stdin = fopen("php://stdin", "r");
$dirname = "";

$ENCODING="UTF-8";

class foldTree {
	var $_table;
	var $_score;

	var $parent;
	var $childern;
	var $sorted;

	var $id;
	var $title;
	var $description;
	var $identifier;
	var $cdate;
	var $cplace;

	function foldTree($t, $i)
	{
		global $dkf_all, $dkf_all_counter;
		
		$this->_table = $t;
		$this->_score = 0;

		$this->parent = NULL;
		$this->childern = NULL;
		$this->sorted = NULL;

		$this->id = $i;
		$this->title = "";
		$this->description = "";
		$this->identifier = "";
		$this->cdate = "";
		$this->cplace = "";

		$dkf_all[] =& $this;
		$dkf_all_counter++;
	}
	
	function add (&$child)
	{
		$child->parent = & $this;
		$this->childern[] = & $child;
	}

	function update ()
	{
		if ($this->_table) {
			$query = "select title, description, identifier from " . $this->_table . "s where id=$this->id";
			$result = mysql_query($query);
			if (! $result)
				die("nezdaril se dotaz do databaze: $this->_table:$this->id");
			$line = mysql_fetch_row($result);
			$this->title = $line[0];
			$this->description = $line[1];
			$this->identifier = $line[2];

			$cquery = "select coverage.* from coverage_$this->_table, coverage where coverage_$this->_table.id_$this->_table='$this->id' and coverage_$this->_table.id_coverage=coverage.id";
			$cresult = mysql_query($cquery);
			if (! $cresult) {
				return 0;
			}
			if (mysql_num_rows($cresult) > 0) {
				$cline = mysql_fetch_row($cresult);
				$this->cdate = $cline[3];
				$this->cplace = $cline[2];
			}
		}
		if (! $this->childern)
			return;
		foreach ($this->childern as $key => $child) {
			$this->childern[$key]->update();
		}
	}

	function export_xml ($prev, $next, $output)
	{
		global $dirname, $ENCODING;
		$out = $output;

		if ($this->_table == "folder") {
			$fname = preg_replace("/\//","--", $this->title);
			$out = fopen("$dirname/" . $fname . ".xml", "w");
			if (! $out) {
				die("Nelze otevrit soubor $dirname/" . $fname . ".xml\n");
			}
			fputs($out,'<?xml version="1.0" encoding="' . $ENCODING . '"?>' . "\n");
#			fputs($out,'<!DOCTYPE sofsem PUBLIC "-//UVT MU//DTD Sofsemy 0.1//EN" "sofsemy.dtd">' . "\n");

			$retez = "<sofsem id=\"" . htmlspecialchars($this->identifier) . "\"";
			if ("$prev" != "")
				$retez .= " pred=\"" . htmlspecialchars($prev) . "\"";
			if ("$next" != "")
				$retez .= " nasl=\"" . htmlspecialchars($next) . "\"";
			$retez .= ">\n";
			fputs($out, $retez);
			fputs($out, "\t<nazev>" . htmlspecialchars($this->title) . "</nazev>\n");
			if ("$this->description" != "")
				fputs($out, 	"\t<popis>" .
						htmlspecialchars($this->description) .
						"</popis>\n");
			if ("$this->cdate" != "")
				fputs($out, 	"\t<datum>" .
						htmlspecialchars($this->cdate) .
						"</datum>\n");
			if ("$this->cplace" != "")
				fputs($out, 	"\t<misto>" .
						htmlspecialchars($this->cplace) .
						"</misto>\n");
			$prevch = "";
			$act = "";
			foreach ($this->childern as $key => $child) {
				if ("$act" == "")
					$act = $key;
				else {
					$chp = ("$prevch" == "") ?
						"" :
						$this->childern["$prevch"]->identifier;
					$this->childern["$act"]->export_xml($chp,
								$this->childern["$key"]->identifier, $out);
					$prevch = $act;
					$act = $key;
				}
			}
			if ("$act" != "")
				$this->childern["$act"]->export_xml(
						$this->childern["$prevch"]->identifier,
						"", $out);

			fputs($out, "</sofsem>\n");
			fclose($out);
		} elseif ($this->_table == "photo") {
			$retez = "\t<fotka id=\"" . htmlspecialchars("$this->identifier") . "\"";
			if ("$prev" != "")
				$retez .= " pred=\"" . htmlspecialchars($prev) . "\"";
			if ("$next" != "")
				$retez .= " nasl=\"" . htmlspecialchars($next) . "\"";
			$retez .= ">\n";
			fputs($out, $retez);
			fputs($out,	"\t\t<nazev>" .
				htmlspecialchars(
					preg_replace("/^(\\d\\d) (.*)/", "\\2", $this->title)
				) .
				"</nazev>\n");
			if ("$this->description" != "")
				fputs($out,	"\t\t<popis>" .
						htmlspecialchars($this->description) .
						"</popis>\n");

			$iquery = "select instance.* from photo_instance, instance where id_photo=$this->id and id_instance=instance.id order by instance.num";
			$ires = mysql_query($iquery);
			while ($iline = mysql_fetch_row($ires)) {
				if ($iline[1] == 0)
					continue;
				$ipred = "";
				$inasl = "";
				if ($iline[1] > 1) {
					$pom = $iline[1] - 1;
					$inasl = "$this->identifier.$pom";
				}
				if ($iline[1] < 3) {
					$pom = $iline[1] + 1;
					$ipred = "$this->identifier.$pom";
				}
				fputs($out,	"\t\t<instance id=\"" .
						htmlspecialchars("$this->identifier.$iline[1]") . "\"");
				if ("$ipred" != "")
					fputs($out,	" pred=\"" . htmlspecialchars("$ipred") . "\"");
				if ("$inasl" != "")
					fputs($out,	" nasl=\"" . htmlspecialchars("$inasl") . "\"");
				fputs($out, ">\n");
				fputs($out, "\t\t\t<soubor>$iline[4]</soubor>\n");


				$imquery = "select image.* from instance_image, image where id_instance=$iline[0] and id_image=image.id";
				$imres = mysql_query($imquery);
				$imline = mysql_fetch_row($imres);
				fputs($out, "\t\t\t<horiz>$imline[3]</horiz>\n");
				fputs($out, "\t\t\t<vert>$imline[4]</vert>\n");
				fputs($out, "\t\t</instance>\n");
			}
			
			fputs($out, "\t</fotka>\n");
		}
	}

	function export ()
	{
		global $stdin, $dirname, $ENCODING;

		echo "zadejte jmeno vystupniho adresare: ";
		$dirname = trim(fgets($stdin, 4096));
		mkdir($dirname);
		$outname = "$dirname/$dirname.xml";
		$out = fopen($outname, "w");

		fputs($out,'<?xml version="1.0" encoding="' . $ENCODING . '"?>' . "\n");
		fputs($out,'<!DOCTYPE sofsemy PUBLIC "-//UVT MU//DTD Sofsemy 0.1//EN" "sofsemy.dtd" [' . "\n");
		foreach ($this->childern as $key => $child) {
			fputs($out, "\t" . '<!ENTITY s' . $key . ' SYSTEM "' . $this->childern["$key"]->title . '.xml">' . "\n");
		}
		fputs($out, "]>\n");
		fputs($out,"<sofsemy>\n");

		$prev = "";
		$act = "";
		foreach ($this->childern as $key => $child) {
			if ("$act" == "")
				$act = $key;
			else {
				$chp = ("$prev" == "") ?
					"" :
					$this->childern["$prev"]->identifier;
				$this->childern["$act"]->export_xml(
							$chp,
							$this->childern["$key"]->identifier, NULL);
				fputs($out, "\t&s$key;\n");
				$prev = $act;
				$act = $key;
			}
		}
		if ("$act" != "") {
			$this->childern["$act"]->export_xml($this->childern["$prev"]->identifier, "", NULL);
		}

		fputs($out,"</sofsemy>\n");
		fclose($out);
	}

	function _show_tree()
	{
		echo "<ul>\n";
		echo "<li>$this->_table:$this->id:$this->title:$this->description:$this->identifier";
		if ($this->childern) {
			foreach($this->childern as $child) {
				$child->_show_tree();
			}
		}
		echo "</ul>\n";
	}
}

$dkf = new foldTree("", 0);



echo "zadejte nazev kolekce: ";
$nazev = trim(fgets($stdin, 4096));


$ne = NULL;
$ne_slozka = "";
do {
	echo "zadejte jmeno slozky, ktera tam nema byt: ";
	$ne_slozka = trim(fgets($stdin, 4096));
	if ("$ne_slozka" != "")
		$ne[] = $ne_slozka;
} while ("$ne_slozka" != "");

/*
 * vyber slozek
 */
$fquery = "select folders.* from collections, collection_folder, folders where collections.title like '$nazev' and collections.id=collection_folder.id_collection and collection_folder.id_folder=folders.id order by folders.title";

$fres = mysql_query($fquery);
if ((! $fres) || (mysql_num_rows($fres) == 0))
	die ("Zadna kolekce obsahujici '$nazev' nenalezena\n");

/*
 * zpracovani slozek
 */
while ($fline = mysql_fetch_row($fres)) {
	/*
	 * predzpracovani nazvu
	 */
	$cycle_end=0;
	if (isset($ne)) {
		foreach ($ne as $ne_slozka) {
			if (strcasecmp($ne_slozka, $fline[4]) == 0) {
				$cycle_end=1;
				break;
			}
		 }
	}
	echo $fline[4] . "\n";
	if ($cycle_end)
		continue;
	$obj = & new foldTree("folder", $fline[0]);
	$dkf->add(&$obj);

	/*
	 * vyber fotek ve slozce
	 */
	$pquery = "select photos.* from folder_photo,photos where folder_photo.id_folder='$fline[0]' and photos.id=folder_photo.id_photo order by photos.title";
	$pres = mysql_query($pquery);
	if ((! $pres) || (mysql_num_rows($fres) <= 0))
		echo "pro slozku $fline[0] nejsou fotky\n";
	
	/*
	 * zpracovani fotek
	 */
	while ($pline = mysql_fetch_row($pres)) {
		$phot = & new foldTree("photo", $pline[0]);
		$obj->add(&$phot);
	}
}

$dkf->update();
$dkf->export();
#$dkf->_show_tree();

fclose($stdin);
?>
