#!/bin/bash

DIR=$1
PRF=$2
DST=$3

BIG=480
MID=120
SMA=90

if ! [ -z "$4" ]; then
    BIG=$4
fi

if ! [ -z "$5" ]; then
    MID=$5
fi

if ! [ -z "$6" ]; then
    SMA=$6
fi

function do_convert() {
  src=$1
  geom=$2
  q=$3
  dst=$4

#  if ! [ -e $4 ]; then
  echo convert $src -geometry ${geom}x${geom} -strip -quality $q -unsharp 1x1.5+0.5 $dst
  convert $src -geometry ${geom}x${geom} -strip -quality $q -unsharp 1x1.5+0.5 $dst
#  fi
}

for i in ${DIR}/${PRF}*.0.*; do
  base=`basename $i | sed 's/.\....$//'`
  fname=`ls ${DIR}/${base}4.* 2> /dev/null`
  change_file=${DST}/.changes
  touch $change_file

  if ! [ -e "$fname" ]; then
    fname=$i
  fi

#  str=`ls -l "$fname" | cut -d ' ' -f 5- -`
  str=`find "$fname" -type f -printf "%s %CY-%Cm-%Cd %CH:%CM %f\n"`

	#echo $fname
	#echo "grep '$str' $change_file"
  cmd="grep '$str' $change_file"
  x=`eval $cmd`
  if [ -z "$x" ]; then
    echo $str
    echo $cmd
    echo $fname
    do_convert $fname $BIG 95 ${DST}/${base}2.jpg
    do_convert ${DST}/${base}2.jpg $MID 95 ${DST}/${base}33.jpg
    do_convert ${DST}/${base}2.jpg $SMA 95 ${DST}/${base}3.jpg
    echo $str >> $change_file
#	else 
		#echo $fname - already generated
  fi
done
